TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

Type EnemyDataLoc
 frameoffset as long
 framebytes as integer
 clipoffset as long
 clipbytes as integer
 gfxoffset as long
 gfxroffset as long
 gfxbytes as long
end type

TYPE AniData
 framesize AS INTEGER
 clipsize AS INTEGER
 gfxsize AS INTEGER
 gfxlowoffset as integer
 gfxhighbytes as integer
END TYPE

TYPE AniFrame
 offset AS integer
 x AS INTEGER
 y AS INTEGER
 w AS INTEGER
 h AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE EnemyType
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 edata AS STRING * 8
 x AS INTEGER
 y AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lastscalex AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 dxo AS INTEGER
 dyo AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 speed AS INTEGER
 yforce AS INTEGER
 fliph AS INTEGER
 tmrstun AS INTEGER
 maxstun AS INTEGER
 ani AS Animator
 hitbox AS Rect
 hurtbox AS Rect
 autohurtbox AS INTEGER
 autohitbox AS INTEGER
 bossmode AS INTEGER
 maxhp AS INTEGER
 hp AS INTEGER
 tmr0 AS TTmr
 tmr1 AS TTmr
 tmr2 AS TTmr
 tmr3 AS TTmr
 tmr4 AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 noclear AS INTEGER
 immortal AS INTEGER
 immaterial AS INTEGER
 index AS INTEGER
 scalex AS INTEGER
 tilehit AS INTEGER
 solidhit AS INTEGER
 redraw AS INTEGER
 dmg AS INTEGER
 immunewhip AS INTEGER
 immunesub0 AS INTEGER
 immunesub1 AS INTEGER
 immunesub2 AS INTEGER
 pickup AS INTEGER
 grounded AS INTEGER
 struck AS INTEGER
 autospawned AS INTEGER
 pstruck AS INTEGER
 pstruckx AS INTEGER
END TYPE

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns AS INTEGER
 spawnid AS INTEGER
 westspawny AS INTEGER
 eastspawny AS INTEGER
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull AS INTEGER
 pendingpower AS INTEGER
 pendinggem AS INTEGER
 pendingwhip AS INTEGER
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 Speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub AS INTEGER
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing AS INTEGER
 duckthrowing AS INTEGER
 backflip AS INTEGER
 platformcheck AS INTEGER
END TYPE

TYPE SubWeapon
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 index AS INTEGER
 dmg AS INTEGER
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 hitbox AS Rect
 check AS INTEGER
 tmr AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 redraw AS INTEGER
 noclear AS INTEGER
 ani AS Animator
 fliph AS INTEGER
 scalex AS INTEGER
 ontile AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 yforce AS INTEGER
 tilehit AS INTEGER
 Speed AS INTEGER
 pswapclip AS INTEGER
 pcliploop AS INTEGER
 ptmrreset AS INTEGER
 pplayerhit AS INTEGER
 ptileat AS INTEGER
 psolidcheck AS INTEGER
 imgnum AS INTEGER
END TYPE

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE ItemDescType
 active AS INTEGER
 shifting AS INTEGER
 id AS INTEGER
 tmr AS TTmr
END TYPE

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

defint a-z

DECLARE SUB DQBpeek (BYVAL DataSeg%, BYVAL DataOff%, BYVAL Offset&, BYVAL Length%)
DECLARE SUB DQBpoke (BYVAL DataSeg%, BYVAL DataOff%, BYVAL Offset&, BYVAL Length%)
DECLARE SUB DQBget (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE SUB DQBput (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE SUB DQBtPut (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%, BYVAL BitMode%)
DECLARE SUB DQBhPut (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%, BYVAL Col%)
'DECLARE SUB DQBmPut (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%, BYVAL Flip%)
DECLARE SUB DQBfPut (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE SUB EnemySpawn (id AS INTEGER, x AS INTEGER, y AS INTEGER, edata AS STRING, e() AS EnemyType, ec() AS AniClip, gs AS GlobalState)

SUB MemoryMode (playergfxr() as integer, playergfxsize as integer, enemygfxr() as integer, enemygfxsize as integer)
  redim playergfxr(playergfxsize) as integer
  DEF SEG = VARSEG(playergfxr(0))
  BLOAD "data/player.gfr", VARPTR(playergfxr(0))
  DEF SEG
  redim enemygfxr(enemygfxsize) as integer
end sub

SUB PlayerDraw (gs as GlobalState, playerframes() as AniFrame, playergfx() as integer, playergfxr() as integer)
 IF gs.pl.redraw = 1 THEN
  'memsavetemp
  IF gs.pl.fliph = 0 THEN
   DQBput gs.gp.drawlayer, gs.pl.dx, gs.pl.dy, VARSEG(playergfx(playerframes(gs.pl.drawframe).offset)), (VARPTR(playergfx(playerframes(gs.pl.drawframe).offset)))
   ''DQBtput layer, gs.pl.dx, gs.pl.dy, VARSEG(playergfx(0)), (VARPTR(playergfx(0)) + playerframes(gs.pl.drawframe).offset), BIT.XOR
  ELSE
   DQBput gs.gp.drawlayer, gs.pl.dx, gs.pl.dy, VARSEG(playergfxr(playerframes(gs.pl.drawframe).offset)), (VARPTR(playergfxr(playerframes(gs.pl.drawframe).offset)))
  END IF
  'DQBmput gs.gp.drawlayer, gs.pl.dx, gs.pl.dy, VARSEG(playergfx(playerframes(gs.pl.drawframe).offset)), VARPTR(playergfx(playerframes(gs.pl.drawframe).offset)), gs.pl.fliph
  'DQBput layer, gs.pl.dx, gs.pl.dy, VARSEG(playergfx(0)), (VARPTR(playergfx(0)) + (playerframes(gs.pl.drawframe).offset * 2))', gs.pl.fliph
 END IF

 IF gs.pl.whipframe > 0 THEN
  'memsavetemp
  IF gs.pl.fliph = 0 THEN
   DQBput gs.gp.drawlayer, gs.pl.whipx, gs.pl.whipy, VARSEG(playergfx(playerframes(gs.pl.whipframe).offset)), (VARPTR(playergfx(playerframes(gs.pl.whipframe).offset)))
  ELSE
   DQBput gs.gp.drawlayer, gs.pl.whipx, gs.pl.whipy, VARSEG(playergfxr(playerframes(gs.pl.whipframe).offset)), (VARPTR(playergfxr(playerframes(gs.pl.whipframe).offset)))
  END IF
  'DQBmput gs.gp.drawlayer, gs.pl.whipx, gs.pl.whipy, VARSEG(playergfx(playerframes(gs.pl.whipframe).offset)), (VARPTR(playergfx(playerframes(gs.pl.whipframe).offset))), gs.pl.fliph
  IF gs.pl.attacking = 0 AND gs.pl.duckattacking = 0 THEN gs.pl.whiplastframe = gs.pl.whipframe: gs.pl.whipframe = 0
 END IF
END SUB

SUB PlayerClear (gs as GlobalState,playerframes() as AniFrame, clearbox() as integer)
  'IF gs.pl.tmrstun > 0 AND gs.pl.tmrstun < 8 THEN EXIT SUB
  IF gs.pl.lasty < 0 THEN gs.pl.lasty = 0
 
   's = (playerframes(gs.pl.clearframe).w * playerframes(gs.pl.clearframe).h) + 4
   'REDIM clearbox(((playerframes(gs.pl.clearframe).w * playerframes(gs.pl.clearframe).h) + 4) / 2) AS INTEGER
   'REDIM clearbox(s / 2) AS INTEGER
   DQBget 1, gs.pl.lastx, gs.pl.lasty, gs.pl.lastx + playerframes(gs.pl.clearframe).w - 1, gs.pl.lasty + playerframes(gs.pl.clearframe).h - 1, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   DQBfput gs.gp.drawlayer, gs.pl.lastx, gs.pl.lasty, VARSEG(clearbox(0)), VARPTR(clearbox(0))
 
  'DQBxput 1, gs.pl.lastx, gs.pl.lasty, gs.pl.lastx + playerframes(gs.pl.clearframe).w - 1, gs.pl.lasty + playerframes(gs.pl.clearframe).h - 1, layer, gs.pl.lastx, gs.pl.lasty
  'DQBtput layer, gs.pl.lastx, gs.pl.lasty, VARSEG(playergfx(0)), (VARPTR(playergfx(0)) + playerframes(gs.pl.clearframe).offset), BIT.XOR
  gs.pl.clearframe = gs.pl.drawframe
  gs.pl.lastx = gs.pl.dx
  gs.pl.lasty = gs.pl.dy
   
  IF gs.pl.whiplastframe > 0 OR gs.pl.whipframe > 0 THEN
   IF gs.pl.whiply < 0 THEN gs.pl.whiply = 0
   IF gs.pl.whiplastframe > 0 THEN
    's = (playerframes(gs.pl.whiplastframe).w * playerframes(gs.pl.whiplastframe).h) + 4
    'REDIM clearbox(s / 2) AS INTEGER
    DQBget 1, gs.pl.whiplx, gs.pl.whiply, gs.pl.whiplx + playerframes(gs.pl.whiplastframe).w - 1, gs.pl.whiply + playerframes(gs.pl.whiplastframe).h - 1, VARSEG(clearbox(0)), VARPTR(clearbox(0))
    DQBfput gs.gp.drawlayer, gs.pl.whiplx, gs.pl.whiply, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   
    'DQBxput 1, gs.pl.whiplx, gs.pl.whiply, gs.pl.whiplx + playerframes(gs.pl.whiplastframe).w - 1, gs.pl.whiply + playerframes(gs.pl.whiplastframe).h - 1, layer, gs.pl.whiplx, gs.pl.whiply
   END IF
   gs.pl.whiplx = gs.pl.whipx
   gs.pl.whiply = gs.pl.whipy
   gs.pl.whiplastframe = gs.pl.whipframe
  END IF

END SUB

SUB EnemyClear (enemy AS EnemyType, enemies() as EnemyType, enemyclips() as AniClip, enemyframes() as AniFrame, gs as GlobalState, clearbox() as integer)
'IF enemy.noclear THEN enemy.redraw = 0: enemy.noclear = 0
IF enemy.redraw OR enemy.pendinginactive THEN
  IF enemy.lasty < 0 THEN enemy.lasty = 0
  IF enemy.noclear = 0 THEN
   's = DQBsize(enemy.lastx, enemy.lasty, enemy.lastx + enemyframes(enemy.clearframe).w - 1, enemy.lasty + enemyframes(enemy.clearframe).h - 1)
   's = (enemyframes(enemy.clearframe).w * enemyframes(enemy.clearframe).h) + 4
   'REDIM clearbox(s / 2) AS INTEGER
   DQBget 1, enemy.lastx, enemy.lasty, enemy.lastx + enemyframes(enemy.clearframe).w - 1, enemy.lasty + enemyframes(enemy.clearframe).h - 1, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   DQBfput gs.gp.drawlayer, enemy.lastx, enemy.lasty, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 1, enemy.lastx, enemy.lasty, enemy.lastx + enemyframes(enemy.clearframe).w - 1, enemy.lasty + enemyframes(enemy.clearframe).h - 1, layer, enemy.lastx, enemy.lasty
  END IF
  enemy.clearframe = enemy.drawframe
  enemy.lastx = enemy.dx
  enemy.lasty = enemy.dy
  IF enemy.pendinginactive = 1 THEN
   enemy.active = 0
   enemy.pendinginactive = 0
   IF gs.emax = enemy.index + 1 THEN
    DO
     gs.emax = gs.emax - 1
     IF gs.emax = 0 THEN EXIT DO
    LOOP WHILE enemies(gs.emax - 1).active = 0
   END IF
   IF gs.md.autospawns > 0 AND enemy.autospawned = 1 THEN
    gs.md.autospawns = gs.md.autospawns - 1
    IF gs.pl.x < 160 THEN
     EnemySpawn gs.md.spawnid, 319, gs.md.eastspawny, "a", enemies(), enemyclips(), gs
    ELSE
     EnemySpawn gs.md.spawnid, -24, gs.md.westspawny, "a", enemies(), enemyclips(), gs
    END IF
   END IF
   'debug = STR$(gs.emax)
  END IF
END IF
END SUB

SUB EnemyDraw (enemy AS EnemyType, enemygfx() as integer, enemygfxr() as integer, enemyframes() as AniFrame, gs as GlobalState, clearbox() as integer)
IF enemy.tmrstun THEN
 SELECT CASE enemy.tmrstun
  CASE 10, 1 '7,2
   'memsave
   IF enemy.fliph = 0 THEN
    DQBtput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset))), BIT.XOR
   ELSE
    DQBtput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfxr(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfxr(enemyframes(enemy.drawframe).offset))), BIT.XOR
   END IF
   'DQBmput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset))), enemy.fliph
  CASE 15, 5 '15,10
   'memsave
   IF enemy.fliph = 0 THEN
    DQBhput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset))), 1'104
   ELSE
    DQBhput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfxr(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfxr(enemyframes(enemy.drawframe).offset))), 1'104
   END IF
   'DQBget 1, enemy.dx, enemy.dy, enemy.dx + enemyframes(enemy.clearframe).w - 1, enemy.lasty + enemyframes(enemy.clearframe).h - 1, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBfput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(clearbox(0)), VARPTR(clearbox(0))
  CASE ELSE
   IF enemy.id = 3000 THEN
     'memsave
    IF enemy.fliph = 0 THEN
     DQBput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset)))
    ELSE
     DQBput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfxr(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfxr(enemyframes(enemy.drawframe).offset)))
    END IF
    'DQBmput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset))), enemy.fliph
    enemy.redraw = 0
    enemy.noclear = 0
   END IF
 END SELECT
ELSEIF enemy.redraw THEN
 'memsave
 IF enemy.fliph = 0 THEN
  DQBput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset)))
 ELSE
  DQBput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfxr(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfxr(enemyframes(enemy.drawframe).offset)))
 END IF
 'DQBmput gs.gp.drawlayer, enemy.dx, enemy.dy, VARSEG(enemygfx(enemyframes(enemy.drawframe).offset)), (VARPTR(enemygfx(enemyframes(enemy.drawframe).offset))), enemy.fliph
 enemy.redraw = 0
 enemy.noclear = 0
END IF
END SUB

SUB SubWepClear (wep AS SubWeapon, playerframes() as AniFrame, gs as GlobalState, clearbox() as integer)
IF wep.redraw = 1 OR wep.pendinginactive = 1 THEN
  IF wep.lasty < 0 THEN wep.lasty = 0
  IF wep.noclear = 0 THEN
   's = (playerframes(wep.clearframe).w * playerframes(wep.clearframe).h) + 4
   'REDIM clearbox(s / 2) AS INTEGER
   DQBget 1, wep.lastx, wep.lasty, wep.lastx + playerframes(wep.clearframe).w - 1, wep.lasty + playerframes(wep.clearframe).h - 1, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   DQBfput gs.gp.drawlayer, wep.lastx, wep.lasty, VARSEG(clearbox(0)), VARPTR(clearbox(0))
  
   'DQBxput 1, wep.lastx, wep.lasty, wep.lastx + playerframes(wep.clearframe).w - 1, wep.lasty + playerframes(wep.clearframe).h - 1, layer, wep.lastx, wep.lasty
  END IF
  wep.clearframe = wep.drawframe
  wep.lastx = wep.dx
  wep.lasty = wep.dy
  IF wep.pendinginactive = 1 THEN
   wep.active = 0
   wep.pendinginactive = 0
   wep.check = 0
   'IF subwepmax = wep.index + 1 THEN
   ' DO
   '  subwepmax = subwepmax - 1
   '  IF subwepmax = 0 THEN EXIT DO
   ' LOOP WHILE subweapons(subwepmax - 1).active = 0
   'END IF
  END IF
END IF

END SUB

SUB SubWepDraw (wep AS SubWeapon, playergfx() as integer, playergfxr() as integer, playerframes() as AniFrame, gs as GlobalState)
 IF wep.redraw THEN
  IF wep.fliph = 0 THEN
   DQBput gs.gp.drawlayer, wep.dx, wep.dy, VARSEG(playergfx(playerframes(wep.drawframe).offset)), (VARPTR(playergfx(playerframes(wep.drawframe).offset)))
  ELSE
   DQBput gs.gp.drawlayer, wep.dx, wep.dy, VARSEG(playergfxr(playerframes(wep.drawframe).offset)), (VARPTR(playergfxr(playerframes(wep.drawframe).offset)))
  END IF
  'DQBmput gs.gp.drawlayer, wep.dx, wep.dy, VARSEG(playergfx(playerframes(wep.drawframe).offset)), (VARPTR(playergfx(playerframes(wep.drawframe).offset))), wep.fliph
  wep.redraw = 0
  wep.noclear = 0
 END IF
END SUB


SUB LoadEnemyToEMS (substr AS STRING, E AS INTEGER, eanidatas() as AniData, edatalocs() as EnemyDataLoc, enemyclips() as AniClip, enemyframes() as AniFrame, enemygfx() as integer, enemygfxr() as integer)
 DEF SEG = VARSEG(enemyframes(0))
 BLOAD "data/" + substr + ".frm", VARPTR(enemyframes(0))
 DEF SEG = VARSEG(enemyclips(0))
 BLOAD "data/" + substr + ".clp", VARPTR(enemyclips(0))
 DEF SEG = VARSEG(enemygfx(0))
 BLOAD "data/" + substr + ".gfx", VARPTR(enemygfx(0))
 'memsave
 DEF SEG = VARSEG(enemygfxr(0))
 BLOAD "data/" + substr + ".gfr", VARPTR(enemygfxr(0))
 DEF SEG

 'EXIT SUB

 DQBPoke VARSEG(enemyframes(0)), VARPTR(enemyframes(0)), edatalocs(E).frameoffset, edatalocs(E).framebytes
 DQBPoke VARSEG(enemyclips(0)), VARPTR(enemyclips(0)), edatalocs(E).clipoffset, edatalocs(E).clipbytes
 IF eanidatas(E).gfxhighbytes = 0 THEN
  DQBPoke VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), edatalocs(E).gfxoffset, edatalocs(E).gfxbytes
  'memsave
  DQBPoke VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), edatalocs(E).gfxroffset, edatalocs(E).gfxbytes
 ELSE
  DQBPoke VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), edatalocs(E).gfxoffset, eanidatas(E).gfxlowoffset * 2
  DQBPoke VARSEG(enemygfx(eanidatas(E).gfxlowoffset)), VARPTR(enemygfx(eanidatas(E).gfxlowoffset)), edatalocs(E).gfxoffset + (eanidatas(E).gfxlowoffset * 2), eanidatas(E).gfxhighbytes
  'memsave
  DQBPoke VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), edatalocs(E).gfxroffset, eanidatas(E).gfxlowoffset * 2
  DQBPoke VARSEG(enemygfxr(enemyanidata.gfxlowoffset)), VARPTR(enemygfxr(eanidatas(E).gfxlowoffset)), edatalocs(E).gfxroffset + (eanidatas(E).gfxlowoffset * 2), eanidatas(E).gfxhighbytes
 END IF

 'DEF SEG = VARSEG(enemyframes(0))
 'BLOAD "data/bosswing.frm", VARPTR(enemyframes(0))
 'DEF SEG = VARSEG(enemyclips(0))
 'BLOAD "data/bosswing.clp", VARPTR(enemyclips(0))
 'DEF SEG = VARSEG(enemygfx(0))
 'BLOAD "data/bosswing.gfx", VARPTR(enemygfx(0))
 ''DEF SEG = VARSEG(enemygfxr(0))
 ''BLOAD "data/bosswing.gfr", VARPTR(enemygfxr(0))
 'DEF SEG
 'DQBPoke VARSEG(enemyframes(0)), VARPTR(enemyframes(0)), bosswingemsloc.frameoffset, bosswingemsloc.framebytes
 'DQBPoke VARSEG(enemyclips(0)), VARPTR(enemyclips(0)), bosswingemsloc.clipoffset, bosswingemsloc.clipbytes
 ''DQBPoke VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), bosswingemsloc.gfxoffset, bosswingemsloc.gfxbytes
 ''DQBPoke VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), bosswingemsloc.gfxroffset, bosswingemsloc.gfxbytes
 'DQBPoke VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), bosswingemsloc.gfxoffset, bosswinganidata.gfxlowoffset * 2
 'DQBPoke VARSEG(enemygfx(bosswinganidata.gfxlowoffset)), VARPTR(enemygfx(bosswinganidata.gfxlowoffset)), bosswingemsloc.gfxoffset + (bosswinganidata.gfxlowoffset * 2), bosswinganidata.gfxhighbytes
 ''DQBPoke VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), bosswingemsloc.gfxoffset, bosswinganidata.gfxlowoffset * 2
 ''DQBPoke VARSEG(enemygfxr(bosswinganidata.gfxlowoffset)), VARPTR(enemygfxr(bosswinganidata.gfxlowoffset)), bosswingemsloc.gfxoffset + (bosswinganidata.gfxlowoffset * 2), bosswinganidata.gfxhighbytes

 'LoadEnemyFromEMS enemyanidata, enemyemsloc
 'DEF SEG = VARSEG(enemyframes(0))
 'BLOAD "data/enemy.frm", VARPTR(enemyframes(0))
 'DEF SEG = VARSEG(enemyclips(0))
 'BLOAD "data/enemy.clp", VARPTR(enemyclips(0))
 'DEF SEG = VARSEG(enemygfx(0))
 'BLOAD "data/enemy.gfx", VARPTR(enemygfx(0))
 ''DEF SEG = VARSEG(enemygfxr(0))
 ''BLOAD "data/enemy.gfr", VARPTR(enemygfxr(0))
 'DEF SEG
END SUB

SUB LoadEnemyFromEMS (E AS INTEGER,eanidatas() as AniData, edatalocs() as EnemyDataLoc, enemyclips() as AniClip, enemyframes() as AniFrame, enemygfx() as integer, enemygfxr() as integer, EnemyGFXPage as integer)
 DQBPeek VARSEG(enemyframes(0)), VARPTR(enemyframes(0)), edatalocs(E).frameoffset, edatalocs(E).framebytes
 DQBPeek VARSEG(enemyclips(0)), VARPTR(enemyclips(0)), edatalocs(E).clipoffset, edatalocs(E).clipbytes
 IF eanidatas(E).gfxhighbytes = 0 THEN
  DQBPeek VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), edatalocs(E).gfxoffset, edatalocs(E).gfxbytes
  'memsave
  DQBPeek VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), edatalocs(E).gfxroffset, edatalocs(E).gfxbytes
 ELSE
  DQBPeek VARSEG(enemygfx(0)), VARPTR(enemygfx(0)), edatalocs(E).gfxoffset, eanidatas(E).gfxlowoffset * 2
  DQBPeek VARSEG(enemygfx(eanidatas(E).gfxlowoffset)), VARPTR(enemygfx(eanidatas(E).gfxlowoffset)), edatalocs(E).gfxoffset + (eanidatas(E).gfxlowoffset * 2), eanidatas(E).gfxhighbytes
  'memsave
  DQBPeek VARSEG(enemygfxr(0)), VARPTR(enemygfxr(0)), edatalocs(E).gfxroffset, eanidatas(E).gfxlowoffset * 2
  DQBPeek VARSEG(enemygfxr(eanidatas(E).gfxlowoffset)), VARPTR(enemygfxr(eanidatas(E).gfxlowoffset)), edatalocs(E).gfxroffset + (eanidatas(E).gfxlowoffset * 2), eanidatas(E).gfxhighbytes
 END IF
 EnemyGFXPage = E
END SUB

SUB OpenDoor (gs AS GlobalState, clearbox() AS INTEGER)
 DQBget 3, 96, 48, 96 + 31, 48 + 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
 DQBfput 1, 144, 112, VARSEG(clearbox(0)), VARPTR(clearbox(0))
 DQBfput gs.gp.drawlayer, 144, 112, VARSEG(clearbox(0)), VARPTR(clearbox(0))
END SUB