TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

TYPE Tile
 id AS INTEGER
 solid AS INTEGER
 breakable AS INTEGER
 deadly AS INTEGER
 teleport AS INTEGER
 stair AS INTEGER
 platform AS INTEGER
 interact AS INTEGER
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 obj AS INTEGER
END TYPE

TYPE ItemDescType
 active AS INTEGER
 shifting AS INTEGER
 id AS INTEGER
 tmr AS TTmr
END TYPE

TYPE AniFrame
 offset AS INTEGER
 x AS INTEGER
 y AS INTEGER
 w AS INTEGER
 h AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE EnemyType
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 edata AS STRING * 8
 x AS INTEGER
 y AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lastscalex AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 dxo AS INTEGER
 dyo AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 speed AS INTEGER
 yforce AS INTEGER
 fliph AS INTEGER
 tmrstun AS INTEGER
 maxstun AS INTEGER
 ani AS Animator
 hitbox AS Rect
 hurtbox AS Rect
 autohurtbox AS INTEGER
 autohitbox AS INTEGER
 bossmode AS INTEGER
 maxhp AS INTEGER
 hp AS INTEGER
 tmr0 AS TTmr
 tmr1 AS TTmr
 tmr2 AS TTmr
 tmr3 AS TTmr
 tmr4 AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 noclear AS INTEGER
 immortal AS INTEGER
 immaterial AS INTEGER
 index AS INTEGER
 scalex AS INTEGER
 tilehit AS INTEGER
 solidhit AS INTEGER
 redraw AS INTEGER
 dmg AS INTEGER
 immunewhip AS INTEGER
 immunesub0 AS INTEGER
 immunesub1 AS INTEGER
 immunesub2 AS INTEGER
 pickup AS INTEGER
 grounded AS INTEGER
 struck AS INTEGER
 autospawned AS INTEGER
 pstruck AS INTEGER
 pstruckx AS INTEGER
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub AS INTEGER
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing AS INTEGER
 duckthrowing AS INTEGER
 backflip AS INTEGER
 platformcheck AS INTEGER
END TYPE

TYPE SubWeapon
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 index AS INTEGER
 dmg AS INTEGER
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 hitbox AS Rect
 check AS INTEGER
 tmr AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 redraw AS INTEGER
 noclear AS INTEGER
 ani AS Animator
 fliph AS INTEGER
 scalex AS INTEGER
 ontile AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 yforce AS INTEGER
 tilehit AS INTEGER
 speed AS INTEGER
 pswapclip AS INTEGER
 pcliploop AS INTEGER
 ptmrreset AS INTEGER
 pplayerhit AS INTEGER
 ptileat AS INTEGER
 psolidcheck AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull AS INTEGER
 pendingpower AS INTEGER
 pendinggem AS INTEGER
 pendingwhip AS INTEGER
END TYPE

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns AS INTEGER
 spawnid AS INTEGER
 westspawny AS INTEGER
 eastspawny AS INTEGER
END TYPE

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

DEFINT A-Z

DECLARE FUNCTION TmrTick% (tmr AS TTmr)
DECLARE SUB TmrReset (tmr AS TTmr, delay AS INTEGER)
DECLARE SUB AniSwapClip (ani AS Animator, clip AS AniClip, looping AS INTEGER, drawframe AS INTEGER)
DECLARE SUB AnimatorUpdate (ani AS Animator, drawframe AS INTEGER)
DECLARE FUNCTION RectHit% (r1 AS Rect, r2 AS Rect)
DECLARE FUNCTION RandomRange% (n1 AS INTEGER, n2 AS INTEGER)
DECLARE SUB EnemyStruck (en AS EnemyType, weapon AS INTEGER, dmg AS INTEGER, e() AS EnemyType, ec() AS AniClip, gs AS GlobalState, voices() as integer,sounds() as integer)
DECLARE SUB EnemySpawn (id AS INTEGER, x AS INTEGER, y AS INTEGER, edata AS STRING, e() AS EnemyType, ec() AS AniClip, gs AS GlobalState)
DECLARE SUB BGCollisionN (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionS (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, lasty AS INTEGER, platimmune AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionW (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionE (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGTileAt (xval AS INTEGER, yval AS INTEGER, tilehit AS INTEGER, gs AS GlobalState)
DECLARE SUB PlaySound (s AS INTEGER, lf AS INTEGER, gs AS GlobalState, voices() AS INTEGER, sounds() AS INTEGER)

DECLARE SUB EnemyUZambie (en AS EnemyType, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUDeathSpark (en AS EnemyType)
DECLARE SUB EnemyUSmallHeart (en AS EnemyType, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyULargeHeart (en AS EnemyType, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUCrawler (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUZangy (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUArmor (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUZambieArcher (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUArrow (en AS EnemyType)
DECLARE SUB EnemyUSkeleborb (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)
DECLARE SUB EnemyUPantherSkel (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUZambieWoof (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUGost (en AS EnemyType, ef() AS AniFrame)
DECLARE SUB EnemyUBone (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)
DECLARE SUB EnemyUSkeleman (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUBossWing (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile,voices(),sounds())
DECLARE SUB EnemyUWingGust (en AS EnemyType, ef() AS AniFrame)
DECLARE SUB EnemyUOrb (en AS EnemyType, ec() AS AniClip, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUPuppetFrog (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUSkullFlower (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState)
DECLARE SUB EnemyUFlowerBullet (en AS EnemyType, ef() AS AniFrame)
DECLARE SUB EnemyUSpiber (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState)
DECLARE SUB EnemyUMiniSpiber (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)
DECLARE SUB EnemyUBossWater (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile,voices(),sounds())
DECLARE SUB EnemyUSploosh (en AS EnemyType)
DECLARE SUB EnemyUFishBullet (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame)
DECLARE SUB EnemyUSkelMiner (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUGarg (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUGargFire (en AS EnemyType, ef() AS AniFrame)
DECLARE SUB EnemyUStarker (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
DECLARE SUB EnemyUBossRock (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile,voices(),sounds())
declare SUB EnemyURockBullet (en AS EnemyType, ef() AS AniFrame)
declare SUB EnemyURockFall (en AS EnemyType, gs as GlobalState)
declare SUB EnemyUBossDrac (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState,voices(),sounds())
declare SUB EnemyUBossCookie (en AS EnemyType, ec() AS AniClip, gs AS GlobalState,voices(),sounds())

SUB EnemySpawn (id AS INTEGER, x AS INTEGER, y AS INTEGER, edata AS STRING, e() AS EnemyType, ec() AS AniClip, gs AS GlobalState)
FOR i = 0 TO 15
 IF e(i).active = 0 THEN
  IF (i + 1) > gs.emax THEN gs.emax = i + 1
  e(i).id = id
  e(i).active = 1
  e(i).pendinginactive = 0
  e(i).tmrstun = 0
  e(i).maxstun = 16
  e(i).immortal = 0
  e(i).immaterial = 0
  e(i).dxo = 0
  e(i).dyo = 0
  e(i).fliph = 0
  e(i).scalex = 1
  e(i).pickup = 0
  e(i).noclear = 0
  e(i).dmg = 1
  e(i).grounded = 1
  e(i).struck = 0
  e(i).yforce = 0
  e(i).bossmode = 0
  e(i).redraw = 1
  e(i).immunewhip=0
  e(i).immunesub0=0
 
  e(i).edata = edata
  e(i).autohurtbox = 1
  IF edata = "a" THEN e(i).autospawned = 1 ELSE e(i).autospawned = 0
 
  IF gs.pl.x < x THEN e(i).fliph = 1: e(i).scalex = -1

  SELECT CASE id
   CASE 0 'zambie
    e(i).hp = 2
    e(i).hitbox.w = 14
    e(i).hitbox.h = 22
    AniSwapClip e(i).ani, ec(0), 1, e(i).drawframe
    e(i).dyo = 1
    e(i).speed = 20
   CASE 1 'deathspark
    e(i).immortal = 1
    e(i).immaterial = 1
    AniSwapClip e(i).ani, ec(1), 0, e(i).drawframe
    e(i).hitbox.h = 16
    e(i).fliph = 0
    e(i).scalex = 1
    TmrReset e(i).tmr0, 0
    IF edata <> "" THEN e(i).tmr0.delay = VAL(edata)
    e(i).redraw = 0
   CASE 2 'smallheart
    e(i).immortal = 1
    e(i).pickup = 1
    e(i).hitbox.w = 7
    e(i).hitbox.h = 7
    e(i).fliph = 0
    e(i).scalex = 1
    e(i).tmr0.tmr = 0
    e(i).tmr0.frame = 0
    e(i).tmr0.delay = 0
	if gs.gd.currentmap = 13 then
	 AniSwapClip e(i).ani, ec(13), 0, e(i).drawframe
	else
     AniSwapClip e(i).ani, ec(2), 0, e(i).drawframe
	end if
   CASE 3 'largeheart
    e(i).immortal = 1
    e(i).pickup = 1
    e(i).hitbox.w = 11
    e(i).hitbox.h = 11
    e(i).fliph = 0
    e(i).scalex = 1
    TmrReset e(i).tmr0, 0
    if gs.gd.currentmap = 13 then
	 AniSwapClip e(i).ani, ec(14), 0, e(i).drawframe
	else
     AniSwapClip e(i).ani, ec(3), 0, e(i).drawframe
	end if
   CASE 4 'crawler
    e(i).hp = 2
    e(i).hitbox.w = 22
    e(i).hitbox.h = 10
    AniSwapClip e(i).ani, ec(5), 1, e(i).drawframe
    'e(i).dyo = 1
    e(i).speed = 30
    TmrReset e(i).tmr0, 0
   CASE 6 'zangy
    e(i).hp = 2
    e(i).hitbox.w = 13
    e(i).hitbox.h = 22
    AniSwapClip e(i).ani, ec(6), 1, e(i).drawframe
    e(i).dyo = 1
    e(i).speed = 30
   CASE 7 'armor
    e(i).hp = 4
    e(i).hitbox.w = 16
    e(i).hitbox.h = 23
    AniSwapClip e(i).ani, ec(7), 1, e(i).drawframe
    'e(i).dyo = 1
    e(i).speed = 20
    TmrReset e(i).tmr0, 60
   CASE 9 'skeleman
    e(i).hp = 3
    e(i).hitbox.w = 10
    e(i).hitbox.h = 22
    AniSwapClip e(i).ani, ec(9), 1, e(i).drawframe
    e(i).dyo = 1
    e(i).speed = 20
    TmrReset e(i).tmr0, 0
   CASE 10'zambiearcher
    e(i).hp = 3
    e(i).hitbox.w = 14
    e(i).hitbox.h = 23
    AniSwapClip e(i).ani, ec(10), 1, e(i).drawframe
    e(i).dyo = 1
    e(i).speed = 20
    TmrReset e(i).tmr0, 120
   CASE 12'arrow
    e(i).hp = 1
    'e(i).immortal = 1
    e(i).hitbox.w = 13
    e(i).hitbox.h = 3
    AniSwapClip e(i).ani, ec(12), 0, e(i).drawframe
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
   CASE 13'skeleborb
    e(i).hp = 1
    e(i).hitbox.w = 18
    e(i).hitbox.h = 14
    AniSwapClip e(i).ani, ec(13), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
    e(i).tmr0.tmr = x \ 4
    TmrReset e(i).tmr1, 0
    TmrReset e(i).tmr2, 0
    e(i).speed = 120
   CASE 14'pantherskel
    e(i).hp = 2
    e(i).hitbox.w = 32
    e(i).hitbox.h = 9
    AniSwapClip e(i).ani, ec(14), 0, e(i).drawframe
    e(i).speed = 120
    TmrReset e(i).tmr0, 0
   CASE 17'zanbiwoof
    e(i).hp = 2
    e(i).hitbox.w = 22
    e(i).hitbox.h = 32
    AniSwapClip e(i).ani, ec(17), 1, e(i).drawframe
    e(i).speed = 60
   CASE 19'gost
    y = gs.pl.y
    IF y < 16 THEN y = 16
    IF y > 144 THEN y = 144
    e(i).hp = 2
    e(i).hitbox.w = 22
    e(i).hitbox.h = 20
    AniSwapClip e(i).ani, ec(19), 1, e(i).drawframe
    e(i).speed = 60
   CASE 21'bone
    e(i).hp = 1
    e(i).hitbox.w = 9
    e(i).hitbox.h = 9
    e(i).yforce = 200'240
    AniSwapClip e(i).ani, ec(21), 1, e(i).drawframe
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
    e(i).speed = ABS(gs.pl.x - x) \ 32
    IF e(i).speed > 4 THEN
     e(i).speed = 4
    ELSEIF e(i).speed < 1 THEN
     e(i).speed = 1
    END IF
   CASE 22'puppetfrog
    e(i).hp = 3
    e(i).hitbox.w = 23
    e(i).hitbox.h = 14
    AniSwapClip e(i).ani, ec(22), 0, e(i).drawframe
    e(i).speed = 1
    TmrReset e(i).tmr0, 0
	e(i).tmr0.tmr=RandomRange(25,65)
   CASE 25'skullflower
    e(i).hp = 4
    e(i).hitbox.w = 24
    e(i).hitbox.h = 24
    AniSwapClip e(i).ani, ec(25), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
   CASE 27'flowerbullet
    e(i).hp = 1
    e(i).hitbox.w = 11
    e(i).hitbox.h = 7
    AniSwapClip e(i).ani, ec(27), 1, e(i).drawframe
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
   CASE 28'spiber
    e(i).hp = 2
    e(i).hitbox.w = 16
    e(i).hitbox.h = 20
    AniSwapClip e(i).ani, ec(28), 0, e(i).drawframe
    TmrReset e(i).tmr0, 0
    TmrReset e(i).tmr1, 0
    TmrReset e(i).tmr2, 0
   CASE 31'minispiber
    e(i).hp = 1
    e(i).hitbox.w = 10
    e(i).hitbox.h = 13
    AniSwapClip e(i).ani, ec(31), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
    TmrReset e(i).tmr1, 0
    TmrReset e(i).tmr2, 0
   CASE 32'skelminer
    e(i).hp = 3
	e(i).hitbox.w = 18
	e(i).hitbox.h = 21
	AniSwapClip e(i).ani, ec(32), 1, e(i).drawframe
	e(i).speed = 20
   CASE 33'garg
    e(i).hp = 4
    e(i).hitbox.w = 20
    e(i).hitbox.h = 23
    AniSwapClip e(i).ani, ec(33), 1, e(i).drawframe
    e(i).speed = 60
    TmrReset e(i).tmr0, 0
   CASE 34'gargfire
    e(i).hp = 1
	e(i).hitbox.w = 11
    e(i).hitbox.h = 7
    AniSwapClip e(i).ani, ec(27), 1, e(i).drawframe
    e(i).scalex = VAL(edata)
	IF ABS(e(i).scalex) = 2 THEN
     e(i).tmr0.frame = -1
    ELSE
     e(i).tmr0.frame = 1
    END IF
	IF e(i).scalex = -2 THEN
	 e(i).scalex = -1
	ELSEIF e(i).scalex = 2 THEN
	 e(i).scalex = 1
    END IF
	IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
   CASE 35'starker
    e(i).hp = 2
	e(i).hitbox.w = 14
	e(i).hitbox.h = 23
	AniSwapClip e(i).ani, ec(35), 1, e(i).drawframe
	e(i).speed = 30
	TmrReset e(i).tmr0, RandomRange(60, 180)
   case 37 'rain
    e(i).hp=1
	e(i).immortal=1
	e(i).immaterial=1
	e(i).hitbox.w=16
	e(i).hitbox.h=25
	AniSwapClip e(i).ani,ec(37),0,e(i).drawframe
   CASE 1000 'bosswing
    e(i).bossmode = 3 + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
    e(i).hp = 8 * e(i).bossmode
    gs.enemyhp = 8
    gs.enemymaxhp = 8
    e(i).hitbox.w = 39
    e(i).hitbox.h = 42
    AniSwapClip e(i).ani, ec(0), 0, e(i).drawframe
    TmrReset e(i).tmr0, 0
    e(i).speed = 120
   CASE 1001 'winggust
    e(i).hp = 1
    e(i).immortal = 1
    e(i).hitbox.w = 20
    e(i).hitbox.h = 15
    AniSwapClip e(i).ani, ec(9), 0, e(i).drawframe
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
   CASE 1002'orb
    e(i).hp = 1
    e(i).immortal = 1
    e(i).pickup = 1
    e(i).fliph = 0
    e(i).scalex = 1
    e(i).hitbox.w = 10
    e(i).hitbox.h = 10
    AniSwapClip e(i).ani, ec(2), 0, e(i).drawframe
    TmrReset e(i).tmr0, 0
   CASE 2000 'bosswater
    e(i).bossmode = 3 + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
    e(i).hp = 8 * e(i).bossmode
    gs.enemyhp = 8
    gs.enemymaxhp = 8
    e(i).hitbox.w = 28
    e(i).hitbox.h = 7
    AniSwapClip e(i).ani, ec(0), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
    TmrReset e(i).tmr1, 0
    e(i).speed = 120
   CASE 2008 'fishbullet
    e(i).hp = 1
    e(i).hitbox.w = 21
    e(i).hitbox.h = 20
    AniSwapClip e(i).ani, ec(8), 1, e(i).drawframe
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
   CASE 2009 'watersploosh
    e(i).immortal = 1
    e(i).immaterial = 1
    AniSwapClip e(i).ani, ec(9), 0, e(i).drawframe
    e(i).hitbox.h = 23
    e(i).fliph = 0
    e(i).scalex = 1
   CASE 3000 'bossrock
	e(i).bossmode = 3 + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
    e(i).hp = 8 * e(i).bossmode
    gs.enemyhp = 8
    gs.enemymaxhp = 8
    e(i).hitbox.w = 48
    e(i).hitbox.h = 25
    AniSwapClip e(i).ani, ec(0), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
   case 3001 'rockbullet
    e(i).hp = 1
	e(i).immortal=1
    e(i).hitbox.w = 20
    e(i).hitbox.h = 16
	if gs.gd.currentmap = 13 then
	 AniSwapClip e(i).ani, ec(12), 1, e(i).drawframe
	else
     AniSwapClip e(i).ani, ec(7), 1, e(i).drawframe
	end if
    e(i).scalex = VAL(edata)
    IF e(i).scalex > 0 THEN e(i).fliph = 0 ELSE e(i).fliph = 1
	x=x-10
   case 3002 'rockfall
    e(i).hp=1
	e(i).immortal=1
	e(i).hitbox.w=16
	e(i).hitbox.h=16
	AniSwapClip e(i).ani, ec(8), 0, e(i).drawframe
   case 4000 'dracla
    e(i).bossmode = 8 + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
    e(i).hp = 8 * e(i).bossmode
    gs.enemyhp = 8
    gs.enemymaxhp = 8
    e(i).hitbox.w = 37
    e(i).hitbox.h = 34
    AniSwapClip e(i).ani, ec(0), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
   case 4010 'dracla2
    e(i).bossmode = 8 + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
    e(i).hp = 8 * e(i).bossmode
    gs.enemyhp = 8
    gs.enemymaxhp = 8
	gs.ui.pendingenemyhp = 1
    e(i).hitbox.w = 48
    e(i).hitbox.h = 48
    AniSwapClip e(i).ani, ec(10), 1, e(i).drawframe
    TmrReset e(i).tmr0, 0
	e(i).tmr0.tmr=-70
	if gs.gd.chainduck = 0 then e(i).maxstun=8
  END SELECT

  IF e(i).bossmode = 0 THEN e(i).hp = e(i).hp + gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave
 
  e(i).x = x
  e(i).dx = x
  e(i).lx = x
  e(i).lastx = x
 
  e(i).y = y + 16 - e(i).hitbox.h
  e(i).dy = e(i).y + e(i).dyo
  e(i).ly = e(i).y
  e(i).lasty = e(i).y

  e(i).clearframe = e(i).ani.frame
 
  e(i).hitbox.x1 = x
  e(i).hitbox.x2 = x + e(i).hitbox.w
  e(i).hitbox.y1 = e(i).y
  e(i).hitbox.y2 = e(i).y + e(i).hitbox.h
 
  e(i).lastscalex = e(i).scalex
  e(i).maxhp = e(i).hp
  EXIT FOR
 END IF
NEXT
END SUB

SUB EnemyStruck (en AS EnemyType, weapon AS INTEGER, dmg AS INTEGER, e() AS EnemyType, ec() AS AniClip, gs AS GlobalState, voices() as integer,sounds() as integer)
 if en.id=3000 and weapon>0 then dmg = 1
 en.hp = en.hp - dmg
 IF en.bossmode > 0 THEN
  gs.enemyhp = (en.hp \ en.bossmode)
  IF en.hp > 0 AND gs.enemyhp = 0 THEN gs.enemyhp = 1
  gs.ui.pendingenemyhp = 1
 END IF
 IF en.hp > 0 THEN
  en.struck = 1
  en.tmrstun = en.maxstun
  SELECT CASE weapon
   CASE 0
    gs.pl.tmrstun = 8
    en.immunewhip = 1
   CASE 1
    en.immunesub0 = 1
   CASE 2
    en.immunesub1 = 1
   CASE 3
    en.immunesub2 = 1
  END SELECT
  PlaySound 3,15000,gs,voices(),sounds()
 ELSE
  en.immortal = 1
  en.immaterial = 1
  TmrReset en.tmr0, 0
  AniSwapClip en.ani, ec(1), 0, en.drawframe
 
  IF en.bossmode > 0 THEN
   if en.id=4000 then
    EnemySpawn 4010, en.x, 144, "", e(), ec(), gs
   else
    EnemySpawn 1002, 155, 32, "", e(), ec(), gs
   end if
   EnemySpawn 1, en.x - 10, en.y - 10, "5", e(), ec(), gs
   EnemySpawn 1, en.x - 10, en.y + 10, "10", e(), ec(), gs
   EnemySpawn 1, en.x + 10, en.y - 10, "15", e(), ec(), gs
   EnemySpawn 1, en.x + 10, en.y + 10, "20", e(), ec(), gs
   PlaySound 12,15000,gs,voices(),sounds()
  ELSE
   PlaySound 4,15000,gs,voices(),sounds()
   IF gs.emax < 4 AND EnemyGfxPage = 0 THEN
    IF RandomRange(0, 8) = 0 THEN EnemySpawn 2, en.x, en.y - 6, "", e(), ec(), gs
   end if  
  END IF
  
  en.id = 1 'deathspark
  en.tmrstun = 0
  en.y = en.y + (en.hitbox.h \ 2) - 12
  en.dy = en.y
  en.x = en.x + (en.hitbox.w \ 2) - 4
  en.dx = en.x
  en.fliph = 0
  en.scalex = 1
  en.redraw = 0
 END IF

END SUB

SUB EnemyUArmor (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)

 IF en.tmr0.tmr < en.tmr0.delay THEN en.tmr0.tmr = en.tmr0.tmr + 1

 IF en.ani.clip.id = 7 THEN
  en.subx = en.subx + (en.speed * en.scalex)
  IF en.subx >= 60 THEN
   en.subx = en.subx - 60
   en.x = en.x + 1
  ELSEIF en.subx <= 0 THEN
   en.subx = en.subx + 60
   en.x = en.x - 1
  END IF

  IF en.fliph = 0 THEN
   BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN
    en.fliph = 1
    en.scalex = -1
   ELSE
    BGCollisionS en.x + 14, en.y, 23, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
   END IF
  ELSE
   BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN
    en.fliph = 0
    en.scalex = 1
   ELSE
    BGCollisionS en.x, en.y, 23, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
   END IF
  END IF

  IF en.tmr0.tmr >= en.tmr0.delay AND ABS(gs.pl.x - en.x) <= 28 AND ABS(gs.pl.y - en.y) <= 34 THEN
   IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
   AniSwapClip en.ani, ec(8), 0, en.drawframe
  END IF
 ELSE
  SELECT CASE en.ani.subframe
   CASE 2, 4
    en.autohurtbox = 0
    IF en.fliph = 0 THEN
     en.hurtbox.x1 = en.x + 8
     en.hurtbox.x2 = en.x + 38
    ELSE
     en.hurtbox.x1 = en.x - 19
     en.hurtbox.x2 = en.x + 8
    END IF
    en.hurtbox.y1 = en.y + 11
    en.hurtbox.y2 = en.y + 14
  END SELECT
  IF en.ani.trigger = -1 THEN
   AniSwapClip en.ani, ec(7), 1, en.drawframe
   en.tmr0.tmr = 0
  END IF
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 17
   'en.dy = en.y + 1
  CASE 18
   en.dy = en.y - 1
  CASE 19
   IF en.fliph THEN en.dx = en.x - 4
   en.dy = en.y + 1
  CASE 20
   'en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 17 ELSE en.dx = en.x + 2
  CASE 21
   'en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x + 2 ELSE en.dx = en.x - 18
  CASE 22
   'en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 19 ELSE en.dx = en.x + 2
 END SELECT

 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1

END SUB

SUB EnemyUArrow (en AS EnemyType)
 en.x = en.x + (en.scalex * 4)

 IF en.x > 320 OR en.x < -13 THEN en.pendinginactive = 1

 en.dx = en.x
 en.dy = en.y
 en.redraw = 1
END SUB

SUB EnemyUBone (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)
  en.x = en.x + (en.scalex * en.speed)

  en.suby = en.suby - en.yforce
  en.yforce = en.yforce - gs.pl.gravity
  IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
  WHILE en.suby > 60
   en.suby = en.suby - 60
   en.y = en.y + 1
  WEND
  WHILE en.suby < 0
   en.suby = en.suby + 60
   en.y = en.y - 1
  WEND

  IF en.y > 176 THEN en.pendinginactive = 1

  AnimatorUpdate en.ani, en.drawframe
 
  en.dx = en.x
  en.dy = en.y
  SELECT CASE ef(en.drawframe).imgnum
   CASE 52
    en.dy = en.y + 2
   CASE 54
    en.dx = en.x + 2
  END SELECT
 
  IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe THEN en.noclear = 1
  en.redraw = 1

END SUB

SUB EnemyUBossRock (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile, voices(),sounds())
 SELECT CASE en.tmr0.frame
  CASE 0'prefightidle
   IF gs.pl.x >= 16 OR en.struck THEN en.tmr0.frame = 1
   en.hitbox.h=15
  CASE 1, 3, 5, 7'idle0
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 60 THEN
    en.tmr0.frame = en.tmr0.frame + 1
	IF en.x + 24 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
	SELECT CASE en.tmr0.frame
     CASE 2, 6
	  AniSwapClip en.ani, ec(4), 0, en.drawframe
	 CASE 4
	  AniSwapClip en.ani, ec(5), 0, en.drawframe
	 CASE 8
	  AniSwapClip en.ani, ec(6), 0, en.drawframe
	  en.speed = 210
	  PlaySound 18, 15000,gs,voices(),sounds()
	END SELECT
   END IF
  CASE 2, 6'fire
   IF en.ani.trigger = 6 THEN
    EnemySpawn 3001, en.x+24+(24*en.scalex),en.y,str$(en.scalex),e(),ec(),gs
	en.ani.trigger = -9
	PlaySound 19, 15000,gs,voices(),sounds()
   ELSEIF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(0), 1, en.drawframe
    en.tmr0.tmr = 0
	en.tmr0.frame = en.tmr0.frame + 1
   END IF
  CASE 4'stomp
   IF en.ani.trigger = 6 THEN
    if gs.ss<=0 then gs.ss=1
	EnemySpawn 3002,RandomRange(gs.pl.x-40,gs.pl.x-8),0,"",e(),ec(),gs
	EnemySpawn 3002,RandomRange(gs.pl.x+8,gs.pl.x+40),0,"",e(),ec(),gs
    en.ani.trigger = -9
	PlaySound 16, 15000,gs,voices(),sounds()
   ELSEIF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(0), 1, en.drawframe
    en.tmr0.tmr = 0
	en.tmr0.frame = en.tmr0.frame + 1
   END IF
  CASE 8'advance
   IF en.speed > 0 THEN
    en.subx = en.subx + (en.speed * en.scalex)
	WHILE en.subx < 0
	 en.x = en.x - 1
	 en.subx = en.subx + 60
	WEND
	WHILE en.subx >= 60
	 en.x = en.x + 1
	 en.subx = en.subx - 60
	WEND
	IF en.x < 16 THEN
	 en.x = 16
	ELSEIF en.x > 254 THEN
	 en.x = 254
	END IF
	en.speed = en.speed - 10
    'IF en.speed <= 0 THEN
	' AniSwapClip en.ani, ec(0), 1, en.drawframe
    ' en.tmr0.tmr = 0
	' en.tmr0.frame = 1
	'END IF
   elseif en.ani.trigger=-1 then
    AniSwapClip en.ani, ec(0), 1, en.drawframe
    en.tmr0.tmr = 0
	en.tmr0.frame = 1
   END IF
   
   'IF en.ani.trigger = 4 THEN
   ' en.speed = 140
   'en.ani.trigger = -9
   'END IF
 END SELECT
 
 AnimatorUpdate en.ani, en.drawframe
 
 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 6, 9
   en.dy = en.y - 7
  CASE 7, 8
   en.dy = en.y - 17
  CASE 10
   en.dy = en.y - 4
  CASE 11, 12, 13
   en.dy = en.y - 7
  CASE 14
   en.dy = en.y - 1
 END SELECT
 
 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 if en.tmrstun>0 then en.noclear=0
 en.redraw=1
END SUB

SUB EnemyUBossWater (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile, voices(),sounds())
 SELECT CASE en.tmr0.frame
  CASE 0' initial idle wander
   en.x = en.x + en.scalex
   IF en.x < 16 THEN
    en.scalex = 1
    en.fliph = 0
   ELSEIF en.x > 271 THEN
    en.scalex = -1
    en.fliph = 1
   END IF
   IF en.struck = 1 OR gs.pl.x < 224 THEN en.tmr0.frame = 1
  CASE 1' underwater seeker
   IF en.tmr0.tmr > 70 THEN
    IF en.x < gs.pl.x THEN
     en.x = en.x + 1
     en.scalex = 1
     en.fliph = 0
    ELSEIF en.x > gs.pl.x THEN
     en.x = en.x - 1
     en.scalex = -1
     en.fliph = 1
    END IF
    IF ABS(en.x - gs.pl.x) < 16 THEN
     en.tmr0.frame = 2
     AniSwapClip en.ani, ec(4), 1, en.drawframe
     EnemySpawn 2009, en.x, 9 * 16, "", e(), ec(), gs
     en.yforce = gs.pl.jforce * 1.9
     en.tmr0.tmr = 0
     en.y = en.y - 16
	 PlaySound 2, 15000,gs,voices(),sounds()
    END IF
   ELSE
    en.tmr0.tmr = en.tmr0.tmr + 1
   END IF
  CASE 2'jumping
   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND
   
   IF en.yforce < 0 THEN
    IF en.ani.clip.id = 4 THEN AniSwapClip en.ani, ec(5), 1, en.drawframe
    SELECT CASE en.tmr1.frame
     CASE 0'jump only
      IF en.y >= 144 THEN
       EnemySpawn 2009, en.x, 9 * 16, "", e(), ec(), gs
       en.y = 161
       en.suby = 0
       AniSwapClip en.ani, ec(0), 1, en.drawframe
       en.tmr0.frame = 1
       en.tmr1.frame = 1
       en.tmr1.delay = 15
       en.tmr1.tmr = 0
       en.tmr0.delay = 0
	   PlaySound 2, 15000,gs,voices(),sounds()
      END IF
     CASE 1'jump n shoot
      IF TmrTick(en.tmr1) THEN
       IF en.tmr0.delay < 3 THEN
	EnemySpawn 2008, en.x + 12, en.y, STR$(en.scalex), e(), ec(), gs
	en.tmr0.delay = en.tmr0.delay + 1
       END IF
      END IF
      IF en.y >= 144 THEN
       EnemySpawn 2009, en.x, 9 * 16, "", e(), ec(), gs
       en.y = 161
       en.suby = 0
       AniSwapClip en.ani, ec(0), 1, en.drawframe
       en.tmr0.frame = 1
       en.tmr1.frame = 2
       en.tmr1.delay = 15
       en.tmr0.delay = 0
	   PlaySound 2, 15000,gs,voices(),sounds()
      END IF
     CASE 2'land n charge
      IF en.y >= 64 THEN
       BGCollisionS en.x + 12, en.y, 48, 0, 0, en.tilehit, gs, t()
       IF t(en.tilehit).solid > 0 THEN
	AniSwapClip en.ani, ec(6), 1, en.drawframe
	en.tmr0.tmr = 0
	en.tmr0.frame = 3
	en.x = en.x - 8
	en.y = en.y + 16
	en.tmr1.frame = 0
       END IF
      END IF
      IF en.y >= 144 THEN
       EnemySpawn 2009, en.x, 9 * 16, "", e(), ec(), gs
       en.y = 161
       en.suby = 0
       AniSwapClip en.ani, ec(0), 1, en.drawframe
       en.tmr0.frame = 1
       en.tmr1.frame = 1
       en.tmr1.delay = 15
       en.tmr0.delay = 0
	   PlaySound 2, 15000,gs,voices(),sounds()
      END IF
     END SELECT
    END IF
  CASE 3 'idle on land
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 60 THEN
    en.tmr0.tmr = 0
    en.tmr0.frame = 4
    en.tmr0.delay = 2
    AniSwapClip en.ani, ec(7), 1, en.drawframe
    en.grounded = 1
	IF en.x + 24 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
   END IF
  CASE 4 'charge
   IF en.tmr0.tmr > 15 THEN
    en.x = en.x + (en.tmr0.delay * en.scalex)
    IF en.grounded THEN
     BGCollisionS en.x + 24, en.y, 32, 0, 0, en.tilehit, gs, t()
     IF t(en.tilehit).solid = 0 THEN
      en.tmr0.delay = 1
      en.grounded = 0
      en.yforce = 0
      en.suby = 0
     END IF
    ELSE
     en.suby = en.suby - en.yforce
     en.yforce = en.yforce - gs.pl.gravity
     IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
     WHILE en.suby > 60
      en.suby = en.suby - 60
      en.y = en.y + 1
     WEND
     IF en.y >= 144 THEN
      EnemySpawn 2009, en.x, 9 * 16, "", e(), ec(), gs
      en.y = 161
      en.suby = 0
      AniSwapClip en.ani, ec(0), 1, en.drawframe
      en.tmr0.frame = 1
      en.tmr1.delay = 15
      en.tmr0.delay = 0
	  PlaySound 2, 15000,gs,voices(),sounds()
     END IF
    END IF
   ELSE
    en.tmr0.tmr = en.tmr0.tmr + 1
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe
 en.dx = en.x
 en.dy = en.y

 SELECT CASE ef(en.drawframe).imgnum
  CASE 0
   en.dy = en.y + 2
   en.hitbox.w = 24
   en.hitbox.h = 4
  CASE 5
   en.dx = en.x - 1
   en.hitbox.w = 24
   en.hitbox.h = 48
  CASE 3
   IF en.fliph = 0 THEN en.dx = en.x - 1
   en.dy = en.y - 1
   en.hitbox.w = 44
   en.hitbox.h = 32
  CASE 4
   IF en.fliph = 0 THEN en.dx = en.x + 1
   en.dy = en.y + 1
  CASE 9, 10
   en.dx = en.x - 2
   en.dy = en.y + 5
   en.hitbox.h = 27
  CASE 11
   en.dx = en.x - 2
   en.dy = en.y + 4
 END SELECT

 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUBossWing (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile, voices(),sounds())
 SELECT CASE en.tmr0.frame
  CASE 0 'idle
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 70 THEN
    en.tmr0.frame = 1
    en.tmr0.tmr = 0
    AniSwapClip en.ani, ec(4), 0, en.drawframe
   END IF
  CASE 1 'spawn
   IF en.ani.clip.id = 4 AND en.ani.trigger = -1 THEN
    en.tmr0.frame = 2
    AniSwapClip en.ani, ec(5), 0, en.drawframe
   END IF
  CASE 2 'spawned idle
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 140 THEN
    AniSwapClip en.ani, ec(6), 0, en.drawframe
    en.tmr0.tmr = 0
    en.tmr0.frame = 3
   END IF
  CASE 3 'flap
   IF en.ani.trigger = 3 OR en.ani.trigger = -1 THEN
    en.yforce = gs.pl.jforce * 1.5
    en.tmr0.frame = 4
    'IF en.scalex < 0 THEN
     EnemySpawn 1001, en.x, 144, "-1", e(), ec(), gs
    'ELSE
     EnemySpawn 1001, en.x + 20, 144, "1", e(), ec(), gs
    'END IF
	PlaySound 13, 15000,gs,voices(),sounds()
   END IF
  CASE 4 'airborne
   IF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(7), 1, en.drawframe
   END IF
   en.x = en.x + (en.scalex * 2)
   IF en.x < 16 THEN
    en.x = 16
   ELSEIF en.x > 265 THEN
    en.x = 265
   END IF
   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND
   IF gs.pl.x < en.x THEN en.fliph = 1 ELSE en.fliph = 0
   BGCollisionS en.x + 16, en.y, 42, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN
    AniSwapClip en.ani, ec(8), 0, en.drawframe
    en.tmr0.frame = 5
   END IF
  CASE 5 'landing
   en.x = en.x + (en.scalex)
   IF en.x < 16 THEN
    en.x = 16
   ELSEIF en.x > 265 THEN
    en.x = 265
   END IF
  
   IF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(10), 1, en.drawframe
    en.tmr0.frame = 6
    en.speed = 60
    'IF screenShake = 0 THEN screenShake = 1
    'IF en.fliph > 0 THEN
    EnemySpawn 1001, en.x, 144, "-1", e(), ec(), gs
    'ELSE
    EnemySpawn 1001, en.x + 20, 144, "1", e(), ec(), gs
    'END IF
    PlaySound 13, 15000,gs,voices(),sounds()
   END IF
  CASE 6'slide
   en.subx = en.subx + (en.speed * en.scalex)
   WHILE en.subx >= 60
    en.subx = en.subx - 60
    en.x = en.x + 1
   WEND
   WHILE en.subx < 0
    en.subx = en.subx + 60
    en.x = en.x - 1
   WEND
   en.speed = en.speed - 4
   IF en.x < 16 THEN
    en.x = 16
   ELSEIF en.x > 265 THEN
    en.x = 265
   END IF
   IF en.speed <= 0 THEN
    en.tmr0.frame = 7
    en.subx = 0
    IF en.fliph = 0 THEN en.scalex = 1 ELSE en.scalex = -1
    AniSwapClip en.ani, ec(5), 0, en.drawframe
   END IF
  CASE 7 'stationaryflapwait
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 70 THEN
    en.speed = 0
    en.tmr0.tmr = 0
    en.tmr0.frame = 8
    AniSwapClip en.ani, ec(11), 0, en.drawframe
   END IF
  CASE 8'stationaryflap
   IF en.speed > 0 THEN
    en.subx = en.subx - (en.speed * en.scalex)
    WHILE en.subx >= 60
     en.subx = en.subx - 60
     en.x = en.x + 1
    WEND
    WHILE en.subx < 0
     en.subx = en.subx + 60
     en.x = en.x - 1
    WEND
    en.speed = en.speed - 4
    IF en.x < 16 THEN
     en.x = 16
    ELSEIF en.x > 265 THEN
     en.x = 265
    END IF
   END IF
   IF en.ani.trigger = 2 THEN
    en.ani.trigger = -9
    en.speed = 120
    IF en.fliph > 0 THEN
     EnemySpawn 1001, en.x, 144, "-2", e(), ec(), gs
    ELSE
     EnemySpawn 1001, en.x + 20, 144, "2", e(), ec(), gs
    END IF
	PlaySound 13, 15000,gs,voices(),sounds()
   ELSEIF en.ani.trigger = -1 AND en.speed <= 0 THEN
    en.tmr0.tmr = 0
    en.tmr0.frame = 2
    en.subx = 0
    AniSwapClip en.ani, ec(5), 0, en.drawframe
   END IF
 END SELECT
 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 0
   en.dx = en.x - 1
  CASE 1
   en.dy = en.y - 3
   IF en.fliph = 0 THEN en.dx = en.x - 20
  CASE 2
   en.dy = en.y - 3
   IF en.fliph = 0 THEN en.dx = en.x - 20
  CASE 3
   en.dy = en.y - 3
   IF en.fliph = 0 THEN en.dx = en.x - 20
  CASE 4
   en.dy = en.y - 30
   IF en.fliph = 0 THEN en.dx = en.x - 18
  CASE 5
   en.dy = en.y - 30
   IF en.fliph = 0 THEN en.dx = en.x - 10
  CASE 6
   en.dy = en.y - 12
   IF en.fliph = 0 THEN en.dx = en.x - 5
  CASE 7, 8
   en.dy = en.y - 14
   IF en.fliph = 0 THEN en.dx = en.x - 6
  CASE 9
   en.dy = en.y - 14
   IF en.fliph = 0 THEN en.dx = en.x - 18
  CASE 10
   en.dy = en.y - 8
   IF en.fliph = 0 THEN en.dx = en.x - 18

 END SELECT
 en.autohitbox = 0
 IF en.fliph = 0 THEN
  en.hitbox.x1 = en.x + 26
  en.hitbox.y1 = en.y
 ELSE
  en.hitbox.x1 = en.x
  en.hitbox.y1 = en.y
 END IF
 en.hitbox.x2 = en.hitbox.x1 + 10
 en.hitbox.y2 = en.y + 10


 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1
END SUB

SUB EnemyUCrawler (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 IF en.ani.clip.id = 5 THEN
  IF en.ani.subframe > 5 THEN
   en.subx = en.subx + (en.speed * en.scalex)
  
   IF en.subx >= 60 THEN
    en.subx = en.subx - 60
    en.x = en.x + 1
   ELSEIF en.subx < 0 THEN
    en.subx = en.subx + 60
    en.x = en.x - 1
   END IF
   IF en.fliph = 0 THEN
    BGCollisionE en.x, en.y + 5, 22, en.tilehit, gs, t()
    BGCollisionS en.x + 18, en.y, 10, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN
    'debug = STR$(t(en.tilehit).solid)
     AniSwapClip en.ani, ec(4), 1, en.drawframe
     en.tmr0.frame = en.scalex
    END IF
   ELSE
    BGCollisionW en.x, en.y + 5, 0, en.tilehit, gs, t()
    BGCollisionS en.x + 4, en.y, 10, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN
     'debug = STR$(t(en.tilehit).solid)
     AniSwapClip en.ani, ec(4), 1, en.drawframe
     en.tmr0.frame = en.scalex
    END IF
   END IF
  ELSEIF en.ani.trigger = 0 THEN
   en.ani.trigger = -9
   en.fliph = 0
   en.scalex = 1
   IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1
  END IF
 ELSE
  en.fliph = 0
  en.scalex = 1
  IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1
  IF en.tmr0.frame <> en.scalex THEN AniSwapClip en.ani, ec(5), 1, en.drawframe
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x

 SELECT CASE ef(en.drawframe).imgnum
  CASE 7, 12, 13
   en.dy = en.y + 1
  CASE ELSE
   en.dy = en.y
 END SELECT

 IF en.lastx = en.dx AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUDeathSpark (en AS EnemyType)
 SELECT CASE en.tmr0.frame
  CASE 0
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= en.tmr0.delay THEN en.tmr0.frame = 1
  CASE 1
   AnimatorUpdate en.ani, en.drawframe
   IF en.drawframe <> en.clearframe THEN en.redraw = 1
 
   IF en.ani.subframe = 1 THEN
    en.dx = en.x + 1
    en.dy = en.y + 2
   ELSEIF en.ani.subframe = 2 THEN
    en.dx = en.x + 2
    en.dy = en.y + 1
   END IF
   IF en.ani.trigger = -1 THEN
    en.redraw = 1
    en.pendinginactive = 1
   END IF
 END SELECT
END SUB

SUB EnemyUFishBullet (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame)
 en.x = en.x + (en.scalex * 2)
 en.y = en.y + 2

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 13
   en.dy = en.y + 1
   en.dx = en.x + 1
 END SELECT

 IF en.x > 320 OR en.x < -13 OR en.y > 152 THEN
  en.id = 2009
  AniSwapClip en.ani, ec(9), 0, en.drawframe
  en.y = (9 * 16)
  en.dy = en.y
  'en.pendinginactive = 1
 END IF
 en.redraw = 1

END SUB

SUB EnemyUFlowerBullet (en AS EnemyType, ef() AS AniFrame)
 en.x = en.x + (en.scalex * 3)

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 63
   en.dy = en.y - 1
  CASE 64
   en.dy = en.y + 1
 END SELECT

 IF en.x > 320 OR en.x < -13 THEN en.pendinginactive = 1
 en.redraw = 1
END SUB

SUB EnemyUGarg (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 en.subx = en.subx + (en.speed * en.scalex)

 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx < 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF


 IF en.grounded = 0 THEN
  en.suby = en.suby - en.yforce
  en.yforce = en.yforce - gs.pl.gravity
  IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
  WHILE en.suby > 60
   en.suby = en.suby - 60
   en.y = en.y + 1
  WEND
  WHILE en.suby < 0
   en.suby = en.suby + 60
   en.y = en.y - 1
  WEND
  IF en.yforce > 0 THEN
   BGCollisionN en.x + 10, en.y, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN en.yforce = 0
  END IF
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 13, en.hitbox.w, en.tilehit, gs, t()
  IF en.x + 22 >= 319 THEN en.x = 297: en.fliph = 1: en.scalex = -1
  IF t(en.tilehit).solid > 0 AND en.grounded = 1 THEN
   en.yforce = gs.pl.jforce + 50
   en.grounded = 0
   AniSwapClip en.ani, ec(34), 0, en.drawframe
  END IF
  BGCollisionS en.x + 5, en.y, en.hitbox.h, 0, 1, en.solidhit, gs, t()
  BGCollisionS en.x + 11, en.y, en.hitbox.h, 0, 1, en.tilehit, gs, t()
 ELSE
  BGCollisionW en.x, en.y + 13, 0, en.tilehit, gs, t()
  IF en.x < 0 THEN en.x = 0: en.fliph = 0: en.scalex = 1
  IF t(en.tilehit).solid > 0 AND en.grounded = 1 THEN
   en.yforce = gs.pl.jforce + 50
   en.grounded = 0
   AniSwapClip en.ani, ec(34), 0, en.drawframe
  END IF
  BGCollisionS en.x + 10, en.y, en.hitbox.h, 0, 1, en.solidhit, gs, t()
  BGCollisionS en.x + 16, en.y, en.hitbox.h, 0, 1, en.tilehit, gs, t()
 END IF

 IF t(en.tilehit).solid = 0 and t(en.solidhit).solid = 0 AND en.yforce = 0 AND en.x >= 0 AND en.x <= 297 THEN
  IF en.grounded = 1 THEN AniSwapClip en.ani, ec(34), 0, en.drawframe
  en.grounded = 0
 ELSEIF t(en.tilehit).solid > 0 and t(en.solidhit).solid > 0 AND en.yforce < 0 THEN
  IF en.grounded = 0 THEN
   AniSwapClip en.ani, ec(33), 1, en.drawframe
   IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
  END IF
  en.grounded = 1
  en.suby = 0
  en.yforce = 0
 END IF
 
 en.tmr0.tmr = en.tmr0.tmr + 1
 IF en.tmr0.tmr >= 210 THEN
  en.tmr0.tmr = 0
  IF en.fliph = 0 THEN
   'EnemySpawn 34, en.x + 10, en.y - 4, STR$(1 * en.scalex), e(), ec(), gs
   'EnemySpawn 34, en.x + 10, en.y - 6, STR$(2 * en.scalex), e(), ec(), gs
   EnemySpawn 27, en.x + 10, en.y - 6, STR$(en.scalex), e(), ec(), gs
  ELSE
   'EnemySpawn 34, en.x, en.y - 4, STR$(1 * en.scalex), e(), ec(), gs
   'EnemySpawn 34, en.x, en.y - 6, STR$(2 * en.scalex), e(), ec(), gs
   EnemySpawn 27, en.x, en.y - 6, STR$(en.scalex), e(), ec(), gs
  END IF
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 72
   en.dy = en.y - 1
 END SELECT

 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUGargFire (en AS EnemyType, ef() AS AniFrame)
 en.x = en.x + (en.scalex * 4)
 en.y = en.y + en.tmr0.frame

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 63
   en.dy = en.y - 1
  CASE 64
   en.dy = en.y + 1
 END SELECT

 IF en.x > 320 OR en.x < -13 THEN en.pendinginactive = 1
 en.redraw = 1
END SUB

SUB EnemyUGost (en AS EnemyType, ef() AS AniFrame)
 en.x = en.x + en.scalex
 en.y = en.ly + SIN(en.x / 16) * 16

 IF en.fliph = 0 THEN
  IF en.x > 319 THEN en.pendinginactive = 1
 ELSE
  IF en.x < -en.hitbox.w THEN en.pendinginactive = 1
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 IF ef(en.drawframe).imgnum = 48 THEN en.dy = en.y - 4
 en.redraw = 1
END SUB

SUB EnemyULargeHeart (en AS EnemyType, gs AS GlobalState, t() AS Tile)
 IF en.tmr0.frame = 0 THEN 'falling
  en.y = en.y + 2
  BGCollisionS en.x + 5, en.y, 11, 0, 0, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 OR t(en.tilehit).platform > 0 THEN en.tmr0.frame = 1
  en.redraw = 1
  en.dy = en.y
  en.dx = en.x
 ELSE
  en.redraw = 1
  en.noclear = 1
  en.tmr0.delay = en.tmr0.delay + 1
  IF en.tmr0.delay >= 180 THEN
   en.pendinginactive = 1
   en.noclear = 0
  END IF
 END IF

END SUB

SUB EnemyUMiniSpiber (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)
 SELECT CASE en.tmr0.frame
  CASE 0'idle
    en.tmr0.frame = 1
    en.tmr1.tmr = gs.pl.x
    en.tmr1.delay = gs.pl.y
    en.suby = 0
    en.subx = 0
    IF ABS(en.x - gs.pl.x) >= ABS(en.y - gs.pl.y) THEN
     en.tmr2.delay = (ABS(en.y - gs.pl.y) / ABS(en.x - gs.pl.x)) * 120
     en.tmr2.tmr = 120
    ELSE
     en.tmr2.tmr = (ABS(en.x - gs.pl.x) / ABS(en.y - gs.pl.y)) * 120
     en.tmr2.delay = 120
    END IF
    IF gs.pl.x < en.x THEN en.scalex = -1 ELSE en.scalex = 1
    IF en.y > gs.pl.y THEN en.tmr2.delay = en.tmr2.delay * -1
  CASE 1'move
   en.subx = en.subx + en.tmr2.tmr * en.scalex
   WHILE en.subx >= 60
    en.subx = en.subx - 60
    en.x = en.x + 1
   WEND
   WHILE en.subx < 0
    en.subx = en.subx + 60
    en.x = en.x - 1
   WEND
  
   en.suby = en.suby + en.tmr2.delay
   WHILE en.suby >= 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND

   IF en.y > 176 OR en.y < -13 OR en.x > 319 OR en.x < -10 THEN en.pendinginactive = 1
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 68
   en.dy = en.y - 1
 END SELECT

 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1
END SUB

SUB EnemyUOrb (en AS EnemyType, ec() AS AniClip, gs AS GlobalState, t() AS Tile)
 SELECT CASE en.tmr0.frame
  CASE 0
   IF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(3), 1, en.drawframe
    en.tmr0.frame = 1
   END IF
  CASE 1
   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   BGCollisionS en.x + 5, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN en.tmr0.frame = 2
 END SELECT
 AnimatorUpdate en.ani, en.drawframe
 en.dx = en.x
 en.dy = en.y

 IF en.ani.clip.id = 2 THEN
  SELECT CASE en.ani.subframe
   CASE 0
    en.dx = en.x + 3
    en.dy = en.y + 3
   CASE 1
    en.dx = en.x + 2
    en.dy = en.y + 2
   CASE 2
    en.dx = en.x + 1
    en.dy = en.y + 1
  END SELECT
 END IF

 IF en.lasty = en.dy AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1

END SUB

SUB EnemyUPantherSkel (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)

 SELECT CASE en.tmr0.frame
  CASE 0'idle
   IF en.struck OR ABS(en.x - gs.pl.x) < 64 THEN
    en.tmr0.frame = 1
    en.struck = 0
    AniSwapClip en.ani, ec(15), 0, en.drawframe
    en.yforce = gs.pl.jforce
   END IF
  CASE 1'leap
   en.x = en.x + (2 * en.scalex)
   IF en.x < 0 THEN
    en.x = 0
   ELSEIF en.x > 320 - en.hitbox.w THEN
    en.x = 320 - en.hitbox.w
   END IF
   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND
   IF en.scalex > 0 THEN
    BGCollisionE en.x, en.y, en.hitbox.w, en.tilehit, gs, t()
   ELSE
    BGCollisionW en.x, en.y, 0, en.tilehit, gs, t()
   END IF
   IF en.yforce < 0 THEN
    BGCollisionS en.x + 8, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
    en.solidhit = t(en.tilehit).solid
    BGCollisionS en.x + 24, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
    IF en.solidhit > 0 OR t(en.tilehit).solid > 0 THEN
     en.suby = 0
     en.yforce = 0
     en.tmr0.frame = 2
     AniSwapClip en.ani, ec(16), 1, en.drawframe
    END IF
   END IF
  CASE 2'freerun
   'en.subx = en.subx + (en.speed * en.scalex)
   en.x = en.x + (2 * en.scalex)
   'IF en.subx >= 60 THEN
   ' en.subx = en.subx - 60
   ' en.x = en.x + 1
   'ELSEIF en.subx < 0 THEN
   ' en.subx = en.subx + 60
   ' en.x = en.x - 1
   'END IF

   IF en.grounded = 0 THEN
    en.suby = en.suby - en.yforce
    en.yforce = en.yforce - gs.pl.gravity
    IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
    WHILE en.suby > 60
     en.suby = en.suby - 60
     en.y = en.y + 1
    WEND
   END IF

   IF en.fliph = 0 THEN
    BGCollisionE en.x, en.y, en.hitbox.w, en.tilehit, gs, t()
    IF en.x + en.hitbox.w > 319 THEN
     en.fliph = 1: en.scalex = -1
    ELSEIF t(en.tilehit).solid > 0 THEN
     en.yforce = gs.pl.jforce
     en.tmr0.frame = 1
     en.y = en.y - 1
    END IF
    BGCollisionS en.x + 24, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   ELSE
    BGCollisionW en.x, en.y, 0, en.tilehit, gs, t()
    IF en.x < 0 THEN
     en.fliph = 0: en.scalex = 1
    ELSEIF t(en.tilehit).solid > 0 THEN
     en.yforce = gs.pl.jforce
     en.tmr0.frame = 1
     en.y = en.y - 1
    END IF
    BGCollisionS en.x + 8, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
    IF en.fliph = 0 THEN en.yforce = gs.pl.jforce: en.tmr0.frame = 1
   END IF

   IF t(en.tilehit).solid = 0 THEN
    en.grounded = 0
   ELSE
    en.grounded = 1
    en.suby = 0
    en.yforce = 0
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 40
   en.dy = en.y - 1
  CASE 41
   en.dy = en.y - 1
   'IF en.fliph = 0 THEN en.dx = en.x + 2
  CASE 42
   'en.dy = en.y - 1
   'IF en.fliph = 0 THEN en.dx = en.x + 1
  CASE 43
   en.dy = en.y + 1
 END SELECT
 IF en.lastx = en.dx AND en.lasty = en.dy AND en.lastscalex = en.scalex AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUpdate (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile, voices() as integer,sounds() as integer)
 'IF en.pendinginactive = 1 THEN EXIT SUB
 IF gs.pl.whipcheck THEN
  IF en.immunewhip = 0 AND en.immortal = 0 AND RectHit(en.hitbox, gs.pl.whipbox) THEN
   EnemyStruck en, 0, 1 + gs.pl.chains+gs.gd.chainduck, e(), ec(), gs,voices(),sounds()
  END IF
 ELSE
  en.immunewhip = 0
 END IF
 IF gs.swep.check THEN
  IF en.immunesub0 = 0 AND en.immortal = 0 AND RectHit(en.hitbox, gs.swep.hitbox) THEN
   IF gs.swep.id = 1 THEN gs.swep.pendinginactive = 1
   EnemyStruck en, 1, gs.swep.dmg + gs.pl.chains+gs.gd.chainduck, e(), ec(), gs,voices(),sounds()
  END IF
 ELSE
  en.immunesub0 = 0
 END IF

 IF en.tmrstun THEN 
  en.tmrstun = en.tmrstun - 1
  if en.id<>3000 then EXIT SUB
 end if

 SELECT CASE en.id
  CASE 0
   EnemyUZambie en, gs, t()
  CASE 1
   EnemyUDeathSpark en
  CASE 2
   EnemyUSmallHeart en, gs, t()
  CASE 3
   EnemyULargeHeart en, gs, t()
  CASE 4
   EnemyUCrawler en, ec(), ef(), gs, t()
  CASE 6
   EnemyUZangy en, ef(), gs, t()
  CASE 7
   EnemyUArmor en, ec(), ef(), gs, t()
  CASE 9
   EnemyUSkeleman en, e(), ec(), ef(), gs, t()
  CASE 10
   EnemyUZambieArcher en, e(), ec(), ef(), gs, t()
  CASE 12
   EnemyUArrow en
  CASE 13
   EnemyUSkeleborb en, ef(), gs
  CASE 14
   EnemyUPantherSkel en, ec(), ef(), gs, t()
  CASE 17
   EnemyUZambieWoof en, ec(), ef(), gs, t()
  CASE 19
   EnemyUGost en, ef()
  CASE 21
   EnemyUBone en, ef(), gs
  CASE 22
   EnemyUPuppetFrog en, ec(), ef(), gs, t()
  CASE 25
   EnemyUSkullFlower en, e(), ec(), ef(), gs
  CASE 27
   EnemyUFlowerBullet en, ef()
  CASE 28
   EnemyUSpiber en, e(), ec(), ef(), gs
  CASE 31
   EnemyUMiniSpiber en, ef(), gs
  CASE 32
   EnemyUSkelMiner en, ef(), gs, t()
  CASE 33
   EnemyUGarg en, e(), ec(), ef(), gs, t()
  CASE 34
   EnemyUGargFire en, ef()
  CASE 35
   EnemyUStarker en, ec(), ef(), gs, t()
  case 37
   en.noclear=1
   en.redraw=1
  CASE 1000
   EnemyUBossWing en, e(), ec(), ef(), gs, t(),voices(),sounds()
  CASE 1001
   EnemyUWingGust en, ef()
  CASE 1002
   EnemyUOrb en, ec(), gs, t()
  CASE 2000
   EnemyUBossWater en, e(), ec(), ef(), gs, t(), voices(),sounds()
  CASE 2008
   EnemyUFishBullet en, ec(), ef()
  CASE 2009
   EnemyUSploosh en
  CASE 3000
   EnemyUBossRock en, e(), ec(), ef(), gs, t(), voices(),sounds()
  case 3001
   EnemyURockBullet en, ef()
  case 3002
   EnemyURockFall en,gs
  case 4000
   EnemyUBossDrac en,e(),ec(),ef(),gs, voices(),sounds()
  case 4010
   EnemyUBossCookie en,ec(),gs, voices(),sounds()
 END SELECT

 IF en.immaterial = 0 THEN
  IF en.autohitbox THEN
   en.hitbox.x1 = en.x
   en.hitbox.x2 = en.x + en.hitbox.w
   en.hitbox.y1 = en.y
   en.hitbox.y2 = en.y + en.hitbox.h
  END IF
  IF en.autohurtbox THEN
   en.hurtbox.x1 = en.x
   en.hurtbox.x2 = en.x + en.hitbox.w
   en.hurtbox.y1 = en.y
   en.hurtbox.y2 = en.y + en.hitbox.h
  END IF
  en.autohurtbox = 1
  en.autohitbox = 1
  IF RectHit(en.hurtbox, gs.pl.hitbox) THEN
   IF en.pickup = 0 THEN
    'PlayerStruck en.dmg, en.x + (en.hitbox.w \ 2)
    en.pstruck = en.dmg
	en.pstruckx = en.x + (en.hitbox.w \ 2)
   ELSE
    SELECT CASE en.id
     CASE 2'smallheart
      en.noclear = 0
      en.pendinginactive = 1
      gs.gd.hearts = gs.gd.hearts + 1
      gs.ui.pendinghearts = 1
	  PlaySound 1, 22050,gs,voices(),sounds()
      'debug = "collected"
     CASE 3'largeheart
      en.noclear = 0
      en.pendinginactive = 1
      gs.gd.hearts = gs.gd.hearts + 5
      gs.ui.pendinghearts = 1
	  PlaySound 1, 22050,gs,voices(),sounds()
     CASE 1002'orb
      en.noclear = 0
      en.pendinginactive = 1
      gs.pl.hp = gs.pl.maxhp
      gs.ui.pendingplayerhp = 1
	  PlaySound 14, 22050,gs,voices(),sounds()
      SELECT CASE gs.gd.currentmap
       CASE 32'bosswing
	    gs.gd.doublejump = 1
	    gs.ui.pendingpower = 1
	    gs.item.id = 2
	    gs.scenechange = 4'item desc scene
       CASE 47'bosswater
	    gs.gd.waterwalk = 1
	    gs.ui.pendingpower = 1
	    gs.item.id = 5
	    gs.scenechange = 4'itemdesc scene
	   CASE 67'bossrock
	    gs.gd.brickbreak = 1
	    gs.ui.pendingpower = 1
	    gs.item.id = 8
	    gs.scenechange = 4'itemdesc scene
	   CASE 13'dracla
	    gs.item.id = 15
	    gs.scenechange = 4'itemdesc scene
      END SELECT
    END SELECT
   END IF
  END IF
 END IF
END SUB

SUB EnemyUPuppetFrog (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 SELECT CASE en.tmr0.frame
  CASE 0 'idle
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 70 THEN
    en.tmr0.tmr = 0
    en.tmr0.frame = 1
    en.yforce = gs.pl.jforce
    AniSwapClip en.ani, ec(23), 0, en.drawframe
    IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
   END IF
  CASE 1' jumping
   en.x = en.x + en.scalex * 2
   IF en.x < 0 AND en.scalex < 0 THEN
    en.x = 0
   ELSEIF en.x > 295 AND en.scalex > 0 THEN
    en.x = 295
   END IF
   IF en.scalex > 0 THEN
    BGCollisionE en.x, en.y + 12, en.hitbox.w, en.tilehit, gs, t()
   ELSE
    BGCollisionW en.x, en.y + 12, 0, en.tilehit, gs, t()
   END IF

   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND
 
   IF en.yforce < 0 THEN
    IF en.ani.clip.id = 23 THEN AniSwapClip en.ani, ec(24), 0, en.drawframe
    BGCollisionS en.x + 12, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid > 0 THEN
     en.tmr0.frame = 0
     AniSwapClip en.ani, ec(22), 0, en.drawframe
    END IF
   ELSE
    BGCollisionN en.x + 12, en.y, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid > 0 THEN en.yforce = -1
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y

 SELECT CASE ef(en.drawframe).imgnum
  CASE 56
   en.dy = en.y - 10
   IF en.fliph = 0 THEN en.dx = en.x - 6 ELSE en.dx = en.x + 2
  CASE 57
   en.dy = en.y - 10
   IF en.fliph = 0 THEN en.dx = en.x - 6 ELSE en.dx = en.x + 3
 END SELECT

 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUSkeleborb (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState)

 SELECT CASE en.tmr0.frame
  CASE 0'slowrise
   en.suby = en.suby - 10
   IF en.suby < 0 THEN
    en.suby = en.suby + 60
    en.y = en.y - 1
   END IF
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 120 THEN
    en.tmr0.frame = 1
    en.tmr0.tmr = 0
   END IF
  CASE 1'wait
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 60 THEN
    en.tmr0.frame = 2
    en.tmr0.tmr = 0
    en.tmr1.tmr = gs.pl.x
    en.tmr1.delay = gs.pl.y
    en.suby = 0
    en.subx = 0
    IF ABS(en.x - gs.pl.x) >= ABS(en.y - gs.pl.y) THEN
     en.tmr2.delay = (ABS(en.y - gs.pl.y) / ABS(en.x - gs.pl.x)) * 120
     en.tmr2.tmr = 120
    ELSE
     en.tmr2.tmr = (ABS(en.x - gs.pl.x) / ABS(en.y - gs.pl.y)) * 120
     en.tmr2.delay = 120
    END IF
    IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
    IF en.y > gs.pl.y THEN en.tmr2.delay = en.tmr2.delay * -1
   END IF
  CASE 2'pursuit
    IF en.scalex > 0 AND en.tmr1.tmr > en.x THEN
     en.subx = en.subx + en.tmr2.tmr
     WHILE en.subx >= 60
      en.subx = en.subx - 60
      en.x = en.x + 1
     WEND
    ELSEIF en.scalex < 0 AND en.tmr1.tmr < en.x THEN
     en.subx = en.subx - en.tmr2.tmr
     WHILE en.subx < 0
      en.subx = en.subx + 60
      en.x = en.x - 1
     WEND
    ELSE
     en.tmr2.tmr = -1
    END IF
    IF en.tmr2.delay > 0 AND en.tmr1.delay > en.y THEN
     en.suby = en.suby + en.tmr2.delay
     WHILE en.suby >= 60
      en.suby = en.suby - 60
      en.y = en.y + 1
     WEND
    ELSEIF en.tmr2.delay < 0 AND en.tmr1.delay < en.y THEN
     en.suby = en.suby + en.tmr2.delay
     WHILE en.suby < 0
      en.suby = en.suby + 60
      en.y = en.y - 1
     WEND
    ELSE
     IF en.tmr2.tmr = -1 THEN
      en.tmr0.frame = 0
      en.tmr0.tmr = 0
     END IF
    END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 36
   en.dy = en.y + 4
  CASE 37
   en.dy = en.y + 4
   IF en.fliph = 0 THEN en.dx = en.x + 2
  CASE 38
   en.dy = en.y + 4
   IF en.fliph = 0 THEN en.dx = en.x + 1
 END SELECT
 IF en.lastx = en.dx AND en.lasty = en.dy AND en.lastscalex = en.scalex AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUSkeleman (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)

 SELECT CASE en.tmr0.frame
  CASE 0'walk
   en.subx = en.subx + (en.speed * en.scalex)
   IF en.subx >= 60 THEN
    en.subx = en.subx - 60
    en.x = en.x + 1
   ELSEIF en.subx <= 0 THEN
    en.subx = en.subx + 60
    en.x = en.x - 1
   END IF
  
   IF en.fliph = 0 THEN
    BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
    IF t(en.tilehit).solid > 0 THEN
     en.fliph = 1
     en.scalex = -1
    ELSEIF en.x > 0 THEN
     BGCollisionS en.x + 14, en.y, 22, 0, 0, en.tilehit, gs, t()
     IF t(en.tilehit).solid = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
    END IF
   ELSE
    BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid > 0 THEN
     en.fliph = 0
     en.scalex = 1
    ELSEIF en.x < 303 THEN
     BGCollisionS en.x, en.y, 22, 0, 0, en.tilehit, gs, t()
     IF t(en.tilehit).solid = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
    END IF
   END IF

   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 180 THEN
    en.tmr0.frame = 1
    AniSwapClip en.ani, ec(20), 0, en.drawframe
    en.tmr0.tmr = 0
    IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
   END IF
  CASE 1'throw
   IF en.ani.trigger = 1 THEN
    en.ani.trigger = -9
    EnemySpawn 21, en.x, en.y, STR$(en.scalex), e(), ec(), gs
   ELSEIF en.ani.trigger = -1 THEN
    AniSwapClip en.ani, ec(9), 1, en.drawframe
    en.tmr0.frame = 0
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 23
   en.dy = en.y + 1
  CASE 49
   en.dy = en.y + 1
   IF en.fliph = 0 THEN en.dx = en.x - 6
  CASE 50
   en.dy = en.y + 1
   IF en.fliph = 1 THEN en.dx = en.x - 1 ELSE en.dx = en.x
 END SELECT

 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1

END SUB

SUB EnemyUSkelMiner (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 en.subx = en.subx + (en.speed * en.scalex)
 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx <= 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 1
   en.scalex = -1
  ELSE
   BGCollisionS en.x + 14, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
  END IF
 ELSE
  BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 0
   en.scalex = 1
  ELSE
   BGCollisionS en.x, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
  END IF
 END IF
 
 AnimatorUpdate en.ani, en.drawframe

 SELECT CASE ef(en.drawframe).imgnum
  CASE 69
   en.dx = en.x
   en.dy = en.y
  CASE 70
   en.dx = en.x
   en.dy = en.y - 1
 END SELECT
 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1
 
END SUB

SUB EnemyUSkullFlower (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState)
 SELECT CASE en.tmr0.frame
  CASE 0'idle
   en.tmr0.tmr = en.tmr0.tmr + 1
   IF en.tmr0.tmr >= 140 THEN
    en.tmr0.tmr = 0
    en.tmr0.frame = 1
    AniSwapClip en.ani, ec(26), 0, en.drawframe
    EnemySpawn 27, en.x + 12, en.y - 5, STR$(en.scalex), e(), ec(), gs
   END IF
  CASE 1
   IF en.ani.clip.id = 26 AND en.ani.trigger = -1 THEN
    en.tmr0.frame = 0
    AniSwapClip en.ani, ec(25), 1, en.drawframe
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y

 SELECT CASE ef(en.drawframe).imgnum
  CASE 58
   en.dy = en.y + 1
  CASE 60
   en.dy = en.y + 2
 END SELECT

 IF en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1

END SUB

SUB EnemyUSmallHeart (en AS EnemyType, gs AS GlobalState, t() AS Tile)
 IF en.tmr0.frame = 0 THEN 'falling
  SELECT CASE en.tmr0.tmr
   CASE IS < 20
    en.subx = en.subx + 10
    IF en.subx >= 60 THEN
     en.subx = en.subx - 60
     en.x = en.x + 1
    END IF
   CASE 20 TO 29, -30 TO -20
    en.subx = en.subx + 5
    IF en.subx >= 60 THEN
     en.subx = en.subx - 60
     en.x = en.x + 1
    END IF
   CASE 30 TO 40, 81 TO 90
    en.subx = en.subx - 5
    IF en.subx <= 0 THEN
     en.subx = en.subx + 60
     en.x = en.x - 1
    END IF
   CASE 40 TO 80
    en.subx = en.subx - 10
    IF en.subx <= 0 THEN
     en.subx = en.subx + 60
     en.x = en.x - 1
    END IF

   CASE IS > 90
    en.tmr0.tmr = -30
  END SELECT
  en.tmr0.tmr = en.tmr0.tmr + 1
  en.suby = en.suby + 5
  IF en.suby >= 60 THEN
   en.suby = en.suby - 60
   en.y = en.y + 1
  END IF
  IF en.x = en.lastx AND en.y = en.lasty THEN en.noclear = 1
  en.redraw = 1
  'debug = STR$(en.y)
  BGTileAt en.x + 3, en.y + 7, en.tilehit, gs
  IF t(en.tilehit).solid > 0 OR t(en.tilehit).platform > 0 THEN en.tmr0.frame = 1
  en.dy = en.y
  en.dx = en.x
 ELSE
  en.autohurtbox=0
  en.hurtbox.x1=en.x-5
  en.hurtbox.x2=en.x+12
  en.redraw = 1
  en.noclear = 1
  en.tmr0.delay = en.tmr0.delay + 1
  IF en.tmr0.delay >= 180 THEN
   en.pendinginactive = 1
   en.noclear = 0
  END IF
 END IF
END SUB

SUB EnemyUSpiber (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState)
 SELECT CASE en.tmr0.frame
  CASE 0'idle
   IF TmrTick(en.tmr0) THEN
    en.tmr0.frame = 1
    en.tmr0.delay = RandomRange(70, 211)
    en.tmr1.tmr = en.x - ((en.x - gs.pl.x) \ 3)
    en.tmr1.delay = en.y - ((en.y - gs.pl.y) \ 3)
    en.suby = 0
    en.subx = 0
    IF ABS(en.x - en.tmr1.tmr) >= ABS(en.y - en.tmr1.delay) THEN
     en.tmr2.delay = (ABS(en.y - en.tmr1.delay) / ABS(en.x - en.tmr1.tmr)) * 15
     en.tmr2.tmr = 15
    ELSE
     en.tmr2.tmr = (ABS(en.x - en.tmr1.tmr) / ABS(en.y - en.tmr1.delay)) * 15
     en.tmr2.delay = 15
    END IF
    IF en.x < gs.pl.x THEN en.scalex = 1 ELSE en.scalex = -1
    IF en.y > gs.pl.y THEN en.tmr2.delay = en.tmr2.delay * -1
    AniSwapClip en.ani, ec(29), 1, en.drawframe
   END IF
  CASE 1'move
   IF en.scalex > 0 AND en.tmr1.tmr > en.x THEN
    en.subx = en.subx + en.tmr2.tmr
    WHILE en.subx >= 60
     en.subx = en.subx - 60
     en.x = en.x + 1
    WEND
   ELSEIF en.scalex < 0 AND en.tmr1.tmr < en.x THEN
    en.subx = en.subx - en.tmr2.tmr
    WHILE en.subx < 0
     en.subx = en.subx + 60
     en.x = en.x - 1
    WEND
   ELSE
    en.tmr2.tmr = -1
   END IF
   IF en.tmr2.delay > 0 AND en.tmr1.delay > en.y THEN
    en.suby = en.suby + en.tmr2.delay
    WHILE en.suby >= 60
     en.suby = en.suby - 60
     en.y = en.y + 1
    WEND
   ELSEIF en.tmr2.delay < 0 AND en.tmr1.delay < en.y THEN
    en.suby = en.suby + en.tmr2.delay
    WHILE en.suby < 0
     en.suby = en.suby + 60
     en.y = en.y - 1
    WEND
   ELSE
    IF en.tmr2.tmr = -1 THEN
     en.tmr0.frame = 2
     AniSwapClip en.ani, ec(30), 0, en.drawframe
    END IF
   END IF
  CASE 2'fire
   IF en.ani.clip.id = 30 AND en.ani.trigger = -1 THEN
    en.tmr0.frame = 0
    EnemySpawn 31, en.x + 8, en.y, "", e(), ec(), gs
   END IF
 END SELECT

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 66
   en.dy = en.y - 1
   en.dx = en.x - 1
 END SELECT

 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1

END SUB

SUB EnemyUSploosh (en AS EnemyType)
 AnimatorUpdate en.ani, en.drawframe
 IF en.drawframe <> en.clearframe THEN en.redraw = 1

 en.dx = en.x
 en.dy = en.y

 SELECT CASE en.ani.subframe
  CASE 1
   en.dy = en.y - 1
   en.dx = en.x - 2
  CASE 2
   en.dx = en.x + 2
   en.dy = en.y + 9
  CASE 3
   en.dx = en.x - 1
   en.dy = en.y + 6
 END SELECT
 IF en.ani.trigger = -1 THEN
  en.redraw = 1
  en.pendinginactive = 1
 END IF

END SUB

SUB EnemyUStarker (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 en.subx = en.subx + (en.speed * en.scalex)
 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx <= 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 1
   en.scalex = -1
  ELSE
   BGCollisionS en.x + 14, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 AND t(en.tilehit).platform = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
  END IF
 ELSE
  BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 0
   en.scalex = 1
  ELSE
   BGCollisionS en.x, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 AND t(en.tilehit).platform = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
  END IF
 END IF
 
 IF en.tmr0.frame = 0 THEN
  IF TmrTick(en.tmr0) THEN
   en.speed = 60
   AniSwapClip en.ani, ec(36), 1, en.drawframe
   IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
   en.tmr0.tmr = 0
   en.tmr0.delay = 120
   en.tmr0.frame = 1
  END IF
 ELSE
  IF TmrTick(en.tmr0) THEN
   en.speed = 30
   AniSwapClip en.ani, ec(35), 1, en.drawframe
   en.tmr0.tmr = 0
   en.tmr0.delay = RandomRange(120, 240)
   en.tmr0.frame = 0
  END IF
 END IF
 
 AnimatorUpdate en.ani, en.drawframe
 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 74
   IF en.fliph = 0 THEN en.dx = en.x + 3
   en.dy = en.y - 1
  CASE 76
   IF en.fliph = 0 THEN en.dx = en.x + 3 ELSE en.dx = en.x - 5
   en.dy = en.y - 1
 END SELECT
 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1
 
END SUB

SUB EnemyUWingGust (en AS EnemyType, ef() AS AniFrame)
 en.x = en.x + en.scalex

 AnimatorUpdate en.ani, en.drawframe
 IF en.ani.trigger = -1 THEN en.pendinginactive = 1
 SELECT CASE ef(en.drawframe).imgnum
  CASE 11
   en.y = en.ly
   en.hitbox.w = 20
   en.hitbox.h = 15
  CASE 12
   en.y = en.ly - 15
   en.hitbox.w = 24
   en.hitbox.h = 30
  CASE 13
   en.y = en.ly - 6
   en.hitbox.w = 28
   en.hitbox.h = 21
  CASE 14
   en.y = en.ly - 23
   en.hitbox.w = 32
   en.hitbox.h = 38
  CASE 15
   en.y = en.ly - 14
   en.hitbox.w = 33
   en.hitbox.h = 29
  CASE 16
   en.y = en.ly - 29
   en.hitbox.w = 35
   en.hitbox.h = 44
  CASE 17
   en.y = en.ly - 30
   en.hitbox.w = 31
   en.hitbox.h = 37
  CASE 18
   en.y = en.ly - 18
   en.hitbox.w = 16
   en.hitbox.h = 24
 END SELECT
 en.dx = en.x
 en.dy = en.y

 en.redraw = 1
END SUB

SUB EnemyUZambie (en AS EnemyType, gs AS GlobalState, t() AS Tile)
 en.subx = en.subx + (en.speed * en.scalex)
 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx <= 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 1
   en.scalex = -1
  ELSE
   BGCollisionS en.x + 14, en.y, 22, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
  END IF
 ELSE
  BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
  IF t(en.tilehit).solid > 0 THEN
   en.fliph = 0
   en.scalex = 1
  ELSE
   BGCollisionS en.x, en.y, 22, 0, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
  END IF
 END IF
 
 AnimatorUpdate en.ani, en.drawframe

 IF en.ani.subframe = 0 THEN
  en.dy = en.y + 1
  en.dx = en.x
 ELSE
  en.dy = en.y
  en.dx = en.x
  IF en.id = 0 THEN
   IF en.fliph = 0 THEN en.dx = en.x + 1 ELSE en.dx = en.x
  END IF
 END IF
 IF en.lastx = en.dx AND en.drawframe = en.clearframe THEN en.noclear = 1
 en.redraw = 1
 
END SUB

SUB EnemyUZambieArcher (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 IF en.ani.clip.id = 10 THEN
  IF en.tmr0.tmr < en.tmr0.delay THEN
   en.tmr0.tmr = en.tmr0.tmr + 1
  ELSE
   IF ABS(en.y - gs.pl.y) < 32 THEN
    AniSwapClip en.ani, ec(11), 0, en.drawframe
    IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
   END IF
  END IF
  en.subx = en.subx + (en.speed * en.scalex)
  IF en.subx >= 60 THEN
   en.subx = en.subx - 60
   en.x = en.x + 1
  ELSEIF en.subx <= 0 THEN
   en.subx = en.subx + 60
   en.x = en.x - 1
  END IF
 ELSE
  IF en.ani.trigger = 7 THEN
   en.ani.trigger = -9
   'firearrow
   IF en.fliph = 0 THEN
    EnemySpawn 12, en.x + 10, en.y - 3, STR$(en.scalex), e(), ec(), gs
   ELSE
    EnemySpawn 12, en.x - 13, en.y - 3, STR$(en.scalex), e(), ec(), gs
   END IF
  ELSEIF en.ani.trigger = -1 THEN
   AniSwapClip en.ani, ec(10), 1, en.drawframe
   en.tmr0.tmr = 0
  END IF
 END IF

 IF en.ani.clip.id = 10 THEN
  IF en.fliph = 0 AND en.x > 4 THEN
   BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN
    en.fliph = 1
    en.scalex = -1
   ELSE
    BGCollisionS en.x + 14, en.y, 23, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN en.fliph = 1: en.scalex = -1: en.redraw = 1
   END IF
  ELSEIF en.fliph = 1 AND en.x < 315 THEN
   BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
   IF t(en.tilehit).solid > 0 THEN
    en.fliph = 0
    en.scalex = 1
   ELSE
    BGCollisionS en.x, en.y, 23, 0, 0, en.tilehit, gs, t()
    IF t(en.tilehit).solid = 0 THEN en.fliph = 0: en.scalex = 1: en.redraw = 1
   END IF
  END IF
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y

 SELECT CASE ef(en.drawframe).imgnum
  CASE 25
   en.dy = en.y + 1
  CASE 26
   IF en.fliph = 0 THEN en.dx = en.x + 1
  CASE 27
   en.dy = en.y + 1
  CASE 28
   en.dy = en.y - 1
   IF en.fliph THEN en.dx = en.x - 3
  CASE 29
   en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 9
  CASE 30
   en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 5
  CASE 31
   en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 4
  CASE 32
   en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 5
  CASE 33
   en.dy = en.y + 1
   IF en.fliph THEN en.dx = en.x - 2
 END SELECT

 IF en.lastx = en.dx AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 IF en.lastscalex <> en.scalex THEN en.tmr0.tmr = en.tmr0.tmr - 10
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUZambieWoof (en AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)
 en.subx = en.subx + (en.speed * en.scalex)

 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx < 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF


 IF en.grounded = 0 THEN
  en.suby = en.suby - en.yforce
  en.yforce = en.yforce - gs.pl.gravity
  IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
  WHILE en.suby > 60
   en.suby = en.suby - 60
   en.y = en.y + 1
  WEND
  WHILE en.suby < 0
   en.suby = en.suby + 60
   en.y = en.y - 1
  WEND
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 24, en.hitbox.w, en.tilehit, gs, t()
  IF en.x + 22 >= 319 THEN en.x = 297: en.fliph = 1: en.scalex = -1
  IF t(en.tilehit).solid > 0 AND en.grounded = 1 THEN
   en.yforce = gs.pl.jforce
   en.grounded = 0
   AniSwapClip en.ani, ec(18), 0, en.drawframe
  END IF
  BGCollisionS en.x + 4, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
 ELSE
  BGCollisionW en.x, en.y + 24, 0, en.tilehit, gs, t()
  IF en.x < 0 THEN en.x = 0: en.fliph = 0: en.scalex = 1
  IF t(en.tilehit).solid > 0 AND en.grounded = 1 THEN
   en.yforce = gs.pl.jforce
   en.grounded = 0
   AniSwapClip en.ani, ec(18), 0, en.drawframe
  END IF
  BGCollisionS en.x + 18, en.y, en.hitbox.h, 0, 0, en.tilehit, gs, t()
 END IF

 IF t(en.tilehit).solid = 0 AND en.yforce = 0 AND en.x >= 0 AND en.x <= 297 THEN
  IF en.grounded = 1 THEN AniSwapClip en.ani, ec(18), 0, en.drawframe
  en.grounded = 0
 ELSEIF t(en.tilehit).solid > 0 AND en.yforce < 0 THEN
  IF en.grounded = 0 THEN
   AniSwapClip en.ani, ec(17), 1, en.drawframe
   IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
  END IF
  en.grounded = 1
  en.suby = 0
  en.yforce = 0
 END IF

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE ef(en.drawframe).imgnum
  CASE 44
   en.dy = en.y + 1
  'CASE 45
   'IF en.fliph = 0 THEN en.dx = en.x + 2
  CASE 46
   en.dy = en.y + 4
   IF en.fliph = 0 THEN en.dx = en.x + 2
 END SELECT

 'IF en.lastx <> en.dx OR en.drawframe <> en.clearframe THEN en.redraw = 1
 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyUZangy (en AS EnemyType, ef() AS AniFrame, gs AS GlobalState, t() AS Tile)

 'en.x = en.x + en.scalex
 en.subx = en.subx + (en.speed * en.scalex)
 
 IF en.subx >= 60 THEN
  en.subx = en.subx - 60
  en.x = en.x + 1
 ELSEIF en.subx < 0 THEN
  en.subx = en.subx + 60
  en.x = en.x - 1
 END IF

 IF en.grounded = 0 THEN
  en.suby = en.suby - en.yforce
  en.yforce = en.yforce - gs.pl.gravity
  IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
  WHILE en.suby > 60
   en.suby = en.suby - 60
   en.y = en.y + 1
  WEND
  'WHILE en.suby < 0
  ' en.suby = en.suby + 60
  ' en.y = en.y - 1
  'WEND
 END IF

 IF en.fliph = 0 THEN
  BGCollisionE en.x, en.y + 16, 14, en.tilehit, gs, t()
  BGCollisionS en.x + 7, en.y, 22, 0, 0, en.tilehit, gs, t()
 ELSE
  BGCollisionW en.x, en.y + 16, 0, en.tilehit, gs, t()
  BGCollisionS en.x + 7, en.y, 22, 0, 0, en.tilehit, gs, t()
 END IF

 IF t(en.tilehit).solid = 0 AND en.x > 0 AND en.x < 303 THEN
  en.grounded = 0
 ELSE
  en.grounded = 1
  en.suby = 0
  en.yforce = 0
 END IF

 AnimatorUpdate en.ani, en.drawframe

 IF en.ani.trigger = 1 THEN
  en.ani.trigger = -9
  IF gs.pl.x < en.x THEN en.fliph = 1: en.scalex = -1:  ELSE en.fliph = 0: en.scalex = 1
 END IF

 IF ef(en.drawframe).imgnum = 15 THEN
  en.dy = en.y + 1
  en.dx = en.x
 ELSE
  en.dy = en.y
  IF en.fliph = 0 THEN en.dx = en.x + 1 ELSE en.dx = en.x
 END IF
 'IF en.lastx <> en.dx OR en.drawframe <> en.clearframe THEN en.redraw = 1
 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw = 1

END SUB

SUB EnemyURockBullet (en AS EnemyType, ef() AS AniFrame)
 en.x = en.x + (en.scalex * 3)

 AnimatorUpdate en.ani, en.drawframe

 en.dx = en.x
 en.dy = en.y
 SELECT CASE en.ani.subframe
  CASE 1
   en.dy = en.y + 1
 END SELECT

 IF en.x > 320 OR en.x < -13 THEN en.pendinginactive = 1
 en.redraw = 1
END SUB

SUB EnemyURockFall (en AS EnemyType, gs as GlobalState)
 en.suby = en.suby - en.yforce
 en.yforce = en.yforce - gs.pl.gravity
 IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
 WHILE en.suby > 60
  en.suby = en.suby - 60
  en.y = en.y + 1
 WEND

 en.dx = en.x
 en.dy = en.y
 
 IF en.y > 176 THEN en.pendinginactive = 1
 en.redraw = 1
END SUB

SUB EnemyUBossDrac (en AS EnemyType, e() AS EnemyType, ec() AS AniClip, ef() AS AniFrame, gs AS GlobalState, voices(),sounds())
 select case en.tmr0.frame
  case 0'idlesit
   if en.struck or gs.pl.x>64 then
    en.immortal=1
	en.immaterial=1
	AniSwapClip en.ani,ec(4),0,en.drawframe
	en.tmr0.frame=1
	PlaySound 20, 22050,gs,voices(),sounds()
   end if
  case 1'wake
   if en.ani.trigger=-1 then
    'teleport
	en.x=-48'RandomRange(16,256)
	en.y=112
	en.tmr0.frame=2
	en.tmr0.tmr=0
   end if
  case 2' waitingtospawn
   en.tmr0.tmr=en.tmr0.tmr+1
   if en.tmr0.tmr>=140 then
    en.tmr0.tmr=0
	en.tmr0.frame=3
	en.x=RandomRange(16,256)
	IF en.x + 23 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
	'fix hitbox
	AniSwapClip en.ani, ec(5),0,en.drawframe
   end if
  case 3' spawnin
   if en.ani.trigger=-1 then
    en.immortal=0
	en.immaterial=0
    en.tmr0.tmr=en.tmr0.tmr+1
	if en.tmr0.tmr>=70 then
	 en.tmr0.frame=4
	 IF en.x + 23 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
	 AniSwapClip en.ani, ec(7),0,en.drawframe
	end if
   end if
  case 4,5,6' attack
   if en.ani.trigger=-1 then
    en.tmr0.tmr=en.tmr0.tmr+1
	if en.tmr0.tmr>=35 then
	 en.tmr0.tmr=0
	 IF en.x + 23 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
	 EnemySpawn 3001, en.x+24,en.y+16,str$(en.scalex),e(),ec(),gs
	 PlaySound 19, 15000,gs,voices(),sounds()
	 en.tmr0.frame=en.tmr0.frame+1
	 if en.tmr0.frame=7 then
	  en.immortal=1
	  en.immaterial=1
	  AniSwapClip en.ani,ec(9),0,en.drawframe
	 end if
	end if
   end if
   case 7'despawn
    if en.ani.trigger=-1 then
	 en.x=-48'RandomRange(16,256)
	 en.tmr0.frame=2
	 en.tmr0.tmr=0
	end if
 end select
 
 select case en.tmr0.frame
  case 3,4,5,6
   en.autohitbox=0
   if en.fliph=0 then en.hitbox.x1=en.x+28 else en.hitbox.x1=en.x+7
   en.hitbox.x2=en.hitbox.x1+11
   en.hitbox.y1=en.y
   en.hitbox.y2=en.y+13
 end select
 
 AnimatorUpdate en.ani,en.drawframe
 
 en.dx=en.x
 en.dy=en.y
 select case ef(en.drawframe).imgnum
  case 5
   en.dy=en.y-1
   en.dx=en.x-3
  case 6
   en.dy=en.y+4
   en.dx=en.x-13
  case 7
   en.dy=en.y+11
   en.dx=en.x-21
  case 8
   en.dy=en.y+19
   en.dx=en.x-23
  case 9,10,11,12,13
   en.dy=en.y+22
   en.dx=en.x-23
 end select
 
 IF en.lastx = en.dx AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw=1
end sub

SUB EnemyUBossCookie (en AS EnemyType, ec() AS AniClip, gs AS GlobalState, voices(),sounds())
 select case en.tmr0.frame
  case 0' idle
   en.tmr0.tmr=en.tmr0.tmr+1
   if en.tmr0.tmr>=30 then
    en.tmr0.tmr=0
	en.tmr0.frame=1
	AniSwapClip en.ani, ec(11),1,en.drawframe
	IF en.x + 24 < gs.pl.x + 6 THEN en.scalex = 1: en.fliph = 0 ELSE en.scalex = -1: en.fliph = 1
	en.yforce=gs.pl.jforce-50
	PlaySound 2, 15000,gs,voices(),sounds()
   end if
  case 1' jump
   en.x=en.x+(en.scalex*2)
   if en.x<0 then 
    en.x=0
   elseif en.x>255 then
    en.x=255
   end if
   en.suby = en.suby - en.yforce
   en.yforce = en.yforce - gs.pl.gravity
   IF en.yforce < -gs.pl.jforce THEN en.yforce = -gs.pl.jforce
   WHILE en.suby > 60
    en.suby = en.suby - 60
    en.y = en.y + 1
   WEND
   WHILE en.suby < 0
    en.suby = en.suby + 60
    en.y = en.y - 1
   WEND
   if en.y>=112 then
    en.suby=0
    en.y=112
	en.tmr0.frame=0
	AniSwapClip en.ani, ec(10),1,en.drawframe
   end if
 end select
 
 AnimatorUpdate en.ani,en.drawframe
 
 en.dx=en.x
 en.dy=en.y
 
 IF en.lastx = en.dx AND en.lasty = en.dy AND en.drawframe = en.clearframe AND en.lastscalex = en.scalex THEN en.noclear = 1
 en.lastscalex = en.scalex
 en.redraw=1
end sub