TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

TYPE Tile
 id AS INTEGER
 solid AS INTEGER
 breakable AS INTEGER
 deadly AS INTEGER
 teleport AS INTEGER
 stair AS INTEGER
 platform AS INTEGER
 interact AS INTEGER
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 obj AS INTEGER
END TYPE

TYPE ItemDescType
 active AS INTEGER
 shifting AS INTEGER
 id AS INTEGER
 tmr AS TTmr
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE PalSwapType
 Water AS INTEGER
 Candle AS INTEGER
 Fallingwater AS INTEGER
 Grass AS INTEGER
 Pipe AS INTEGER
 HangingGrass AS INTEGER
 Angel AS INTEGER
 Skull AS INTEGER
 livinggrass AS INTEGER
END TYPE

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns AS INTEGER
 spawnid AS INTEGER
 westspawny AS INTEGER
 eastspawny AS INTEGER
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull AS INTEGER
 pendingpower AS INTEGER
 pendinggem AS INTEGER
 pendingwhip AS INTEGER
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 Speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub AS INTEGER
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing AS INTEGER
 duckthrowing AS INTEGER
 backflip AS INTEGER
 platformcheck AS INTEGER
END TYPE

TYPE SubWeapon
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 index AS INTEGER
 dmg AS INTEGER
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 hitbox AS Rect
 check AS INTEGER
 tmr AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 redraw AS INTEGER
 noclear AS INTEGER
 ani AS Animator
 fliph AS INTEGER
 scalex AS INTEGER
 ontile AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 yforce AS INTEGER
 tilehit AS INTEGER
 Speed AS INTEGER
 pswapclip AS INTEGER
 pcliploop AS INTEGER
 ptmrreset AS INTEGER
 pplayerhit AS INTEGER
 ptileat AS INTEGER
 psolidcheck AS INTEGER
 imgnum AS INTEGER
END TYPE

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

Type SaveMenuType
 active as integer
 shifting as integer
 xpos as integer
 tmr as TTmr
end type

DEFINT A-Z

DECLARE SUB UIUpdateHearts (layer AS INTEGER, gs AS GlobalState)
DECLARE SUB UIUpdatePlayerHP (layer AS INTEGER, gs AS GlobalState)
DECLARE SUB UIUpdateEnemyHP (layer AS INTEGER, gs AS GlobalState)
DECLARE FUNCTION RandomRange% (n1 AS INTEGER, n2 AS INTEGER)
DECLARE FUNCTION RectHit% (r1 AS Rect, r2 AS Rect)
DECLARE FUNCTION TmrTick% (tmr AS TTmr)
declare SUB PlaySound (s AS INTEGER, lf AS INTEGER, gs AS GlobalState, voices() AS INTEGER, sounds() AS INTEGER)

DECLARE SUB DQBboxf (BYVAL layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Col%)
DECLARE SUB DQBprint (layer%, Text$, x%, y%, Col%)
DECLARE SUB DQBfput (BYVAL layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE SUB DQBget (BYVAL layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE FUNCTION DQBkey% (BYVAL ScanCode%)
DECLARE FUNCTION DQBinUse% (BYVAL Voice%)
DECLARE SUB DQBplaySound (BYVAL SoundNum%, BYVAL Voice%, BYVAL Freq%, BYVAL LoopFlag%)
DECLARE SUB DQBstopVoice (BYVAL Voice%)
DECLARE SUB DQBClearLayer (BYVAL layer%)

REM $DYNAMIC
SUB AnimatorUpdate (ani AS Animator, drawframe AS INTEGER)
 IF ani.playing = 1 THEN
  ani.tmr = ani.tmr + 1
  IF ani.tmr >= ani.clip.delay THEN
   ani.tmr = 0
   IF ani.frame >= ani.clip.maxframe THEN
    IF ani.looping = 1 THEN
     ani.frame = ani.clip.minframe
     drawframe = ani.frame
     ani.trigger = 0
     ani.subframe = 0
    ELSEIF ani.repeat > 0 THEN
     ani.repeat = ani.repeat - 1
     ani.frame = ani.clip.minframe
     drawframe = ani.frame
     ani.trigger = 0
    ELSE
     ani.trigger = -1
     ani.playing = 0
    END IF
   ELSE
    ani.frame = ani.frame + 1
    drawframe = ani.frame
    ani.trigger = ani.frame - ani.clip.minframe
    ani.subframe = ani.trigger
   END IF
  END IF
 END IF
END SUB

SUB AniSwapClip (ani AS Animator, clip AS AniClip, looping AS INTEGER, drawframe AS INTEGER)
  ani.clip = clip
  ani.repeat = ani.clip.repeat
  ani.tmr = 0
  ani.trigger = -2
  ani.frame = ani.clip.minframe
  drawframe = ani.frame
  ani.subframe = 0
  ani.looping = looping
  ani.playing = 1
END SUB

SUB BGCollisionE (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
'IF xval + offset < 0 OR xval + offset > 319 OR yval < 0 OR yval > 176 THEN tilehit = 21: EXIT SUB

IF xval + offset < 0 OR yval < 0 OR yval > 176 THEN
 tilehit = 21: EXIT SUB
ELSEIF xval + offset > 319 THEN
 IF gs.md.solide = 0 THEN
  tilehit = 21: EXIT SUB
 ELSEIF player.stairimmune > 0 THEN
  tilehit = 21: EXIT SUB
 ELSE
  tilehit = md.solide: xval = 319 - offset: EXIT SUB
 END IF
END IF


temptile = ((yval \ 16) * 20) + ((xval + offset) \ 16)
IF temptile < 0 OR temptile > 219 THEN tilehit = 21: EXIT SUB
tilehit = temptile
'debug = STR$(tile)
IF t(temptile).solid > 0 THEN xval = (t(temptile).x1 - offset)
END SUB

SUB BGCollisionN (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
IF xval < 0 OR xval > 319 OR yval + offset > 176 THEN
 tilehit = 21: EXIT SUB
ELSEIF yval + offset < 0 THEN
 IF gs.md.solidn = 0 THEN
  tilehit = 21: EXIT SUB
 ELSEIF player.stairimmune > 0 THEN
  tilehit = 21: EXIT SUB
 ELSE
  tilehit = gs.md.solidn: yval = -offset: EXIT SUB
 END IF
END IF
temptile = (((yval + offset) \ 16) * 20) + (xval \ 16)
IF temptile < 0 OR temptile > 219 THEN tilehit = 21: EXIT SUB
tilehit = temptile
IF t(temptile).solid > 0 THEN yval = t(temptile).y2 - offset
END SUB

SUB BGCollisionS (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, lasty AS INTEGER, platimmune AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)

IF xval < 0 OR xval > 319 OR yval + offset < 0 THEN
 tilehit = 21: EXIT SUB
ELSEIF yval + offset >= 176 THEN
 IF gs.md.solids = 0 THEN
  tilehit = 21: EXIT SUB
 ELSEIF player.stairimmune > 0 THEN
  tilehit = 21: EXIT SUB
 ELSE
  tilehit = gs.md.solids: yval = 176 - offset: EXIT SUB
 END IF
END IF


temptile = (((yval + offset) \ 16) * 20) + (xval \ 16)
IF t(temptile).deadly = 1 AND gs.gd.waterwalk = 1 THEN t(temptile).deadly = 0: t(temptile).platform = 1
IF temptile < 0 OR temptile > 219 THEN tilehit = 21: EXIT SUB
tilehit = temptile
IF t(tilehit).solid > 0 THEN yval = t(temptile).y1 - offset
'debug = STR$(lasty) + STR$(t(temptile).y1 - offset)
IF platimmune = 0 AND t(tilehit).platform AND lasty <= t(temptile).y1 - offset THEN
  yval = t(temptile).y1 - offset
  gs.pl.platformcheck = 1
END IF
END SUB

SUB BGCollisionW (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
'IF xval + offset < 0 OR xval + offset > 319 OR yval < 0 OR yval > 176 THEN tilehit = 21: EXIT SUB

IF xval + offset > 319 OR yval < 0 OR yval > 176 THEN
 tilehit = 21: EXIT SUB
ELSEIF xval + offset < 0 THEN
 IF gs.md.solidw = 0 THEN
  tilehit = 21: EXIT SUB
 ELSEIF player.stairimmune > 0 THEN
  tilehit = 21: EXIT SUB
 ELSE
  tilehit = gs.md.solidw: xval = -offset: EXIT SUB
 END IF
END IF


temptile = ((yval \ 16) * 20) + ((xval + offset) \ 16)
IF temptile < 0 OR temptile > 219 THEN tilehit = 21: EXIT SUB
tilehit = temptile
'debug = STR$(tile) + STR$(xval) + STR$(yval)
IF t(temptile).solid > 0 THEN xval = t(temptile).x2 - offset
END SUB

SUB BGTileAt (xval AS INTEGER, yval AS INTEGER, tilehit AS INTEGER, gs AS GlobalState)
IF xval + offset < 0 OR xval + offset > 319 OR yval > 176 THEN tilehit = 21: EXIT SUB
IF yval < 0 THEN
 IF gs.md.solidn = 0 THEN
  tilehit = 21: EXIT SUB
 ELSE
  tilehit = gs.md.solidn: EXIT SUB
 END IF
END IF
temptile = ((yval \ 16) * 20) + ((xval + offset) \ 16)
IF temptile < 0 OR temptile > 219 THEN tilehit = 21: EXIT SUB
tilehit = temptile
END SUB

SUB ItemDescUpdate (layer AS INTEGER, gs AS GlobalState, clearbox() AS INTEGER)
 IF gs.item.shifting = 1 THEN
  IF TmrTick(gs.item.tmr) THEN
   SELECT CASE gs.item.tmr.frame
    CASE 0
     DQBboxf layer, 156 - (gs.item.tmr.frame * 8), 84, 163 + (gs.item.tmr.frame * 8), 84 + 7, 0
     DQBprint layer, CHR$(186), 156 - (gs.item.tmr.frame * 8), 84, 8
    CASE 1
     DQBboxf layer, 156 - (gs.item.tmr.frame * 8), 84, 163 + ((gs.item.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint layer, CHR$(198) + STRING$(1, 205) + CHR$(181), 156 - (gs.item.tmr.frame * 8), 84, 8
    CASE 2, 3, 4, 5, 6, 7, 8, 9, 10
     DQBboxf layer, 156 - (gs.item.tmr.frame * 8), 84, 163 + ((gs.item.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint layer, CHR$(198) + STRING$(gs.item.tmr.frame * 2, 205) + CHR$(181), 156 - (gs.item.tmr.frame * 8), 84, 8
    CASE 11
     DQBboxf layer, 156 - (10 * 8), 84 - 8, 163 + (11 * 8), 84 + 7 + 8, 0
     DQBprint layer, CHR$(201) + STRING$(20, 205) + CHR$(187), 156 - (10 * 8), 84 - 8, 8
     DQBprint layer, CHR$(186) + STRING$(20, 32) + CHR$(186), 156 - (10 * 8), 84, 8
     DQBprint layer, CHR$(200) + STRING$(20, 205) + CHR$(188), 156 - (10 * 8), 84 + 8, 8
    CASE 12
     DQBboxf layer, 156 - (10 * 8), 84 - 16, 163 + (11 * 8), 84 + 7 + 16, 0
     DQBprint layer, CHR$(201) + STRING$(20, 205) + CHR$(187), 156 - (10 * 8), 84 - 16, 8
     DQBprint layer, CHR$(186) + STRING$(20, 32) + CHR$(186), 156 - (10 * 8), 84 - 8, 8
     DQBprint layer, CHR$(200) + STRING$(20, 205) + CHR$(188), 156 - (10 * 8), 84 + 16, 8
     gs.item.shifting = 0
     SELECT CASE gs.item.id
      CASE 0'dagger
			  '"                    "
       DQBprint layer, "       DAGGER       ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "THROWING KNIFE MADE " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "FROM SILVER.        " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 1'skull fragment
			  '"                    "
       DQBprint layer, "   SKULL FRAGMENT   ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "THE SHADOWS GROW    " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "DEEPER.             " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 2'doublejump
			  '"                    "
       DQBprint layer, "    BROKEN WING     ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "                    " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "DOUBLE JUMP.        " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 3'whip upgrade
			  '"                    "
       DQBprint layer, "   BLESSED CHAIN    ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "WHIP LENGTH AND     " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "DAMAGE UP.          " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 4'life upgrade
			  '"                    "
       DQBprint layer, "   BLOOD CRYSTAL    ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "                    " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "HP MAX UP.          " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 5'waterwalk
			  '"                    "
       DQBprint layer, "  ROTTED TENTACLE   ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "WALK UPON TRANQUIL  " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "WATERS.             " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 6'holywater
			  '"                    "
       DQBprint layer, "     HOLY WATER     ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "SEALED VIAL BLESSED " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "BY A LOST RELIGION. " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
      CASE 7'axe
			  '"                    "
       DQBprint layer, "       SCYTHE       ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "CURVED BLADE PURPOSE" + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "BUILT TO CLIP WINGS." + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  CASE 8'brickbreak
			          '"                    "
       DQBprint layer, "   SHATTERED HOOF   ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "WEAPON STRIKES BREAK" + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "WEAKENED WALLS.     " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  CASE 9'cross
			          '"                    "
       DQBprint layer, "       CROSS        ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "STRANGE BONES BOUND " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "INTO A CROSS SHAPE. " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  case 10'lockeddoor
	   	              '"                    "
       DQBprint layer, "    SEALED DOOR     ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "BEARS THE MARK OF AN" + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "UNKNOWN SKULL.      " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  case 11'swapweapon
	   	              '"                    "
       DQBprint layer, "CYCLE THROUGH       ", 156 - (9 * 8), 84 - 8, 8
       DQBprint layer, CHR$(186) + "SUBWEAPONS WITH THE " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "D KEY.              " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  case 12'gyduck
	   	              '"                    "
       DQBprint layer, "     AVIAN IDOL     ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "TO SOME, A LESSER   " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "DEITY OF LONGEVITY. " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  case 13'rain0
	   	              '"                    "
       DQBprint layer, "RAIN:               ", 156 - (9 * 8), 84 - 8, 5
       DQBprint layer, CHR$(186) + "SET YOUR WHIP ON    " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "FIRE, IT'LL BE COOL." + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  case 14'rain1
	   	              '"                    "
       DQBprint layer, "RAIN:               ", 156 - (9 * 8), 84 - 8, 5
       DQBprint layer, CHR$(186) + "THESE LAURELS ARE   " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "BANGIN, YO.         " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
	  CASE 15'gameover
			          '"                    "
       DQBprint layer, "  FRACTURED HEART   ", 156 - (9 * 8), 84 - 8, 7
       DQBprint layer, CHR$(186) + "                    " + CHR$(186), 156 - (10 * 8), 84, 8
       DQBprint layer, CHR$(186) + "???                 " + CHR$(186), 156 - (10 * 8), 84 + 8, 8
     END SELECT
   END SELECT
   gs.item.tmr.frame = gs.item.tmr.frame + 1
  END IF
 ELSEIF gs.item.shifting = -1 THEN
  IF TmrTick(gs.item.tmr) THEN
   SELECT CASE gs.item.tmr.frame
    CASE -1
     DQBget 1, 156, 84, 163, 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156, 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
	 if gs.item.id=15 then
	  gs.sceneChange=666
	  gs.item.active=0
	 elseif gs.gd.dagger+gs.gd.holywater+gs.gd.axe+gs.gd.cross=2 then
	  select case gs.item.id
	   case 0,6,7,9
	    gs.sceneChange=4
		gs.item.id=11
		gs.item.active=0
	   case else
	    gs.sceneChange = 0
        gs.item.active = 0
	  end select
	 else
	  gs.sceneChange = 0
      gs.item.active = 0
	 end if
    CASE 0
     DQBget 1, 156 - ((gs.item.tmr.frame + 1) * 8), 84, 163 + ((gs.item.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156 - ((gs.item.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))

     DQBboxf layer, 156, 84, 163, 84 + 7, 0
     DQBprint layer, CHR$(186), 156, 84, 8
    CASE 1
     DQBget 1, 156 - ((gs.item.tmr.frame + 1) * 8), 84, 163 + ((gs.item.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156 - ((gs.item.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   
     DQBboxf layer, 156 - (gs.item.tmr.frame * 8), 84, 163 + ((gs.item.tmr.frame) * 8), 84 + 7, 0
     DQBprint layer, CHR$(198) + STRING$(1, 205) + CHR$(181), 156 - (gs.item.tmr.frame * 8), 84, 8
    CASE 2, 3, 4, 5, 6, 7, 8, 9, 10
     DQBget 1, 156 - ((gs.item.tmr.frame + 1) * 8), 84, 163 + ((gs.item.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156 - ((gs.item.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   
     DQBboxf layer, 156 - (gs.item.tmr.frame * 8), 84, 163 + ((gs.item.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint layer, CHR$(198) + STRING$(gs.item.tmr.frame * 2, 205) + CHR$(181), 156 - (gs.item.tmr.frame * 8), 84, 8
    CASE 11
     DQBget 1, 156 - (10 * 8), 84 - 8, 163 + (11 * 8), 84 + 7 + 8, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156 - (10 * 8), 84 - 8, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBboxf layer, 156 - (80), 84, 163 + (88), 84 + 7, 0
     DQBprint layer, CHR$(198) + STRING$(20, 205) + CHR$(181), 156 - (80), 84, 8
    CASE 12
     DQBget 1, 156 - (10 * 8), 84 - 16, 163 + (11 * 8), 84 + 7 + 16, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput layer, 156 - (10 * 8), 84 - 16, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBboxf layer, 156 - (10 * 8), 84 - 8, 163 + (11 * 8), 84 + 7 + 8, 0
     DQBprint layer, CHR$(201) + STRING$(20, 205) + CHR$(187), 156 - (10 * 8), 84 - 8, 8
     DQBprint layer, CHR$(186) + STRING$(20, 32) + CHR$(186), 156 - (10 * 8), 84, 8
     DQBprint layer, CHR$(200) + STRING$(20, 205) + CHR$(188), 156 - (10 * 8), 84 + 8, 8
   END SELECT
   gs.item.tmr.frame = gs.item.tmr.frame - 1
  END IF
 ELSE
  'inputhandling
  IF gs.sB0 = 2 OR gs.sB1 = 2 THEN
   gs.item.shifting = -1
   gs.item.tmr.frame = 12
  END IF
 END IF
END SUB

SUB PalSwap (swaps AS PalSwapType)

IF swaps.Grass > 0 THEN
 swaps.Grass = swaps.Grass + 1
SELECT CASE swaps.Grass
 CASE 2
  OUT &H3C8, 248 'set color
  OUT &H3C9, 42  'red
  OUT &H3C9, 21  'green
  OUT &H3C9, 0   'blue
  OUT &H3C8, 249
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
 CASE 12, 32
  OUT &H3C8, 248
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 249
  OUT &H3C9, 42
  OUT &H3C9, 21
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 42
  OUT &H3C9, 21
  OUT &H3C9, 0
 CASE 22
  OUT &H3C8, 248
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 249
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 42
  OUT &H3C9, 21
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 42
  OUT &H3C9, 21
  OUT &H3C9, 0
END SELECT
IF swaps.Grass = 42 THEN swaps.Grass = 1
END IF

IF swaps.HangingGrass > 0 THEN
 swaps.HangingGrass = swaps.HangingGrass + 1
SELECT CASE swaps.HangingGrass
 CASE 2
  OUT &H3C8, 248 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 16  'green
  OUT &H3C9, 0   'blue
  OUT &H3C8, 249
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
 CASE 12, 32
  OUT &H3C8, 248
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 249
  OUT &H3C9, 0
  OUT &H3C9, 16
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 0
  OUT &H3C9, 16
  OUT &H3C9, 0
 CASE 22
  OUT &H3C8, 248
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 249
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 250
  OUT &H3C9, 0
  OUT &H3C9, 16
  OUT &H3C9, 0
  OUT &H3C8, 251
  OUT &H3C9, 0
  OUT &H3C9, 16
  OUT &H3C9, 0
END SELECT
IF swaps.HangingGrass = 42 THEN swaps.HangingGrass = 1
END IF


IF swaps.Fallingwater > 0 THEN
 swaps.Fallingwater = swaps.Fallingwater + 1
SELECT CASE swaps.Fallingwater
 CASE 2
  OUT &H3C8, 240 'set color
  OUT &H3C9, 42  'red
  OUT &H3C9, 42  'green
  OUT &H3C9, 63  'blue
  OUT &H3C8, 241
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 242
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42

  '
  OUT &H3C8, 232 'set color
  OUT &H3C9, 42  'red
  OUT &H3C9, 42  'green
  OUT &H3C9, 63  'blue
  OUT &H3C8, 231
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 230
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
 CASE 6
  OUT &H3C8, 232 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0  'blue
  OUT &H3C8, 231
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63
  OUT &H3C8, 230
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
 
 CASE 10
  OUT &H3C8, 240
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 241
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63
  OUT &H3C8, 242
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63

  OUT &H3C8, 232 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0  'blue
  OUT &H3C8, 231
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 230
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63

 CASE 14
  OUT &H3C8, 232 'set color
  OUT &H3C9, 42  'red
  OUT &H3C9, 42  'green
  OUT &H3C9, 63  'blue
  OUT &H3C8, 231
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 230
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
 
 CASE 18
  OUT &H3C8, 240
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 241
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 242
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63
 
  OUT &H3C8, 232 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0  'blue
  OUT &H3C8, 231
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63
  OUT &H3C8, 230
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
CASE 22
  OUT &H3C8, 232 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0  'blue
  OUT &H3C8, 231
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 230
  OUT &H3C9, 42
  OUT &H3C9, 42
  OUT &H3C9, 63

 
END SELECT
IF swaps.Fallingwater = 26 THEN swaps.Fallingwater = 1
END IF
IF swaps.Water > 0 THEN
 swaps.Water = swaps.Water + 1
SELECT CASE swaps.Water
 CASE 2, 62
  OUT &H3C8, 243 'set color
  OUT &H3C9, 21  'red
  OUT &H3C9, 21  'green
  OUT &H3C9, 63   'blue
  OUT &H3C8, 244
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 245
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 246
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 247
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63

 CASE 32
  OUT &H3C8, 243 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 42   'blue
  OUT &H3C8, 244
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 245
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 246
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 247
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42

 CASE 92
  OUT &H3C8, 243 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 42   'blue
  OUT &H3C8, 244
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63
  OUT &H3C8, 245
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 246
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 42
  OUT &H3C8, 247
  OUT &H3C9, 21
  OUT &H3C9, 21
  OUT &H3C9, 63

END SELECT
IF swaps.Water = 122 THEN swaps.Water = 1
END IF

IF swaps.Candle > 0 THEN
 swaps.Candle = swaps.Candle + 1
SELECT CASE swaps.Candle
 CASE 2
  OUT &H3C8, 224 'set color
  OUT &H3C9, 42  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0   'blue
  OUT &H3C8, 225
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 226
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 227
  OUT &H3C9, 63
  OUT &H3C9, 63
  OUT &H3C9, 21
  OUT &H3C8, 228
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 229
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0

 CASE 7, 17
  OUT &H3C8, 224 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0   'blue
  OUT &H3C8, 225
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 226
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 227
  OUT &H3C9, 63
  OUT &H3C9, 63
  OUT &H3C9, 21
  OUT &H3C8, 228
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 229
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0

 CASE 12
  OUT &H3C8, 224 'set color
  OUT &H3C9, 0  'red
  OUT &H3C9, 0  'green
  OUT &H3C9, 0   'blue
  OUT &H3C8, 225
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 226
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 227
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 228
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C8, 229
  OUT &H3C9, 42
  OUT &H3C9, 0
  OUT &H3C9, 0

END SELECT
IF swaps.Candle = 22 THEN swaps.Candle = 1
END IF
IF swaps.Pipe > 0 THEN
 swaps.Pipe = swaps.Pipe + 1
 SELECT CASE swaps.Pipe
  CASE 2
   OUT &H3C8, 252  '16 12
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 122
   OUT &H3C8, 252
   OUT &H3C9, 16
   OUT &H3C9, 12
   OUT &H3C9, 0
  CASE 182
   OUT &H3C8, 252
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 253
   OUT &H3C9, 16
   OUT &H3C9, 12
   OUT &H3C9, 0
  CASE 187
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 16
   OUT &H3C9, 12
   OUT &H3C9, 0
  CASE 192
   swaps.Pipe = 1
 END SELECT
END IF
IF swaps.Angel > 0 THEN
 swaps.Angel = swaps.Angel + 1
 SELECT CASE swaps.Angel
  CASE 2
   OUT &H3C8, 252
   OUT &H3C9, 7
   OUT &H3C9, 0
   OUT &H3C9, 28
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 7
   OUT &H3C8, 252
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 253
   OUT &H3C9, 7
   OUT &H3C9, 0
   OUT &H3C9, 28
   OUT &H3C8, 254
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 12
   OUT &H3C8, 252
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 7
   OUT &H3C9, 0
   OUT &H3C9, 28
  CASE 17
   swaps.Angel = 1
 END SELECT
END IF
IF swaps.Skull > 0 THEN
 swaps.Skull = swaps.Skull + 1
 SELECT CASE swaps.Skull
  CASE 2
   OUT &H3C8, 254
   OUT &H3C9, 8
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 22, 62
   OUT &H3C8, 254
   OUT &H3C9, 12
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 42
   OUT &H3C8, 254
   OUT &H3C9, 16
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 81
   swaps.Skull = 1
 END SELECT
END IF

END SUB

FUNCTION RandomRange (n1 AS INTEGER, n2 AS INTEGER)
 RandomRange = INT(RND * (n2 - n1)) + n1
END FUNCTION

FUNCTION RectHit (r1 AS Rect, r2 AS Rect)
 IF r1.x2 > r2.x1 AND r1.y2 > r2.y1 AND r2.x2 > r1.x1 AND r2.y2 > r1.y1 THEN RectHit = 1 ELSE RectHit = 0
END FUNCTION

SUB TmrReset (tmr AS TTmr, delay AS INTEGER)
 tmr.tmr = 0
 tmr.frame = 0
 tmr.delay = delay
END SUB

FUNCTION TmrTick% (tmr AS TTmr)
 tmr.tmr = tmr.tmr + 1
 IF tmr.tmr >= tmr.delay THEN
  tmr.tmr = tmr.tmr - tmr.delay
  TmrTick = 1
 ELSE
  TmrTick = 0
 END IF
END FUNCTION

SUB UIBuilder (cleararea AS INTEGER, layer AS INTEGER, gs AS GlobalState, clearbox() AS INTEGER)
 IF cleararea = 1 THEN DQBboxf layer, 0, 176, 319, 199, 0
 DQBprint layer, CHR$(201) + STRING$(17, 205) + CHR$(209) + CHR$(205) + CHR$(205) + CHR$(209) + STRING$(17, 205) + CHR$(187), 0, 176, 8
 DQBprint layer, CHR$(186) + "PLAYER " + STRING$(10, 32) + CHR$(179) + "  " + CHR$(179) + STRING$(9, 32) + "ENEMY   " + CHR$(186), 0, 184, 8
 DQBprint layer, CHR$(186) + STRING$(17, 32) + CHR$(179) + "  " + CHR$(179) + STRING$(17, 32) + CHR$(186), 0, 192, 8

 'chains
 DQBprint layer, CHR$(236), 80, 184, 8 - (gs.gd.chainruins * 4)+ (gs.gd.chainduck * 5)
 DQBprint layer, CHR$(236), 88, 184, 8 - (gs.gd.chaingrave * 4)+ (gs.gd.chainduck * 5)
 DQBprint layer, CHR$(236), 96, 184, 8 - (gs.gd.chainforest * 4)+ (gs.gd.chainduck * 5)
 DQBprint layer, CHR$(236), 104, 184, 8 - (gs.gd.chaincave * 4)+ (gs.gd.chainduck * 5)
 'gems
 DQBprint layer, CHR$(4), 112, 184, 8 - (gs.gd.gemruins * 4)
 DQBprint layer, CHR$(4), 120, 184, 8 - (gs.gd.gemgrave * 4)
 DQBprint layer, CHR$(4), 128, 184, 8 - (gs.gd.gemforest * 4)
 DQBprint layer, CHR$(4), 136, 184, 8 - (gs.gd.gemcave * 4)
 'subweapons
 'gs.gd.dagger = 1
 'gs.gd.currentsubweapon = 1
 IF gs.gd.currentsubweapon > 0 THEN
  gs.ui.lastsubweapon = gs.gd.currentsubweapon
  DQBprint layer, CHR$(31), 168 + (gs.gd.currentsubweapon * 8), 184, 8
  DQBget 3, 16 + (gs.gd.currentsubweapon * 16), 32, 31 + (gs.gd.currentsubweapon * 16), 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
  DQBfput layer, 152, 184, VARSEG(clearbox(0)), VARPTR(clearbox(0))
  'DQBxput 3, 16 + (gs.gd.currentsubweapon * 16), 32, 31 + (gs.gd.currentsubweapon * 16), 47, layer, 152, 184
 END IF
 DQBprint layer, CHR$(27), 176, 192, 8 - (gs.gd.dagger * 4)
 DQBprint layer, CHR$(235), 184, 192, 8 - (gs.gd.holywater * 4)
 DQBprint layer, CHR$(29), 192, 192, 8 - (gs.gd.cross * 4)
 DQBprint layer, CHR$(231), 200, 192, 8 - (gs.gd.axe * 4)
 'powers
 DQBprint layer, CHR$(234), 216, 192, 8 - (gs.gd.doublejump * 4)
 DQBprint layer, CHR$(247), 224, 192, 8 - (gs.gd.waterwalk * 4)
 DQBprint layer, CHR$(8), 232, 192, 8 - (gs.gd.brickbreak * 4)

 SELECT CASE (gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave)
  CASE 0
   DQBget 3, 0, 32, 7, 39, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 3, 0, 32, 7, 39, layer, 224, 184
  CASE 1
   DQBget 3, 8, 32, 15, 39, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 3, 8, 32, 15, 39, layer, 224, 184
  CASE 2
   DQBget 3, 0, 40, 7, 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 3, 0, 40, 7, 47, layer, 224, 184
  CASE 3
   DQBget 3, 8, 40, 15, 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 3, 8, 40, 15, 47, layer, 224, 184
 END SELECT
 DQBfput layer, 224, 184, VARSEG(clearbox(0)), VARPTR(clearbox(0))

 'heart
 DQBprint layer, CHR$(3), 112, 192, 4
 UIUpdateHearts layer, gs

 'playerhp
 UIUpdatePlayerHP layer, gs

 'enemyhp
 UIUpdateEnemyHP layer, gs

END SUB

SUB UIDraw (layer AS INTEGER, gs AS GlobalState, clearbox() AS INTEGER)
 IF gs.ui.pendingsubweapon = 1 THEN
  gs.ui.pendingsubweapon = 0
  IF gs.gd.currentsubweapon > 0 THEN
   IF gs.ui.lastsubweapon > 0 THEN
    DQBboxf layer, 168 + (gs.ui.lastsubweapon * 8), 184, 168 + (gs.ui.lastsubweapon * 8) + 7, 191, 0
   END IF
   DQBprint layer, CHR$(31), 168 + (gs.gd.currentsubweapon * 8), 184, 8
   DQBget 3, 16 + (gs.gd.currentsubweapon * 16), 32, 31 + (gs.gd.currentsubweapon * 16), 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   DQBfput layer, 152, 184, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   'DQBxput 3, 16 + (gs.gd.currentsubweapon * 16), 32, 31 + (gs.gd.currentsubweapon * 16), 47, layer, 152, 184
   gs.ui.lastsubweapon = gs.gd.currentsubweapon
  END IF
  DQBprint layer, CHR$(27), 176, 192, 8 - (gs.gd.dagger * 4)
  DQBprint layer, CHR$(235), 184, 192, 8 - (gs.gd.holywater * 4)
  DQBprint layer, CHR$(29), 192, 192, 8 - (gs.gd.cross * 4)
  DQBprint layer, CHR$(231), 200, 192, 8 - (gs.gd.axe * 4)
 END IF
 IF gs.ui.pendingplayerhp = 1 THEN
  gs.ui.pendingplayerhp = 0
  UIUpdatePlayerHP layer, gs
 END IF
 IF gs.ui.pendinghearts = 1 THEN
  gs.ui.pendinghearts = 0
  UIUpdateHearts layer, gs
 END IF
 IF gs.ui.pendingenemyhp = 1 THEN
  gs.ui.pendingenemyhp = 0
  UIUpdateEnemyHP layer, gs
 END IF
 IF gs.ui.pendingpower = 1 THEN
  gs.ui.pendingpower = 0
  DQBprint layer, CHR$(234), 216, 192, 8 - (gs.gd.doublejump * 4)
  DQBprint layer, CHR$(247), 224, 192, 8 - (gs.gd.waterwalk * 4)
  DQBprint layer, CHR$(8), 232, 192, 8 - (gs.gd.brickbreak * 4)
 END IF
 IF gs.ui.pendingskull = 1 THEN
  gs.ui.pendingskull = 0
  SELECT CASE (gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave)
   CASE 0
    DQBget 3, 0, 32, 7, 39, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   CASE 1
    DQBget 3, 8, 32, 15, 39, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   CASE 2
    DQBget 3, 0, 40, 7, 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
   CASE 3
    DQBget 3, 8, 40, 15, 47, VARSEG(clearbox(0)), VARPTR(clearbox(0))
  END SELECT
  DQBfput layer, 224, 184, VARSEG(clearbox(0)), VARPTR(clearbox(0))
 END IF
 IF gs.ui.pendingwhip = 1 THEN
  gs.ui.pendingwhip = 0
  DQBprint layer, CHR$(236), 80, 184, 8 - (gs.gd.chainruins * 4) + (gs.gd.chainduck * 5)
  DQBprint layer, CHR$(236), 88, 184, 8 - (gs.gd.chaingrave * 4) + (gs.gd.chainduck * 5)
  DQBprint layer, CHR$(236), 96, 184, 8 - (gs.gd.chainforest * 4) + (gs.gd.chainduck * 5)
  DQBprint layer, CHR$(236), 104, 184, 8 - (gs.gd.chaincave * 4) + (gs.gd.chainduck * 5)
 END IF
 IF gs.ui.pendinggem = 1 THEN
  gs.ui.pendinggem = 0
  DQBprint layer, CHR$(4), 112, 184, 8 - (gs.gd.gemruins * 4)
  DQBprint layer, CHR$(4), 120, 184, 8 - (gs.gd.gemgrave * 4)
  DQBprint layer, CHR$(4), 128, 184, 8 - (gs.gd.gemforest * 4)
  DQBprint layer, CHR$(4), 136, 184, 8 - (gs.gd.gemcave * 4)
 END IF
END SUB

SUB UIUpdateEnemyHP (layer AS INTEGER, gs AS GlobalState)
 IF gs.enemyhp = 0 THEN
  DQBboxf layer, 248, 192, 311, 199, 0
  DQBprint layer, STRING$(8, 176), 248, 192, 5
 ELSEIF gs.enemyhp < gs.enemymaxhp AND gs.enemyhp > 0 THEN
  DQBboxf layer, 248, 192, 311, 199, 0
  'enemyhpbars = (8 / enemymaxhp) * enemyhp
  'IF enemyhpbars < 1 THEN enemyhpbars = 1
  DQBprint layer, STRING$(gs.enemyhp, 219) + STRING$(8 - gs.enemyhp, 176), 248, 192, 5
 ELSE
  DQBprint layer, STRING$(8, 219), 248, 192, 5
 END IF
END SUB

SUB UIUpdateHearts (layer AS INTEGER, gs AS GlobalState)
 DQBboxf layer, 120, 192, 142, 199, 0
 IF gs.gd.hearts < 10 THEN
  DQBprint layer, "00" + MID$(STR$(gs.gd.hearts), 2, 1), 120, 192, 15
 ELSEIF gs.gd.hearts < 100 THEN
  DQBprint layer, "0" + MID$(STR$(gs.gd.hearts), 2, 2), 120, 192, 15
 ELSE
  DQBprint layer, MID$(STR$(gs.gd.hearts), 2, 3), 120, 192, 15
 END IF
END SUB

SUB UIUpdatePlayerHP (layer AS INTEGER, gs AS GlobalState)
 gs.pl.maxhp = 4 + gs.gd.gemruins + gs.gd.gemgrave + gs.gd.gemforest + gs.gd.gemcave
 IF gs.pl.hp < gs.pl.maxhp THEN
  DQBboxf layer, 8, 192, 8 + (8 * gs.pl.maxhp) - 1, 199, 0
  DQBprint layer, STRING$(gs.pl.hp, 219) + STRING$(gs.pl.maxhp - gs.pl.hp, 176), 8, 192, 5
 ELSE
  DQBprint layer, STRING$(gs.pl.hp, 219), 8, 192, 5
 END IF
 'debug = STR$(gs.pl.hp)
END SUB

FUNCTION ScanCode2Char$ (k AS INTEGER)
 SELECT CASE k
  CASE &H1
   ScanCode2Char$ = "ESC"
  CASE &H2
   ScanCode2Char$ = "1"
  CASE &H3
   ScanCode2Char$ = "2"
  CASE &H4
   ScanCode2Char$ = "3"
  CASE &H5
   ScanCode2Char$ = "4"
  CASE &H6
   ScanCode2Char$ = "5"
  CASE &H7
   ScanCode2Char$ = "6"
  CASE &H8
   ScanCode2Char$ = "7"
  CASE &H9
   ScanCode2Char$ = "8"
  CASE &HA
   ScanCode2Char$ = "9"
  CASE &HB
   ScanCode2Char$ = "0"
  CASE &HC
   ScanCode2Char$ = "-"
  CASE &HD
   ScanCode2Char$ = "="
  CASE &HE
   ScanCode2Char$ = "BKSPACE"
  CASE &HF
   ScanCode2Char$ = "TAB"
  CASE &H10
   ScanCode2Char$ = "Q"
  CASE &H11
   ScanCode2Char$ = "W"
  CASE &H12
   ScanCode2Char$ = "E"
  CASE &H13
   ScanCode2Char$ = "R"
  CASE &H14
   ScanCode2Char$ = "T"
  CASE &H15
   ScanCode2Char$ = "Y"
  CASE &H16
   ScanCode2Char$ = "U"
  CASE &H17
   ScanCode2Char$ = "I"
  CASE &H18
   ScanCode2Char$ = "O"
  CASE &H19
   ScanCode2Char$ = "P"
  CASE &H1A
   ScanCode2Char$ = "["
  CASE &H1B
   ScanCode2Char$ = "]"
  CASE &H1C
   ScanCode2Char$ = "ENTER"
  CASE &H1D
   ScanCode2Char$ = "CTRL"
  CASE &H1E
   ScanCode2Char$ = "A"
  CASE &H1F
   ScanCode2Char$ = "S"
  CASE &H20
   ScanCode2Char$ = "D"
  CASE &H21
   ScanCode2Char$ = "F"
  CASE &H22
   ScanCode2Char$ = "G"
  CASE &H23
   ScanCode2Char$ = "H"
  CASE &H24
   ScanCode2Char$ = "J"
  CASE &H25
   ScanCode2Char$ = "K"
  CASE &H26
   ScanCode2Char$ = "L"
  CASE &H27
   ScanCode2Char$ = ";"
  CASE &H28
   ScanCode2Char$ = CHR$(34)
  CASE &H29
   ScanCode2Char$ = "`"
  CASE &H2A
   ScanCode2Char$ = "LSHIFT"
  CASE &H2B
   ScanCode2Char$ = "\"
  CASE &H2C
   ScanCode2Char$ = "Z"
  CASE &H2D
   ScanCode2Char$ = "X"
  CASE &H2E
   ScanCode2Char$ = "C"
  CASE &H2F
   ScanCode2Char$ = "V"
  CASE &H30
   ScanCode2Char$ = "B"
  CASE &H31
   ScanCode2Char$ = "N"
  CASE &H32
   ScanCode2Char$ = "M"
  CASE &H33
   ScanCode2Char$ = ","
  CASE &H34
   ScanCode2Char$ = "."
  CASE &H35
   ScanCode2Char$ = "/"
  CASE &H36
   ScanCode2Char$ = "RSHIFT"
  CASE &H37
   ScanCode2Char$ = "PRTSC"
  CASE &H38
   ScanCode2Char$ = "ALT"
  CASE &H39
   ScanCode2Char$ = "SPACE"
  CASE &H3A
   ScanCode2Char$ = "CAPSLOCK"
  CASE &H3B
   ScanCode2Char$ = "F1"
  CASE &H3C
   ScanCode2Char$ = "F2"
  CASE &H3D
   ScanCode2Char$ = "F3"
  CASE &H3E
   ScanCode2Char$ = "F4"
  CASE &H3F
   ScanCode2Char$ = "F5"
  CASE &H40
   ScanCode2Char$ = "F6"
  CASE &H41
   ScanCode2Char$ = "F7"
  CASE &H42
   ScanCode2Char$ = "F8"
  CASE &H43
   ScanCode2Char$ = "F9"
  CASE &H44
   ScanCode2Char$ = "F10"
  CASE &H45
   ScanCode2Char$ = "NUMLOCK"
  CASE &H46
   ScanCode2Char$ = "SCRLOCK"
  CASE &H47
   ScanCode2Char$ = "HOME"
  CASE &H48
   ScanCode2Char$ = "UP"
  CASE &H49
   ScanCode2Char$ = "PGUP"
  CASE &H4A
   ScanCode2Char$ = "NP -"
  CASE &H4B
   ScanCode2Char$ = "LEFT"
  CASE &H4C
   ScanCode2Char$ = "NP 5"
  CASE &H4D
   ScanCode2Char$ = "RIGHT"
  CASE &H4E
   ScanCode2Char$ = "NP +"
  CASE &H4F
   ScanCode2Char$ = "END"
  CASE &H50
   ScanCode2Char$ = "DOWN"
  CASE &H51
   ScanCode2Char$ = "PGDN"
  CASE &H52
   ScanCode2Char$ = "INS"
  CASE &H53
   ScanCode2Char$ = "DEL"
 END SELECT
END FUNCTION

SUB OptionDraw (gs AS GlobalState)
 PRINT " High Effort Option Menu"
 PRINT " v240624_1724"
 PRINT ""
 PRINT " CONTROLS"
 PRINT "  1. UP              - " + ScanCode2Char(gs.gp.kup)
 PRINT "  2. DOWN            - " + ScanCode2Char(gs.gp.kdown)
 PRINT "  3. LEFT            - " + ScanCode2Char(gs.gp.kleft)
 PRINT "  4. RIGHT           - " + ScanCode2Char(gs.gp.kright)
 PRINT "  5. JUMP            - " + ScanCode2Char(gs.gp.kb0)
 PRINT "  6. ATTACK          - " + ScanCode2Char(gs.gp.kb1)
 PRINT "  7. THROW SUBWEAPON - " + ScanCode2Char(gs.gp.kb2)
 PRINT "  8. SWAP SUBWEAPON  - " + ScanCode2Char(gs.gp.kselect)
 PRINT "  9. PAUSE           - " + ScanCode2Char(gs.gp.kstart)
 PRINT " 10. RESTORE DEFAULTS"
 PRINT ""
 IF gs.gp.sfx THEN
 PRINT " 11. SFX          - ON"
 ELSE
 PRINT " 11. SFX          - OFF"
 END IF
 IF gs.gp.mfx THEN
 PRINT " 12. MFX          - ON"
 ELSE
 PRINT " 12. MFX          - OFF"
 END IF
 IF gs.gp.drawlayer = VIDEO THEN
 PRINT " 13. DOUBLEBUFFER - OFF"
 ELSE
 PRINT " 13. DOUBLEBUFFER - ON"
 END IF
 PRINT ""
 PRINT " 99. EXIT"
 PRINT ""
END SUB

SUB OptionKeyInput (gs AS GlobalState, gpk AS INTEGER)
  lk = 0
  DO
   gpk = INP(&H60)
  LOOP WHILE gpk < 128
  DO
   gpk = INP(&H60)
   IF gpk < 128 THEN
    lk = 1
   END IF
  LOOP WHILE lk = 0
  DO WHILE INKEY$ <> "": LOOP
END SUB

SUB OptionUpdate (gs AS GlobalState, selected AS INTEGER)
 INPUT " Input Option #", selected
 SELECT CASE selected
  CASE 1
   PRINT " Input Key for UP"
   OptionKeyInput gs, gs.gp.kup
  CASE 2
   PRINT " Input Key for DOWN"
   OptionKeyInput gs, gs.gp.kdown
  CASE 3
   PRINT " Input Key for LEFT"
   OptionKeyInput gs, gs.gp.kleft
  CASE 4
   PRINT " Input Key for RIGHT"
   OptionKeyInput gs, gs.gp.kright
  CASE 5
   PRINT " Input Key for JUMP"
   OptionKeyInput gs, gs.gp.kb0
  CASE 6
   PRINT " Input Key for ATTACK"
   OptionKeyInput gs, gs.gp.kb1
  CASE 7
   PRINT " Input Key for THROW SUBWEAPON"
   OptionKeyInput gs, gs.gp.kb2
  CASE 8
   PRINT " Input Key for SWAP SUBWEAPON"
   OptionKeyInput gs, gs.gp.kselect
  CASE 9
   PRINT " Input Key for PAUSE"
   OptionKeyInput gs, gs.gp.kstart
  CASE 10
   gs.gp.kleft = &H4B
   gs.gp.kright = &H4D
   gs.gp.kup = &H48
   gs.gp.kdown = &H50
   gs.gp.kb0 = &H2C
   gs.gp.kb1 = &H2D
   gs.gp.kb2 = &H2E
   gs.gp.kstart = &H1C
   gs.gp.kselect = &H20
  CASE 11
   IF gs.gp.sfx THEN gs.gp.sfx = 0 ELSE gs.gp.sfx = 1
  CASE 12
   IF gs.gp.mfx THEN gs.gp.mfx = 0 ELSE gs.gp.mfx = 1
  CASE 13
   IF gs.gp.drawlayer = VIDEO THEN gs.gp.drawlayer = 2 ELSE gs.gp.drawlayer = VIDEO
  CASE 14
   'save options
 END SELECT
 
END SUB

SUB SaveMenuUpdate (gs AS GlobalState, savemenu AS SaveMenuType, clearbox() as integer, voices() as integer, sounds() as integer)
 IF savemenu.shifting = 1 THEN
  IF TmrTick(savemenu.tmr) THEN
   SELECT CASE savemenu.tmr.frame
    CASE 0
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + (savemenu.tmr.frame * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(186), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 1
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + ((savemenu.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(198) + STRING$(1, 205) + CHR$(181), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 2, 3, 4, 5
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + ((savemenu.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(198) + STRING$(savemenu.tmr.frame * 2, 205) + CHR$(181), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 6
     DQBboxf gs.gp.drawlayer, 156 - (5 * 8), 84 - 8, 163 + (6 * 8), 84 + 7 + 8, 0
     DQBprint gs.gp.drawlayer, CHR$(201) + STRING$(10, 205) + CHR$(187), 156 - (5 * 8), 84 - 8, 8
     DQBprint gs.gp.drawlayer, CHR$(186) + STRING$(10, 32) + CHR$(186), 156 - (5 * 8), 84, 8
     DQBprint gs.gp.drawlayer, CHR$(200) + STRING$(10, 205) + CHR$(188), 156 - (5 * 8), 84 + 8, 8
    CASE 7
     DQBboxf gs.gp.drawlayer, 156 - (5 * 8), 84 - 16, 163 + (6 * 8), 84 + 7 + 16, 0
     DQBprint gs.gp.drawlayer, CHR$(201) + STRING$(10, 205) + CHR$(187), 156 - (5 * 8), 84 - 16, 8
     DQBprint gs.gp.drawlayer, CHR$(186) + STRING$(10, 32) + CHR$(186), 156 - (5 * 8), 84 - 8, 8
     DQBprint gs.gp.drawlayer, "SAVE GAME?", 156 - (4 * 8), 84 - 8, 7
     DQBprint gs.gp.drawlayer, CHR$(186) + STRING$(10, 32) + CHR$(186), 156 - (5 * 8), 84, 8
     DQBprint gs.gp.drawlayer, CHR$(186) + " YES  NO  " + CHR$(186), 156 - (5 * 8), 84 + 8, 8
     DQBprint gs.gp.drawlayer, CHR$(200) + STRING$(10, 205) + CHR$(188), 156 - (5 * 8), 84 + 16, 8
     DQBprint gs.gp.drawlayer, CHR$(16), 124 + (savemenu.xpos * 40), 92, 7
     savemenu.shifting = 0
   END SELECT
   savemenu.tmr.frame = savemenu.tmr.frame + 1
  END IF
 ELSEIF savemenu.shifting = -1 THEN
  IF TmrTick(savemenu.tmr) THEN
   SELECT CASE savemenu.tmr.frame
    CASE -1
     DQBget 1, 156, 84, 163, 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156, 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     gs.scenechange = 0
     savemenu.active = 0
    CASE 0
     DQBget 1, 156 - ((savemenu.tmr.frame + 1) * 8), 84, 163 + ((savemenu.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156 - ((savemenu.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))

     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + (savemenu.tmr.frame * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(186), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 1
     DQBget 1, 156 - ((savemenu.tmr.frame + 1) * 8), 84, 163 + ((savemenu.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156 - ((savemenu.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
    
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + ((savemenu.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(198) + STRING$(1, 205) + CHR$(181), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 2, 3, 4
     DQBget 1, 156 - ((savemenu.tmr.frame + 1) * 8), 84, 163 + ((savemenu.tmr.frame + 2) * 8), 84 + 7, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156 - ((savemenu.tmr.frame + 1) * 8), 84, VARSEG(clearbox(0)), VARPTR(clearbox(0))
    
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + ((savemenu.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(198) + STRING$(savemenu.tmr.frame * 2, 205) + CHR$(181), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 5
     DQBget 1, 156 - (5 * 8), 84 - 8, 163 + (6 * 8), 84 + 7 + 8, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156 - (5 * 8), 84 - 8, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBboxf gs.gp.drawlayer, 156 - (savemenu.tmr.frame * 8), 84, 163 + ((savemenu.tmr.frame + 1) * 8), 84 + 7, 0
     DQBprint gs.gp.drawlayer, CHR$(198) + STRING$(savemenu.tmr.frame * 2, 205) + CHR$(181), 156 - (savemenu.tmr.frame * 8), 84, 8
    CASE 6
     DQBget 1, 156 - (5 * 8), 84 - 16, 163 + (6 * 8), 84 + 7 + 16, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBfput gs.gp.drawlayer, 156 - (5 * 8), 84 - 16, VARSEG(clearbox(0)), VARPTR(clearbox(0))
     DQBboxf gs.gp.drawlayer, 156 - (5 * 8), 84 - 8, 163 + (6 * 8), 84 + 7 + 8, 0
     DQBprint gs.gp.drawlayer, CHR$(201) + STRING$(10, 205) + CHR$(187), 156 - (5 * 8), 84 - 8, 8
     DQBprint gs.gp.drawlayer, CHR$(186) + STRING$(10, 32) + CHR$(186), 156 - (5 * 8), 84, 8
     DQBprint gs.gp.drawlayer, CHR$(200) + STRING$(10, 205) + CHR$(188), 156 - (5 * 8), 84 + 8, 8
   END SELECT
   savemenu.tmr.frame = savemenu.tmr.frame - 1
  END IF
 ELSE
  'inputhandling
  IF gs.sRight = 2 OR gs.sLeft = 2 THEN
   DQBboxf gs.gp.drawlayer, 124 + (savemenu.xpos * 40), 92, 131 + (savemenu.xpos * 40), 99, 0
   IF savemenu.xpos = 0 THEN savemenu.xpos = 1 ELSE savemenu.xpos = 0
   DQBprint gs.gp.drawlayer, CHR$(16), 124 + (savemenu.xpos * 40), 92, 7
   PlaySound 7,22050,gs,voices(),sounds()
  END IF
  IF gs.sB0 = 2 OR gs.sB1 = 2 THEN
   IF savemenu.xpos = 0 THEN
    gs.gp.loaded=1
    gs.gd.savemap = gs.gd.currentmap
    DEF SEG = VARSEG(gs.gd)
    BSAVE "data/save.dat", VARPTR(gs.gd), 62'GAMEDATABYTES
    DEF SEG
	PlaySound 9,22050,gs,voices(),sounds()
   ELSE
    'dontsave
	PlaySound 7,22050,gs,voices(),sounds()
   END IF
   savemenu.shifting = -1
   savemenu.tmr.frame = 6
  END IF
 END IF
END SUB

SUB PollKB (gs AS GlobalState)
 IF DQBkey(gs.gp.kLeft) THEN
  IF gs.sLeft = 0 THEN
   gs.sLeft = 2
   IF gs.sRight > 0 THEN gs.sRight = -1
  ELSEIF gs.sLeft = 2 THEN
   gs.sLeft = 1
  END IF
 ELSE
  gs.sLeft = 0
  IF gs.sRight < 0 THEN gs.sRight = 1
 END IF
 IF DQBkey(gs.gp.kRight) THEN
  IF gs.sRight = 0 THEN
   gs.sRight = 2
   IF gs.sLeft > 0 THEN gs.sLeft = -1
  ELSEIF gs.sRight = 2 THEN
   gs.sRight = 1
  END IF
 ELSE
  gs.sRight = 0
  IF gs.sLeft < 0 THEN gs.sLeft = 1
 END IF
 IF DQBkey(gs.gp.kUp) THEN
  IF gs.sUp = 0 THEN
   gs.sUp = 2
   IF gs.sDown > 0 THEN gs.sDown = -1
  ELSEIF gs.sUp = 2 THEN
   gs.sUp = 1
  END IF
 ELSE
  gs.sUp = 0
  IF gs.sDown < 0 THEN gs.sDown = 1
 END IF
 IF DQBkey(gs.gp.kDown) THEN
  IF gs.sDown = 0 THEN
   gs.sDown = 2
   IF gs.sUp > 0 THEN gs.sUp = -1
  ELSEIF gs.sDown = 2 THEN
   gs.sDown = 1
  END IF
 ELSE
  gs.sDown = 0
  IF gs.sUp < 0 THEN gs.sUp = 1
 END IF

 IF DQBkey(gs.gp.kB0) THEN
  IF gs.sB0 = 0 THEN gs.sB0 = 2 ELSE gs.sB0 = 1
 ELSE
  gs.sB0 = 0
 END IF
 IF DQBkey(gs.gp.kB1) THEN
  IF gs.sB1 = 0 THEN gs.sB1 = 2 ELSE gs.sB1 = 1
 ELSE
  gs.sB1 = 0
 END IF
 IF DQBkey(gs.gp.kB2) THEN
  IF gs.sB2 = 0 THEN gs.sB2 = 2 ELSE gs.sB2 = 1
 ELSE
  gs.sB2 = 0
 END IF
 IF DQBkey(gs.gp.kStart) THEN
  IF gs.sStart = 0 THEN gs.sStart = 2 ELSE gs.sStart = 1
 ELSE
  gs.sStart = 0
 END IF
 IF DQBkey(gs.gp.kSelect) THEN
  IF gs.sSelect = 0 THEN gs.sSelect = 2 ELSE gs.sSelect = 1
 ELSE
  gs.sSelect = 0
 END IF

END SUB

SUB PlaySound (s AS INTEGER, lf AS INTEGER, gs AS GlobalState, voices() AS INTEGER, sounds() AS INTEGER)
 IF gs.gp.sfx = 0 THEN EXIT SUB
 IF voices(sounds(s)) = s AND DQBinUse(sounds(s)) THEN DQBstopVoice sounds(s)
 DQBplaySound s + 1, gs.cVoice + 1, RandomRange(lf, 22050), ONCE
 sounds(s) = gs.cVoice
 voices(gs.cVoice) = s
 gs.cVoice = gs.cVoice + 1
 IF gs.cVoice >= gs.tVoices THEN gs.cVoice = 0
END SUB

SUB TitlePalSwaps (pal as integer)
 SELECT CASE (pal)
  CASE 0
   OUT &H3C8, 245
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 246
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 247
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 248
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 249
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 250
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 251
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 252
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 5
   OUT &H3C8, 250
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 251
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 10
   OUT &H3C8, 250
   OUT &H3C9, 42
   OUT &H3C9, 21
   OUT &H3C9, 0
   OUT &H3C8, 251
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 252
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 15
   OUT &H3C8, 250
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C8, 251
   OUT &H3C9, 42
   OUT &H3C9, 21
   OUT &H3C9, 0
   OUT &H3C8, 252
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 253
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 20
   OUT &H3C8, 250
   OUT &H3C9, 63
   OUT &H3C9, 63
   OUT &H3C9, 21
   OUT &H3C8, 251
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C8, 252
   OUT &H3C9, 42
   OUT &H3C9, 21
   OUT &H3C9, 0
   OUT &H3C8, 253
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C8, 254
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 25
   OUT &H3C8, 249
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 250
   OUT &H3C9, 63
   OUT &H3C9, 63
   OUT &H3C9, 63
   OUT &H3C8, 251
   OUT &H3C9, 63
   OUT &H3C9, 63
   OUT &H3C9, 21
   OUT &H3C8, 252
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C8, 253
   OUT &H3C9, 42
   OUT &H3C9, 21
   OUT &H3C9, 0
   OUT &H3C8, 254
   OUT &H3C9, 21
   OUT &H3C9, 21
   OUT &H3C9, 21
  CASE 30
   OUT &H3C8, 248
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 249
   OUT &H3C9, 42
   OUT &H3C9, 0
   OUT &H3C9, 42
  CASE 35
   OUT &H3C8, 247
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 248
   OUT &H3C9, 42
   OUT &H3C9, 0
   OUT &H3C9, 42
   OUT &H3C8, 249
   OUT &H3C9, 42
   OUT &H3C9, 0
   OUT &H3C9, 0
  CASE 40
   OUT &H3C8, 245
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 246
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C8, 247
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 42
  CASE 45
   OUT &H3C8, 245
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C9, 42
   OUT &H3C8, 246
   OUT &H3C9, 63
   OUT &H3C9, 63
   OUT &H3C9, 21
 END SELECT
END SUB

sub EndingUpdate (rollout as integer)
 select case rollout
  case 5 to 14
   DQBPrint VIDEO,mid$("EPISODE 1:",rollout-4,1),120+((rollout-5)*8),8,7
  case 15 to 37
   DQBPrint VIDEO,mid$("COMMON WOODLAND GRACULA",rollout-14,1),64+((rollout-15)*8),16,4
  case 50 to 83
   DQBPrint VIDEO,mid$("WITHOUT THE WICKED HEARTS OF MEN,",rollout-49,1),8+((rollout-50)*8),32,7
  case 84 to 119
   DQBPrint VIDEO,mid$("LITTLE REMAINED TO SUSTAIN THE ONCE",rollout-83,1),8+((rollout-84)*8),40,7
  case 120 to 157
   DQBPrint VIDEO,mid$("FEARED PRINCE OF DARKNESS. WITH THEIR",rollout-119,1),8+((rollout-120)*8),48,7
  case 158 to 193
   DQBPrint VIDEO,mid$("DEFEAT, THE LINGERING FRAGMENTS OF",rollout-157,1),8+((rollout-158)*8),56,7
  case 194 to 230
   DQBPrint VIDEO,mid$("THIS FALLEN CIVILIZATION MAY FINALLY",rollout-193,1),8+((rollout-194)*8),64,7
  case 231 to 267
   DQBPrint VIDEO,mid$("BE ABLE TO REST IN PEACE. AFTER ALL,",rollout-230,1),8+((rollout-231)*8),72,7
  case 268 to 303
   DQBPrint VIDEO,mid$("THE NEW WORLD YET SHELTERS DEVILS OF",rollout-267,1),8+((rollout-268)*8),80,7
  case 304 to 314
   DQBPrint VIDEO,mid$("ITS OWN...",rollout-303,1),8+((rollout-304)*8),88,7
  case 350 to 380
   DQBPrint VIDEO,mid$("TO CONTINUE THE CASTLE GRACULA",rollout-349,1),8+((rollout-350)*8),104,7
  case 381 to 417
   DQBPrint VIDEO,mid$("EXPERIENCE, PLAY CROWS OF MURDER AND",rollout-380,1),8+((rollout-381)*8),112,7
  case 418 to 456
   DQBPrint VIDEO,mid$("ITS AMAZING SEQUEL, DOVES OF MOURNING!",rollout-417,1),8+((rollout-418)*8),120,7
  case 457
   rollout=-2
 end select
 rollout=rollout+1
end sub

sub CreditUpdate (rollout as integer)
 select case rollout
  case 0
   DQBPrint VIDEO,"ANZU CASTLE GRACULA",76,8,4
  case 1
   DQBPrint VIDEO,"GAME BY: RAINBOWCEMETERY",8,24,7
  case 2
   DQBPrint VIDEO,"THANKS:",8,40,7
  case 3
   DQBPrint VIDEO,"DIRECTQB LIBRARY - ANGELO MOTTOLA",8,48,7
  case 4
   DQBPrint VIDEO,"QMIDI LIBRARY - JESSE DORLAND",8,56,7
  case 5
   DQBPrint VIDEO,"WWW.PETESQBSITE.COM",8,64,7
  case 6
   DQBPrint VIDEO,"PATRONS AND FRIENDS",8,80,7
  case 7
   DQBPrint VIDEO,"AND YOU!!!",8,96,7
  case 8
   rollout=-2
 end select
 rollout=rollout+1
end sub

sub PatronDraw
 DQBClearLayer VIDEO
 DQBprint VIDEO, CHR$(1) + " PATRONS " + CHR$(1), 120, 8, 7

 DQBprint VIDEO, "BAGEL", 17 * 8, 24, 14
 DQBprint VIDEO, "DANIEL", 17 * 8, 32, 14
 DQBprint VIDEO, "ALEXANDER MCCLELLAND", 80, 40, 14
 DQBprint VIDEO, "ICARUS", 17 * 8, 48, 14
 DQBprint VIDEO, "DIETING HIPPO", 14 * 8, 56, 7
 DQBprint VIDEO, "XARIS LYNN", 15 * 8, 64, 7
 DQBprint VIDEO, "TALKING SOUP", 14 * 8, 72, 7
 DQBprint VIDEO, "SWIRL", 17 * 8, 80, 7
 DQBprint VIDEO, "ARROW ONIONBELLY", 12 * 8, 88, 7

 DQBprint VIDEO, CHR$(3) + " THANKS FOR YOUR SUPPORT " + CHR$(3), 7 * 8, 104, 7

 DQBprint VIDEO, "PRESS THE " + CHR$(34) + "ANY" + CHR$(34) + " KEY TO CONTINUE", 5 * 8, 176, 7
end sub