defint a-z


TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

Type UpPromptType
 active as integer
 pendinginactive as integer
 x as integer
 lastx as integer
 y as integer
 lasty as integer
 tmr as TTmr
end type

TYPE Tile
 id AS INTEGER
 solid AS INTEGER
 breakable AS INTEGER
 deadly AS INTEGER
 teleport AS INTEGER
 stair AS INTEGER
 platform AS INTEGER
 interact AS INTEGER
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 obj AS INTEGER
END TYPE

TYPE ItemDescType
 active AS INTEGER
 shifting AS INTEGER
 id AS INTEGER
 tmr AS TTmr
END TYPE

TYPE AniFrame
 offset AS INTEGER
 x AS INTEGER
 y AS INTEGER
 w AS INTEGER
 h AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub AS INTEGER
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing AS INTEGER
 duckthrowing AS INTEGER
 backflip AS INTEGER
 platformcheck AS INTEGER
END TYPE

TYPE SubWeapon
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 index AS INTEGER
 dmg AS INTEGER
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 hitbox AS Rect
 check AS INTEGER
 tmr AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 redraw AS INTEGER
 noclear AS INTEGER
 ani AS Animator
 fliph AS INTEGER
 scalex AS INTEGER
 ontile AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 yforce AS INTEGER
 tilehit AS INTEGER
 speed AS INTEGER
 pswapclip AS INTEGER
 pcliploop AS INTEGER
 ptmrreset AS INTEGER
 pplayerhit AS INTEGER
 ptileat AS INTEGER
 psolidcheck AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull AS INTEGER
 pendingpower AS INTEGER
 pendinggem AS INTEGER
 pendingwhip AS INTEGER
END TYPE

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns AS INTEGER
 spawnid AS INTEGER
 westspawny AS INTEGER
 eastspawny AS INTEGER
END TYPE

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

DECLARE SUB TmrReset (tmr AS TTmr, delay AS INTEGER)
DECLARE SUB AniSwapClip (ani AS Animator, clip AS AniClip, looping AS INTEGER, drawframe AS INTEGER)
DECLARE SUB AnimatorUpdate (ani AS Animator, drawframe AS INTEGER)
DECLARE SUB BGCollisionN (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionS (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, lasty AS INTEGER, platimmune AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionW (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGCollisionE (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGTileAt (xval AS INTEGER, yval AS INTEGER, tilehit AS INTEGER, gs AS GlobalState)
DECLARE SUB PlaySound (s AS INTEGER, lf AS INTEGER, gs AS GlobalState, voices() AS INTEGER, sounds() AS INTEGER)
DECLARE SUB DQBplaySound (BYVAL SoundNum%, BYVAL Voice%, BYVAL Freq%, BYVAL LoopFlag%)
DECLARE SUB SubWepSpawn (wep AS SubWeapon, id AS INTEGER, x AS INTEGER, y AS INTEGER, xdir AS INTEGER, pc() AS AniClip, gs AS GlobalState)
DECLARE SUB OpenDoor (gs AS GlobalState, clearbox() AS INTEGER)
declare SUB PlayerCollision (gs AS GlobalState, tiles() AS Tile, playerclips() AS AniClip, voices() AS INTEGER, sounds() AS INTEGER)
declare SUB PlayerStruck (dmg AS INTEGER, hitx AS INTEGER, gs AS GlobalState, playerclips() AS AniClip, voices() AS INTEGER, sounds() AS INTEGER)

SUB PlayerCollision (gs AS GlobalState, tiles() AS Tile, playerclips() AS AniClip, voices() AS INTEGER, sounds() AS INTEGER)
 yoffset = gs.pl.y - gs.pl.ly

 IF gs.pl.stairimmune > 0 THEN
  
  BGTileAt gs.pl.x + 6, gs.pl.ly + 12, gs.pl.tilehit, gs
  gs.pl.hitsolid = tiles(gs.pl.tilehit).solid
  BGTileAt gs.pl.x + 6, gs.pl.ly + 23, gs.pl.tilehit, gs
  gs.pl.hitsolid = gs.pl.hitsolid + tiles(gs.pl.tilehit).solid
  BGTileAt gs.pl.x + 6, gs.pl.ly + 4, gs.pl.tilehit, gs
  gs.pl.hitsolid = gs.pl.hitsolid + tiles(gs.pl.tilehit).solid
  IF gs.pl.hitsolid = 0 THEN gs.pl.stairimmune = 0
 
  BGTileAt gs.pl.x + 16, gs.pl.ly + 12, gs.pl.tilehit, gs
  gs.pl.hitsolid = tiles(gs.pl.tilehit).solid
  BGTileAt gs.pl.x + 16, gs.pl.ly + 23, gs.pl.tilehit, gs
  gs.pl.hitsolid = gs.pl.hitsolid + tiles(gs.pl.tilehit).solid
  BGTileAt gs.pl.x + 16, gs.pl.ly + 4, gs.pl.tilehit, gs
  gs.pl.hitsolid = gs.pl.hitsolid + tiles(gs.pl.tilehit).solid
  IF gs.pl.hitsolid = 0 THEN gs.pl.stairimmune = 0

  gs.pl.x = gs.pl.lx
  'IF gs.pl.hitsolid = 0 THEN
  ' gs.pl.stairimmune = 0
   'debug = "stairimmune off"
  'ELSE
  ' gs.pl.x = gs.pl.lx
  'END IF
 END IF
 IF gs.pl.lx < gs.pl.x THEN
  IF gs.pl.jumping > 0 THEN
   BGCollisionE gs.pl.x, (gs.pl.y + 10), 16, gs.pl.tilehit, gs, tiles() 'was y+7 before stairs
   'BGCollisionE gs.pl.x, (gs.pl.y + 11), 16, gs.pl.tilehit
   BGCollisionE gs.pl.x, (gs.pl.y + 23 - yoffset), 16, gs.pl.tilehit, gs, tiles()
  ELSE
   BGCollisionE gs.pl.x, gs.pl.y + 1, 16, gs.pl.tilehit, gs, tiles()
   BGCollisionE gs.pl.x, (gs.pl.y + 23), 16, gs.pl.tilehit, gs, tiles()
  END IF
 ELSEIF gs.pl.lx > gs.pl.x THEN
  IF gs.pl.jumping > 0 THEN
   BGCollisionW gs.pl.x, (gs.pl.y + 10), 6, gs.pl.tilehit, gs, tiles()
   'BGCollisionW gs.pl.x, (gs.pl.y + 11), 6, gs.pl.tilehit
   BGCollisionW gs.pl.x, (gs.pl.y + 23 - yoffset), 6, gs.pl.tilehit, gs, tiles()
  ELSE
   BGCollisionW gs.pl.x, gs.pl.y + 1, 6, gs.pl.tilehit, gs, tiles()
   BGCollisionW gs.pl.x, (gs.pl.y + 23), 6, gs.pl.tilehit, gs, tiles()
  END IF
  'debug = STR$(gs.pl.tilehit)
 END IF

 IF gs.pl.ly > gs.pl.y THEN
  IF gs.pl.stairimmune = 0 THEN
   BGCollisionN (gs.pl.x + 7), gs.pl.y, 6, gs.pl.tilehit, gs, tiles()
   gs.pl.hitsolid = tiles(gs.pl.tilehit).solid
   BGCollisionN (gs.pl.x + 15), gs.pl.y, 6, gs.pl.tilehit, gs, tiles()
   IF tiles(gs.pl.tilehit).solid > 0 OR gs.pl.hitsolid > 0 THEN
    gs.pl.yforce = 0
    gs.pl.suby = 0
   END IF
  END IF
 ELSEIF gs.pl.y > gs.pl.stairimmune OR gs.pl.stairimmune = 0 THEN
  gs.pl.platformcheck = 0
  BGCollisionS (gs.pl.x + 7), gs.pl.y, 24, gs.pl.ly, gs.pl.platimmune, gs.pl.tilehit, gs, tiles()
  gs.pl.hitsolid = tiles(gs.pl.tilehit).solid
  IF gs.pl.tilehit >= 20 THEN gs.pl.ontile = gs.pl.tilehit - 20
  BGCollisionS (gs.pl.x + 15), gs.pl.y, 24, gs.pl.ly, gs.pl.platimmune, gs.pl.tilehit, gs, tiles()
  IF tiles(gs.pl.tilehit).solid > 0 OR gs.pl.hitsolid > 0 OR (gs.pl.platformcheck > 0 AND gs.pl.platimmune <= 0) THEN
   gs.pl.suby = 0
   gs.pl.jumping = 0
   gs.pl.hurting = 0
   gs.pl.backflip = 0
   gs.pl.coyote = 8
   'debug = "onground"
   'debug = STR$(gs.pl.tilehit)
  ELSE
   IF gs.pl.jumping = 0 THEN
    'IF gs.pl.coyote > 0 THEN
    ' gs.pl.coyote = gs.pl.coyote - 1
    'ELSE
     'debug = "onair"
     gs.pl.yforce = 0
     gs.pl.jumping = 1
    'END IF
   END IF
  END IF
  IF tiles(gs.pl.tilehit).deadly > 1 THEN
   PlayerStruck 999, gs.pl.x + 10 + gs.pl.scalex, gs, playerclips(), voices(), sounds()
  END IF
 END IF
END SUB

SUB PlayerStart (gs AS GlobalState, playerclips() AS AniClip)
'set/reset starting vars
 gs.pl.jforce = 240
 gs.pl.gravity = 12
 gs.pl.fliph = 0
 gs.pl.scalex = 1
 gs.pl.x = 48
 gs.pl.y = 136
 gs.pl.dx = 48
 gs.pl.dy = 136
 gs.pl.lx = 48
 gs.pl.ly = 136
 gs.pl.subx = 0
 gs.pl.suby = 0
 gs.pl.speed = 60
 gs.pl.jumping = 0
 gs.pl.attacking = 0
 gs.pl.ducking = 0
 gs.pl.moving = 0
 gs.pl.pendingani = 0
 gs.pl.ani.playing = FALSE
 gs.pl.ani.clip = playerclips(0)
 gs.pl.ani.looping = FALSE
 gs.pl.ani.frame = gs.pl.ani.clip.minframe
 gs.pl.drawframe = gs.pl.ani.frame
 gs.pl.clearframe = gs.pl.ani.frame
 gs.pl.whipframe = -1
 gs.pl.whiplastframe = -1
 gs.pl.whipbox.w = 23
 gs.pl.whipbox.h = 4
 gs.pl.onstair=0
 gs.pl.hurting=0
 gs.pl.yforce=0
 gs.pl.redraw = 1
 gs.pl.hitbox.x1 = -10
 gs.pl.hitbox.x2 = -5
 gs.pl.hitbox.y1 = -10
 gs.pl.hitbox.y2 = -5
 gs.pl.hp = 4 + gs.gd.gemruins + gs.gd.gemgrave + gs.gd.gemforest + gs.gd.gemcave
 gs.pl.maxhp = gs.pl.hp
 gs.pl.chains = gs.gd.chainruins + gs.gd.chainforest + gs.gd.chaincave + gs.gd.chaingrave
 gs.pl.teleported = 1
END SUB

SUB PlayerStruck (dmg AS INTEGER, hitx AS INTEGER, gs AS GlobalState, playerclips() AS AniClip, voices() AS INTEGER, sounds() AS INTEGER)
 IF gs.pl.iframe > 0 AND dmg < 999 THEN EXIT SUB
 gs.pl.iframe = 45
 IF gs.ss <= 0 THEN gs.ss = 1
 gs.pl.whipcheck = 0
 gs.pl.attacking = 0
 gs.pl.duckattacking = 0
 gs.pl.backflip = 0
 gs.pl.throwing = 0
 gs.pl.duckthrowing = 0
 gs.pl.ducking = 0
 gs.pl.jumping = 1
 gs.pl.yforce = gs.pl.jforce * .75
 gs.pl.hurting = 1
 gs.pl.onstair = 0
 gs.pl.tmrstun = 0
 gs.pl.hp = gs.pl.hp - dmg
 IF hitx > gs.pl.x + 10 THEN
  gs.pl.scalex = 1
  gs.pl.fliph = 0
 ELSE
  gs.pl.scalex = -1
  gs.pl.fliph = 1
 END IF
 'debug = STR$(gs.pl.hp)
 IF gs.pl.hp > 0 THEN
  PlaySound 5, 22050, gs, voices(), sounds()
 ELSE
  gs.pl.hp = 0
  AniSwapClip gs.pl.ani, playerclips(6), 0, gs.pl.drawframe
  gs.scenechange = 5'dead
  PlaySound 6, 22050, gs, voices(), sounds()
 END IF
 gs.ui.pendingplayerhp = 1
END SUB

SUB PlayerUANIMATRIX (gs AS GlobalState, playerclips() AS AniClip)
 IF gs.pl.tmrstun THEN EXIT SUB
 gs.pl.lx = gs.pl.x
 gs.pl.ly = gs.pl.y
 gs.pl.dx = gs.pl.x
 gs.pl.dy = gs.pl.y
 IF gs.pl.hurting THEN
  gs.pl.pendingani = 6'hurting
  gs.pl.pendingloop = 0
 ELSEIF gs.pl.duckattacking THEN
  IF gs.pl.jumping = 0 THEN gs.pl.ducking = 1
  gs.pl.pendingani = 4'duckattack
  gs.pl.pendingloop = 0
  IF gs.pl.ani.clip.id = 4 THEN
   IF gs.pl.ani.trigger = -1 THEN
    gs.pl.pendingani = 2
    gs.pl.duckattacking = 0
   END IF
  END IF
  gs.pl.dy = gs.pl.y + 4
 ELSEIF gs.pl.duckthrowing THEN
  IF gs.pl.jumping = 0 THEN gs.pl.ducking = 1
  gs.pl.pendingani = 14'duckthrow
  gs.pl.pendingloop = 0
  IF gs.pl.ani.clip.id = 14 THEN
   IF gs.pl.ani.trigger = 3 THEN
    gs.pl.ani.trigger = -9
    IF gs.gd.hearts > 0 THEN
     gs.gd.hearts = gs.gd.hearts - 1
     gs.ui.pendinghearts = 1
     SubWepSpawn gs.swep, gs.gd.currentsubweapon, gs.pl.x + 11 + (6 * gs.pl.scalex), gs.pl.y + 10, gs.pl.scalex, playerclips(), gs
    END IF
   ELSEIF gs.pl.ani.trigger = -1 THEN
    gs.pl.duckthrowing = 0
   END IF
  END IF
  gs.pl.dy = gs.pl.y + 4
 ELSEIF gs.pl.throwing THEN
  gs.pl.pendingani = 13'throw
  gs.pl.pendingloop = 0
  IF gs.pl.ani.clip.id = 13 THEN
   IF gs.pl.ani.trigger = 3 THEN
    gs.pl.ani.trigger = -9
    IF gs.gd.hearts > 0 THEN
     gs.gd.hearts = gs.gd.hearts - 1
     gs.ui.pendinghearts = 1
     SubWepSpawn gs.swep, gs.gd.currentsubweapon, gs.pl.x + 11 + (6 * gs.pl.scalex), gs.pl.y + 6, gs.pl.scalex, playerclips(), gs
    END IF
   ELSEIF gs.pl.ani.trigger = -1 THEN
    gs.pl.throwing = 0
   END IF
  END IF
 ELSEIF gs.pl.attacking THEN
  gs.pl.pendingani = 3'attack
  gs.pl.pendingloop = 0
  IF gs.pl.ani.clip.id = 3 THEN
   IF gs.pl.ani.trigger = -1 THEN
    gs.pl.attacking = 0
    gs.pl.pendingani = 0
    'gs.pl.whipframe = 0
   END IF
  END IF
  'IF gs.pl.jumping = 1 THEN
  ' gs.pl.dy = gs.pl.y + 4
  'END IF
 ELSEIF gs.pl.backflip = 1 THEN
  gs.pl.pendingani = 15
  gs.pl.pendingloop = 0
  IF gs.pl.ani.clip.id = 15 AND gs.pl.ani.trigger = -1 THEN
   gs.pl.backflip = -1
  END IF
 ELSEIF gs.pl.jumping OR gs.pl.ducking THEN
  gs.pl.dy = gs.pl.y + 4
  gs.pl.pendingani = 2 'duckjump
  gs.pl.pendingloop = 0
 ELSEIF gs.pl.moving THEN
  gs.pl.pendingani = 1 'move
  gs.pl.pendingloop = 1
 ELSE
  gs.pl.pendingani = 0 'idle
  gs.pl.pendingloop = 0
 END IF

 IF gs.pl.pendingani <> gs.pl.ani.clip.id THEN
  AniSwapClip gs.pl.ani, playerclips(gs.pl.pendingani), gs.pl.pendingloop, gs.pl.drawframe
 END IF


 AnimatorUpdate gs.pl.ani, gs.pl.drawframe
END SUB

SUB PlayerUCollision (gs AS GlobalState, tiles() AS Tile, playerclips() AS AniClip, voices() AS INTEGER, sounds() AS INTEGER)
 IF gs.pl.tmrstun THEN EXIT SUB
 IF gs.pl.onstair = 0 THEN
  'IF gs.pl.stairimmune > -1 THEN
  ' IF gs.pl.y + 32 < gs.pl.stairimmune THEN gs.pl.stairimmune = -1
  'END IF
  'IF gs.pl.stairimmune < 0 THEN
  PlayerCollision gs, tiles(), playerclips(), voices(), sounds()
 ELSE
  IF gs.pl.ly > gs.pl.y THEN
   BGTileAt (gs.pl.x + 9), gs.pl.y + 23, gs.pl.tilehit, gs
   IF tiles(gs.pl.tilehit).stair = 0 THEN
    BGTileAt (gs.pl.x + 9), gs.pl.y + 24, gs.pl.tilehit, gs
    IF tiles(gs.pl.tilehit).stair > 10 OR tiles(gs.pl.tilehit).stair < -10 THEN gs.pl.onstair = 0
   END IF
  ELSEIF gs.pl.ly < gs.pl.y THEN
   BGTileAt (gs.pl.x + 9), gs.pl.y + 24, gs.pl.tilehit, gs
   IF tiles(gs.pl.tilehit).stair <> 0 AND ABS(tiles(gs.pl.tilehit).stair) < 11 AND tiles(gs.pl.tilehit).solid > 0 THEN
    'BGTileAt (gs.pl.x + 9), gs.pl.y + 24, gs.pl.tilehit
    'IF tiles(gs.pl.tilehit).stair > 10 OR tiles(gs.pl.tilehit).stair < -10 THEN
    gs.pl.onstair = 0
   END IF
  END IF
 END IF
END SUB

SUB PlayerUOffsets (gs AS GlobalState, tiles() AS Tile, playerclips() AS AniClip, playerframes() AS AniFrame, upprompt as UpPromptType)
 IF gs.pl.tmrstun THEN EXIT SUB
 SELECT CASE playerframes(gs.pl.drawframe).imgnum
  CASE 1
   gs.pl.dy = gs.pl.y - 1
  CASE 3
   IF gs.pl.fliph = 0 THEN gs.pl.dx = gs.pl.x - 3 ELSE gs.pl.dx = gs.pl.x + 4
  CASE 5
   IF gs.pl.fliph = 0 THEN gs.pl.dx = gs.pl.x - 3 ELSE gs.pl.dx = gs.pl.x + 4
  CASE 11
   IF gs.pl.fliph = 0 THEN gs.pl.dx = gs.pl.x + 1 ELSE gs.pl.dx = gs.pl.x + 4
   gs.pl.dy = gs.pl.y + 1
  CASE 30
   IF gs.pl.fliph = 1 THEN gs.pl.dx = gs.pl.x + 4
  CASE 32
   IF gs.pl.fliph = 1 THEN gs.pl.dx = gs.pl.x + 4
 END SELECT

 IF gs.pl.ani.clip.id = 3 OR gs.pl.ani.clip.id = 4 THEN
   IF gs.pl.ani.subframe > 1 THEN
    SELECT CASE gs.pl.ani.subframe
     CASE 3
      gs.pl.whipframe = playerclips(5).minframe
      IF gs.pl.fliph = 0 THEN gs.pl.whipx = gs.pl.x + 20 ELSE gs.pl.whipx = gs.pl.x - 11
      gs.pl.whipy = gs.pl.dy + 1
     
      gs.pl.whipcheck = 1
      gs.pl.whipbox.x1 = gs.pl.whipx
      gs.pl.whipbox.y1 = gs.pl.whipy
      gs.pl.whipbox.x2 = gs.pl.whipx + 11
      gs.pl.whipbox.y2 = gs.pl.whipy + 10

     CASE 4, 5
      gs.pl.whipframe = playerclips(5).minframe + 1
	  gs.pl.whipy = gs.pl.dy + 9
      IF gs.pl.chains > 0 THEN
       IF gs.gd.chainduck > 0 AND gs.pl.ani.subframe = 5 THEN
	    gs.pl.whipframe = playerclips(7).minframe + gs.pl.chains + 4
	    gs.pl.whipy = gs.pl.dy + 7
       ELSE
	    gs.pl.whipframe = playerclips(7).minframe + gs.pl.chains - 1
       END IF
      ELSE
	   IF gs.gd.chainduck > 0 AND gs.pl.ani.subframe = 5 THEN
	    gs.pl.whipframe = playerclips(7).minframe + 4
	    gs.pl.whipy = gs.pl.dy + 7
       ELSE
        gs.pl.whipframe = playerclips(5).minframe + 1
	   end if
      END IF
      IF gs.pl.fliph = 0 THEN
       gs.pl.whipx = gs.pl.x + 20
      ELSE
       gs.pl.whipx = gs.pl.x - 22 - (gs.pl.chains * 3)
      END IF
     
      gs.pl.whipcheck = 1
      gs.pl.whipbox.x1 = gs.pl.whipx
      gs.pl.whipbox.y1 = gs.pl.whipy
      gs.pl.whipbox.x2 = gs.pl.whipx + gs.pl.whipbox.w + (gs.pl.chains * 3)
      gs.pl.whipbox.y2 = gs.pl.whipy + gs.pl.whipbox.h
     CASE 6
      gs.pl.whipframe = playerclips(5).minframe + 3
      IF gs.pl.fliph = 0 THEN gs.pl.whipx = gs.pl.x + 20 ELSE gs.pl.whipx = gs.pl.x - 15
      gs.pl.whipy = gs.pl.dy + 9

      gs.pl.whipcheck = 1
      gs.pl.whipbox.x1 = gs.pl.whipx
      gs.pl.whipbox.y1 = gs.pl.whipy
      gs.pl.whipbox.x2 = gs.pl.whipx + gs.pl.whipbox.w - 7
      gs.pl.whipbox.y2 = gs.pl.whipy + gs.pl.whipbox.h' + 3
     CASE 7
      gs.pl.whipcheck = 0
      gs.pl.whipframe = playerclips(5).minframe + 4
      IF gs.pl.fliph = 0 THEN gs.pl.whipx = gs.pl.x + 20 ELSE gs.pl.whipx = gs.pl.x - 10
      gs.pl.whipy = gs.pl.dy + 9
    END SELECT
   END IF
 END IF

 gs.pl.hitbox.x1 = gs.pl.x + 9
 gs.pl.hitbox.x2 = gs.pl.x + 14
 gs.pl.hitbox.y1 = gs.pl.y + 4
 gs.pl.hitbox.y2 = gs.pl.y + 24

 IF tiles(gs.pl.ontile).interact > 0 AND upprompt.active = 0 THEN
  TmrReset upprompt.tmr, 5
  SELECT CASE tiles(gs.pl.ontile).interact
   CASE 1, 3
    upprompt.x = tiles(gs.pl.ontile).x1 + 12
   CASE 2, 4
    upprompt.x = tiles(gs.pl.ontile).x1 - 4
   CASE 5
    upprompt.x = tiles(gs.pl.ontile).x1 + 4
  END SELECT
  upprompt.y = tiles(gs.pl.ontile).y1 - 16
  upprompt.active = 1
 END IF
 'BGTileAt gs.pl.x + 11, gs.pl.y + 23, gs.pl.ontile
END SUB

SUB PlayerUpdate (gs AS GlobalState, tiles() AS Tile, voices() AS INTEGER, sounds() AS INTEGER, clearbox() AS INTEGER)
 IF gs.pl.tmrstun THEN gs.pl.tmrstun = gs.pl.tmrstun - 1: EXIT SUB
 IF gs.pl.hurting = 0 AND gs.pl.iframe THEN
  gs.pl.iframe = gs.pl.iframe - 1
  IF gs.pl.iframe MOD 2 = 1 THEN gs.pl.redraw = 0 ELSE gs.pl.redraw = 1
  IF gs.pl.iframe = 0 THEN gs.pl.redraw = 1
 END IF
 gs.pl.xdir = 0
 gs.pl.ydir = 1
 gs.pl.moving = 0
 IF gs.pl.onstair AND gs.pl.stairtarget <> 0 THEN
  IF gs.pl.stairtarget > 0 THEN
   gs.pl.moving = 1
   IF gs.pl.stairtarget < gs.pl.x THEN
    gs.pl.x = gs.pl.x - 1
   ELSEIF gs.pl.stairtarget > gs.pl.x THEN
    gs.pl.x = gs.pl.x + 1
   END IF
   IF gs.pl.stairtarget = gs.pl.x THEN gs.pl.stairtarget = -1
  ELSE
   gs.pl.x = gs.pl.x - (gs.pl.onstair * gs.pl.stairdir)
   gs.pl.y = gs.pl.y + gs.pl.stairdir
   gs.pl.stairtarget = 0
  END IF
 ELSEIF gs.pl.ducking = 0 AND gs.pl.attacking = 0 AND gs.pl.hurting = 0 AND gs.pl.throwing = 0 THEN
   IF gs.sUp AND gs.pl.onstair THEN
    gs.pl.x = gs.pl.x + gs.pl.onstair
    gs.pl.y = gs.pl.y - 1
    IF gs.pl.onstair > 0 THEN gs.pl.fliph = 0 ELSE gs.pl.fliph = 1
    gs.pl.scalex = gs.pl.onstair
    gs.pl.moving = 1
   ELSEIF gs.sDown AND gs.pl.onstair THEN
    gs.pl.x = gs.pl.x - gs.pl.onstair
    gs.pl.y = gs.pl.y + 1
    IF gs.pl.onstair < 0 THEN gs.pl.fliph = 0 ELSE gs.pl.fliph = 1
    gs.pl.scalex = -gs.pl.onstair
    gs.pl.moving = 1
  
   ELSEIF gs.sLeft THEN
    gs.pl.x = gs.pl.x - 1
    gs.pl.y = gs.pl.y + gs.pl.onstair
    gs.pl.fliph = 1
    gs.pl.scalex = -1
    gs.pl.moving = 1
   ELSEIF gs.sRight THEN
    gs.pl.x = gs.pl.x + 1
    gs.pl.y = gs.pl.y - gs.pl.onstair
    gs.pl.fliph = 0
    gs.pl.scalex = 1
    gs.pl.moving = 1
   END IF
 END IF

 IF gs.pl.hurting = 1 THEN gs.pl.x = gs.pl.x - gs.pl.scalex

 IF gs.sB0 = 2 THEN
  IF (gs.pl.jumping = 0 OR gs.pl.coyote) AND gs.pl.attacking = 0 AND gs.pl.hurting = 0 THEN
   IF gs.pl.ducking = 0 THEN
    gs.pl.yforce = gs.pl.jforce
    gs.pl.jumping = 1
    gs.pl.coyote = 0
    IF gs.pl.onstair THEN
     gs.pl.y = gs.pl.ly
     gs.pl.onstair = 0
     gs.pl.yforce = gs.pl.jforce
     IF gs.sDown THEN
      gs.pl.yforce = 0
      gs.pl.stairimmune = tiles(gs.pl.ontile).y2
     ELSE
      gs.pl.stairimmune = 1
     END IF
    END IF
   ELSE
    BGTileAt gs.pl.x + 7, gs.pl.y + 24, gs.pl.tilehit, gs
    gs.pl.hitsolid = tiles(gs.pl.tilehit).platform - tiles(gs.pl.tilehit).solid
    BGTileAt gs.pl.x + 15, gs.pl.y + 24, gs.pl.tilehit, gs
    IF gs.pl.hitsolid + tiles(gs.pl.tilehit).platform - tiles(gs.pl.tilehit).solid > 0 THEN
     gs.pl.platimmune = gs.pl.y + 4
     gs.pl.yforce = 0
     gs.pl.jumping = 1
    END IF
   END IF
  ELSEIF gs.pl.jumping = 1 AND gs.pl.hurting = 0 AND gs.gd.doublejump AND gs.pl.backflip = 0 THEN
   PlaySound 0, 22050, gs, voices(), sounds()
   gs.pl.backflip = 1
   gs.pl.attacking = 0
   gs.pl.duckattacking = 0
   gs.pl.throwing = 0
   gs.pl.duckthrowing = 0
   gs.pl.whipcheck = 0
   gs.pl.yforce = gs.pl.jforce
  END IF
 END IF

 IF gs.sB1 = 2 THEN
  IF gs.pl.attacking = 0 AND gs.pl.duckattacking = 0 AND gs.pl.hurting = 0 AND gs.pl.throwing = 0 AND gs.pl.duckthrowing = 0 THEN
   IF gs.pl.ducking OR gs.pl.jumping THEN gs.pl.duckattacking = 1 ELSE gs.pl.attacking = 1
   IF gs.gd.chainduck = 0 THEN
    PlaySound 0, 18000, gs, voices(), sounds()
   ELSE
    PlaySound 18, 18000, gs, voices(), sounds()
   END IF
   gs.pl.backflip = 0
  END IF
 END IF

 IF gs.sB2 = 2 THEN
  IF gs.pl.attacking = 0 AND gs.pl.duckattacking = 0 AND gs.pl.throwing = 0 AND gs.pl.duckthrowing = 0 AND gs.pl.hurting = 0 THEN
   IF gs.swep.active = 0 AND gs.gd.currentsubweapon > 0 AND gs.gd.hearts > 0 THEN
    IF gs.pl.ducking OR gs.pl.jumping THEN gs.pl.duckthrowing = 1 ELSE gs.pl.throwing = 1
    PlaySound 0, 18000, gs, voices(), sounds()
    gs.pl.backflip = 0
   END IF
  END IF
 END IF

 IF gs.sSelect = 2 THEN
  IF gs.gd.currentsubweapon THEN
   PlaySound 7, 22050, gs, voices(), sounds()
   SELECT CASE gs.gd.currentsubweapon
    CASE 1
     IF gs.gd.holywater = 1 THEN
      gs.gd.currentsubweapon = 2
     ELSEIF gs.gd.cross = 1 THEN
      gs.gd.currentsubweapon = 3
     ELSEIF gs.gd.axe = 1 THEN
      gs.gd.currentsubweapon = 4
     END IF
     gs.ui.pendingsubweapon = 1
    CASE 2
     IF gs.gd.cross = 1 THEN
      gs.gd.currentsubweapon = 3
     ELSEIF gs.gd.axe = 1 THEN
      gs.gd.currentsubweapon = 4
     ELSEIF gs.gd.dagger = 1 THEN
      gs.gd.currentsubweapon = 1
     END IF
     gs.ui.pendingsubweapon = 1
    CASE 3
     IF gs.gd.axe = 1 THEN
      gs.gd.currentsubweapon = 4
     ELSEIF gs.gd.dagger = 1 THEN
      gs.gd.currentsubweapon = 1
     ELSEIF gs.gd.holywater = 1 THEN
      gs.gd.currentsubweapon = 2
     END IF
     gs.ui.pendingsubweapon = 1
    CASE 4
     IF gs.gd.dagger = 1 THEN
      gs.gd.currentsubweapon = 1
     ELSEIF gs.gd.holywater = 1 THEN
      gs.gd.currentsubweapon = 2
     ELSEIF gs.gd.cross = 1 THEN
      gs.gd.currentsubweapon = 3
     END IF
     gs.ui.pendingsubweapon = 1
   END SELECT
  END IF
 END IF

 IF gs.sDown THEN
  IF gs.pl.jumping = 0 AND gs.pl.hurting = 0 AND gs.pl.onstair = 0 THEN
   BGTileAt (gs.pl.x + 11), gs.pl.y + 24, gs.pl.tilehit, gs
   IF gs.sDown AND tiles(gs.pl.tilehit).stair < -10 THEN
   
    gs.pl.stairtarget = tiles(gs.pl.tilehit).x1
    gs.pl.stairdir = 1
    gs.pl.scalex = 1
    gs.pl.fliph = 0
    gs.pl.onstair = -1
    gs.pl.ducking = 0
   ELSEIF gs.sDown = 2 AND tiles(gs.pl.tilehit).stair > 10 THEN
    gs.pl.stairtarget = tiles(gs.pl.tilehit).x1 - 5
    gs.pl.stairdir = 1
    gs.pl.scalex = -1
    gs.pl.fliph = 1
    gs.pl.onstair = 1
    gs.pl.ducking = 0
   ELSE
    gs.pl.ducking = 1
   END IF
   'debug = STR$(tiles(gs.pl.tilehit).stair)
  END IF
 ELSE
  IF gs.pl.duckattacking = 0 THEN gs.pl.ducking = 0
 END IF

 IF gs.sUp THEN
  IF gs.pl.jumping = 0 AND gs.pl.hurting = 0 AND gs.pl.onstair = 0 THEN
   BGTileAt (gs.pl.x + 11), gs.pl.y + 24, gs.pl.tilehit, gs
   IF tiles(gs.pl.tilehit).stair = -10 THEN
    gs.pl.stairtarget = tiles(gs.pl.tilehit).x1
    gs.pl.stairdir = -1
    gs.pl.scalex = -1
    gs.pl.fliph = 1
    gs.pl.onstair = -1
   ELSEIF tiles(gs.pl.tilehit).stair = 10 THEN
    gs.pl.stairtarget = tiles(gs.pl.tilehit).x1 - 5
    gs.pl.stairdir = -1
    gs.pl.scalex = 1
    gs.pl.fliph = 0
    gs.pl.onstair = 1
   END IF
   'debug = STR$(tiles(gs.pl.tilehit).x2) + STR$(gs.pl.x + 7)
  'ELSEIF gs.pl.jumping = 1 AND gs.pl.hurting = 0 AND gs.pl.onstair = 0 THEN
  ' BGTileAt (gs.pl.x + 9), gs.pl.y + 23, gs.pl.tilehit
  ' IF tiles(gs.pl.tilehit).stair = -10 AND gs.pl.y MOD 16 > 8 THEN
  '  IF (gs.pl.x + 9 - tiles(gs.pl.tilehit).x1) < 8 THEN
  '   gs.pl.x = tiles(gs.pl.tilehit).x1
  '   gs.pl.y = tiles(gs.pl.tilehit).y1 - 24
  '  ELSE
  '   gs.pl.x = tiles(gs.pl.tilehit).x1 + 8
  '   gs.pl.y = tiles(gs.pl.tilehit).y1 - 16
  '
  '  END IF
  '  gs.pl.scalex = -1
  '  gs.pl.fliph = 1
  '  gs.pl.onstair = -1
  '  gs.pl.jumping = 0
  ' ELSEIF tiles(gs.pl.tilehit).stair = 10 THEN
  '  IF (gs.pl.x + 9 - tiles(gs.pl.tilehit).x1) > 8 THEN
  '   gs.pl.x = tiles(gs.pl.tilehit).x1 - 5
  '   gs.pl.y = tiles(gs.pl.tilehit).y1 - 24
  '  ELSE
  '   gs.pl.x = tiles(gs.pl.tilehit).x1 - 13
  '   gs.pl.y = tiles(gs.pl.tilehit).y1 - 16
  '
  '  END IF
  '  gs.pl.scalex = 1
  '  gs.pl.fliph = 0
  '  gs.pl.onstair = 1
  '  gs.pl.jumping = 0
  '
  ' END IF
   'debug = STR$(tiles(gs.pl.tilehit).stair)
   IF gs.sUp = 2 THEN
    IF tiles(gs.pl.ontile).interact > 0 THEN
     SELECT CASE tiles(gs.pl.ontile).interact
      CASE 1, 2'savegame
       gs.scenechange = 2'savemenu
       gs.pl.hp = gs.pl.maxhp
       gs.ui.pendingplayerhp = 1
       PlaySound 8, 22050, gs, voices(), sounds()
      CASE 3, 4'door
       IF gs.gd.skullgrave + gs.gd.skullforest + gs.gd.skullcave = 3 THEN
	IF gs.gd.dooropen THEN
	 gs.pl.teleported = 13
	 DQBplaySound 11, 1, 15000, ONCE
	ELSE
	 OpenDoor gs, clearbox()
	 gs.gd.dooropen = 1
	 gs.ss = 1
	 PlaySound 16, 22050, gs, voices(), sounds()
	END IF
       ELSE
	gs.scenechange = 4'scenechange
	gs.item.id = 10'locked door
	PlaySound 15, 22050, gs, voices(), sounds()
       END IF
      CASE 5
       IF gs.gd.chainduck = 0 THEN
	gs.item.id = 13
	gs.gd.chainduck = 2
	'gs.gd.chainruins = 1
	'gs.gd.chaingrave = 1
	'gs.gd.chainforest = 1
	'gs.gd.chaincave = 1
	'gs.pl.chains = gs.gd.chaingrave + gs.gd.chainruins + gs.gd.chainforest + gs.gd.chaincave
	gs.ui.pendingwhip = 1
	PlaySound 17, 22050, gs, voices(), sounds()
       ELSE
	gs.item.id = 14
	PlaySound 15, 22050, gs, voices(), sounds()
       END IF
       gs.scenechange = 4'item desc scene
     END SELECT
    END IF
   END IF
  END IF
 END IF

 IF gs.pl.jumping = 1 THEN
   IF gs.pl.y > gs.pl.platimmune THEN gs.pl.platimmune = 0
   IF gs.pl.coyote > 0 THEN gs.pl.coyote = gs.pl.coyote - 1
   gs.pl.suby = gs.pl.suby - gs.pl.yforce
   gs.pl.yforce = gs.pl.yforce - gs.pl.gravity
   IF gs.pl.yforce < -gs.pl.jforce THEN gs.pl.yforce = -gs.pl.jforce
   WHILE gs.pl.suby > 60
    gs.pl.suby = gs.pl.suby - 60
    gs.pl.y = gs.pl.y + 1
   WEND
   WHILE gs.pl.suby < 0
    gs.pl.suby = gs.pl.suby + 60
    gs.pl.y = gs.pl.y - 1
   WEND
 END IF


 
 
 IF gs.sStart = 2 THEN
  IF gs.scenechange <= 0 THEN
   gs.scenechange = 1
   PlaySound 8, 22050, gs, voices(), sounds()
  END IF
 END IF
 'debug = STR$(playerframes(gs.pl.drawframe).imgnum)

 
END SUB