TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

TYPE Tile
 id AS INTEGER
 solid AS INTEGER
 breakable AS INTEGER
 deadly AS INTEGER
 teleport AS INTEGER
 stair AS INTEGER
 platform AS INTEGER
 interact AS INTEGER
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 obj AS INTEGER
END TYPE

TYPE AniFrame
 offset AS INTEGER
 x AS INTEGER
 y AS INTEGER
 w AS INTEGER
 h AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE SubWeapon
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 index AS INTEGER
 dmg AS INTEGER
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 hitbox AS Rect
 check AS INTEGER
 tmr AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 redraw AS INTEGER
 noclear AS INTEGER
 ani AS Animator
 fliph AS INTEGER
 scalex AS INTEGER
 ontile AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 yforce AS INTEGER
 tilehit AS INTEGER
 speed AS INTEGER
 pswapclip AS INTEGER
 pcliploop AS INTEGER
 ptmrreset AS INTEGER
 pplayerhit AS INTEGER
 ptileat AS INTEGER
 psolidcheck AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub AS INTEGER
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing AS INTEGER
 duckthrowing AS INTEGER
 backflip AS INTEGER
 platformcheck AS INTEGER
END TYPE

TYPE ItemDescType
 active AS INTEGER
 shifting AS INTEGER
 id AS INTEGER
 tmr AS TTmr
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull AS INTEGER
 pendingpower AS INTEGER
 pendinggem AS INTEGER
 pendingwhip AS INTEGER
END TYPE

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns AS INTEGER
 spawnid AS INTEGER
 westspawny AS INTEGER
 eastspawny AS INTEGER
END TYPE

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

DECLARE SUB TmrReset (tmr AS TTmr, delay AS INTEGER)
DECLARE SUB AniSwapClip (ani AS Animator, clip AS AniClip, looping AS INTEGER, drawframe AS INTEGER)
DECLARE SUB AnimatorUpdate (ani AS Animator, drawframe AS INTEGER)
DECLARE FUNCTION RectHit% (r1 AS Rect, r2 AS Rect)
DECLARE SUB BGCollisionS (xval AS INTEGER, yval AS INTEGER, offset AS INTEGER, lasty AS INTEGER, platimmune AS INTEGER, tilehit AS INTEGER, gs AS GlobalState, t() AS Tile)
DECLARE SUB BGTileAt (xval AS INTEGER, yval AS INTEGER, tilehit AS INTEGER, gs AS GlobalState)
DECLARE SUB PlaySound (s AS INTEGER, lf AS INTEGER, gs AS GlobalState, voices() AS INTEGER, sounds() AS INTEGER)

SUB SubWepAxe (wep AS SubWeapon, pl AS PlayerType)
 wep.x = wep.x + wep.speed * wep.scalex
 wep.suby = wep.suby - wep.yforce
 wep.yforce = wep.yforce - pl.gravity
 IF wep.yforce < -pl.jforce THEN wep.yforce = -pl.jforce
 WHILE wep.suby > 60
  wep.suby = wep.suby - 60
  wep.y = wep.y + 1
 WEND
 WHILE wep.suby < 0
  wep.suby = wep.suby + 60
  wep.y = wep.y - 1
 WEND
 AnimatorUpdate wep.ani, wep.drawframe
 IF wep.x >= 320 OR wep.x <= -16 OR wep.y > 168 THEN wep.pendinginactive = 1
 wep.dx = wep.x
 wep.dy = wep.y
 'SELECT CASE playerframes(wep.drawframe).imgnum
 'END SELECT
END SUB

SUB SubWepCross (wep AS SubWeapon, pl AS PlayerType)
 wep.subx = wep.subx + (wep.speed * wep.scalex)
 WHILE wep.subx >= 60
  wep.x = wep.x + 1
  wep.subx = wep.subx - 60
 WEND
 WHILE wep.subx < 0
  wep.x = wep.x - 1
  wep.subx = wep.subx + 60
 WEND
 IF wep.tmr.frame = 0 THEN
  IF wep.scalex > 0 THEN
   IF wep.x > 260 THEN
    wep.speed = (319 - wep.x) * 3
   ELSE
    wep.speed = 180
   END IF
   IF wep.x >= 304 THEN wep.tmr.frame = 1: wep.scalex = wep.scalex * -1: wep.check = 0: wep.x = 304
  ELSE
   IF wep.x + 15 < 60 THEN
    wep.speed = (wep.x + 15) * 3
   ELSE
    wep.speed = 180
   END IF
   IF wep.x <= 0 THEN wep.tmr.frame = 1: wep.scalex = wep.scalex * -1: wep.check = 0: wep.x = 0
  END IF
 ELSEIF wep.tmr.frame = 1 THEN
  wep.check = 1
  wep.tmr.frame = 2
 ELSE
  IF wep.scalex < 0 THEN
   IF wep.x > 260 THEN
    wep.speed = (319 - wep.x) * 3
   END IF
   IF wep.x < -15 THEN wep.pendinginactive = 1
  ELSE
   IF wep.x + 15 < 60 THEN
    wep.speed = (wep.x + 15) * 3
   END IF
   IF wep.x > 319 THEN wep.pendinginactive = 1
  END IF
  IF RectHit(wep.hitbox, pl.hitbox) THEN wep.pendinginactive = 1
  'wep.pplayerhit = 1
 END IF
 AnimatorUpdate wep.ani, wep.drawframe
 wep.dx = wep.x
 wep.dy = wep.y
 wep.redraw = 1
END SUB

SUB SubWepDagger (wep AS SubWeapon)
 wep.x = wep.x + 4 * wep.scalex
 IF wep.x >= 320 OR wep.x <= -16 THEN wep.pendinginactive = 1
 wep.dx = wep.x
 wep.dy = wep.y
END SUB

SUB SubWepHolyWater (wep AS SubWeapon, pc() AS AniClip, pf() AS AniFrame, gs AS GlobalState, t() AS Tile, voices() as integer, sounds() as integer)
 SELECT CASE wep.tmr.frame
  CASE 0
   wep.x = wep.x + 2 * wep.scalex
   wep.suby = wep.suby - wep.yforce
   wep.yforce = wep.yforce - gs.pl.gravity
   IF wep.yforce < -gs.pl.jforce THEN wep.yforce = -gs.pl.jforce
   WHILE wep.suby > 60
    wep.suby = wep.suby - 60
    wep.y = wep.y + 1
   WEND
   WHILE wep.suby < 0
    wep.suby = wep.suby + 60
    wep.y = wep.y - 1
   WEND
   BGTileAt wep.x + 5, wep.y + wep.hitbox.h, wep.tilehit, gs
   'wep.ptileat=1
   'wep.psolidcheck=1
   'BGCollisionS wep.x + 5, wep.y, wep.hitbox.h, 0, 0, wep.tilehit, gs, t()
   IF t(wep.tilehit).solid > 0 or t(wep.tilehit).platform=1 THEN
    IF ABS((wep.y + 10) - t(wep.tilehit).y1) < 8 THEN wep.y = t(wep.tilehit).y1 - 10
    wep.dy = wep.y
    wep.tmr.frame = 1
    AniSwapClip wep.ani, pc(10), 1, wep.drawframe
    wep.scalex = 1
    wep.fliph = 0
	PlaySound 21,22050,gs,voices(),sounds()
   END IF
  CASE 1
   AnimatorUpdate wep.ani, wep.drawframe
   wep.tmr.tmr = wep.tmr.tmr + 1
   IF wep.clearframe = wep.drawframe THEN wep.noclear = 1
   IF wep.tmr.tmr >= 70 THEN wep.pendinginactive = 1
 END SELECT
 IF wep.x >= 320 OR wep.x <= -16 OR wep.y > 168 THEN wep.pendinginactive = 1
 wep.dx = wep.x
 wep.dy = wep.y
 SELECT CASE pf(wep.drawframe).imgnum
  CASE 18
   wep.dy = wep.y + 2
   wep.check = 0
  CASE 19
   wep.dy = wep.y + 1
   wep.dx = wep.x + 1
   wep.check = 1
  CASE 20
   wep.dy = wep.y + 1
   wep.dx = wep.x + 3
   wep.check = 0
  CASE 21
   wep.dy = wep.y + 1
   wep.dx = wep.x + 2
   wep.check = 1
 END SELECT

END SUB

SUB SubWepSpawn (wep AS SubWeapon, id AS INTEGER, x AS INTEGER, y AS INTEGER, xdir AS INTEGER, pc() AS AniClip, gs AS GlobalState)
 IF wep.active = 0 THEN
  wep.active = 1
  wep.pendinginactive = 0
  wep.redraw = 1
  wep.id = id
  wep.scalex = xdir
  wep.pplayerhit = -1
  wep.ptmrreset = -1
  wep.psolidcheck = 0
  wep.dmg = 1
  IF xdir > 0 THEN wep.fliph = 0 ELSE wep.fliph = 1
  SELECT CASE id
   CASE 1 'dagger
    AniSwapClip wep.ani, pc(8), 0, wep.drawframe
    'wep.pswapclip = 8
    'wep.pcliploop = 0
    wep.hitbox.w = 16
    wep.hitbox.h = 8
   CASE 2 'holywater
    AniSwapClip wep.ani, pc(9), 0, wep.drawframe
    'wep.pswapclip = 9
    'wep.pcliploop = 0
    wep.hitbox.w = 10
    wep.hitbox.h = 10
    wep.yforce = 100
    TmrReset wep.tmr, 0
    wep.ptmrreset = 0
   CASE 3 'cross
    AniSwapClip wep.ani, pc(11), 1, wep.drawframe
    'wep.pswapclip = 11
    'wep.pcliploop = 1
    wep.hitbox.w = 15
    wep.hitbox.h = 15
    wep.speed = 180
    y = y - 6
    IF x > 304 THEN
     x = 304
    ELSEIF x < 0 THEN
     x = 0
    END IF
    TmrReset wep.tmr, 0
    wep.ptmrreset = 0
   CASE 4 'axe
    AniSwapClip wep.ani, pc(12), 1, wep.drawframe
    'wep.pswapclip = 12
    'wep.pcliploop = 1
    wep.hitbox.w = 14
    wep.hitbox.h = 14
    wep.yforce = 350
    wep.speed = 2
    IF gs.sDown > 0 THEN wep.yforce = 200: wep.speed = 3
  END SELECT
  wep.clearframe = wep.drawframe
  wep.x = x
  IF wep.fliph = 1 THEN wep.x = wep.x - wep.hitbox.w
  wep.hitbox.x1 = wep.x
  wep.hitbox.x2 = wep.x + wep.hitbox.w
  wep.hitbox.y1 = y
  wep.hitbox.y2 = y + wep.hitbox.h
  wep.y = y
  wep.dx = wep.x
  wep.dy = y
  wep.lastx = wep.x
  wep.lasty = y
  wep.check = 1
  BGTileAt wep.x + (wep.hitbox.w \ 2), wep.y + (wep.hitbox.h \ 2), wep.ontile, gs
  'wep.ptileat = 1
 END IF
END SUB

