TYPE Rect
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 w AS INTEGER
 h AS INTEGER
END TYPE

TYPE TTmr
 tmr AS INTEGER
 delay AS INTEGER
 frame AS INTEGER
END TYPE

TYPE Tile
 id AS INTEGER
 solid AS INTEGER
 breakable AS INTEGER
 deadly AS INTEGER
 teleport AS INTEGER
 stair AS INTEGER
 platform AS INTEGER
 interact as integer
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 obj AS INTEGER
END TYPE

TYPE Object
 id AS INTEGER
 enemy AS INTEGER
 x AS INTEGER
 y AS INTEGER
 odata AS STRING * 8
END TYPE

Type MapEMSLoc
 mdoffset as long
 tdoffset as long
 odoffset as long
end type

TYPE MapData
 id AS INTEGER
 activeSwaps AS STRING * 8
 landing AS INTEGER
 exitn AS INTEGER
 exite AS INTEGER
 exits AS INTEGER
 exitw AS INTEGER
 solidn AS INTEGER
 solide AS INTEGER
 solids AS INTEGER
 solidw AS INTEGER
 objectsize AS INTEGER
 autospawns as integer
 spawnid as integer
 westspawny as integer
 eastspawny as integer
END TYPE

TYPE AniData
 framesize AS INTEGER
 clipsize AS INTEGER
 gfxsize AS INTEGER
 gfxlowoffset as integer
 gfxhighbytes as integer
END TYPE

TYPE AniFrame
 offset AS integer
 x AS INTEGER
 y AS INTEGER
 w AS INTEGER
 h AS INTEGER
 imgnum AS INTEGER
END TYPE

TYPE AniClip
 minframe AS INTEGER
 maxframe AS INTEGER
 delay AS INTEGER
 repeat AS INTEGER
 id AS INTEGER
END TYPE

TYPE Animator
 clip AS AniClip
 tmr AS INTEGER
 trigger AS INTEGER
 frame AS INTEGER
 subframe AS INTEGER
 looping AS INTEGER
 playing AS INTEGER
 repeat AS INTEGER
END TYPE

TYPE BGObject
 active AS INTEGER
 id AS INTEGER
 index AS INTEGER
 hitbox AS Rect
 ontouch AS INTEGER
 onhit AS INTEGER
 ontile AS INTEGER
 odata as integer
END TYPE

TYPE EnemyType
 active AS INTEGER
 pendinginactive AS INTEGER
 id AS INTEGER
 edata AS STRING * 8
 x AS INTEGER
 y AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lastscalex as integer
 dx AS INTEGER
 dy AS INTEGER
 dxo AS INTEGER
 dyo AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 speed AS INTEGER
 yforce AS INTEGER
 fliph AS INTEGER
 tmrstun AS INTEGER
 maxstun AS INTEGER
 ani AS Animator
 hitbox AS Rect
 hurtbox as Rect
 autohurtbox as integer
 autohitbox as integer
 bossmode as integer
 maxhp as integer
 hp AS INTEGER
 tmr0 AS TTmr
 tmr1 AS TTmr
 tmr2 AS TTmr
 tmr3 AS TTmr
 tmr4 AS TTmr
 drawframe AS INTEGER
 clearframe AS INTEGER
 noclear as integer
 immortal AS INTEGER
 immaterial AS INTEGER
 index AS INTEGER
 scalex AS INTEGER
 tilehit AS INTEGER
 solidhit as integer
 redraw AS INTEGER
 dmg AS INTEGER
 immunewhip AS INTEGER
 immunesub0 as integer
 immunesub1 as integer
 immunesub2 as integer
 pickup as integer
 grounded as integer
 struck as integer
 autospawned as integer
 pstruck as integer
 pstruckx as integer
END TYPE

TYPE PlayerType
 x AS INTEGER
 y AS INTEGER
 dx AS INTEGER
 dy AS INTEGER
 xdir AS INTEGER
 ydir AS INTEGER
 speed AS INTEGER
 subx AS INTEGER
 suby AS INTEGER
 lastx AS INTEGER
 lasty AS INTEGER
 lx AS INTEGER
 ly AS INTEGER
 lastflip AS INTEGER
 h AS INTEGER
 halfw AS INTEGER
 drawframe AS INTEGER
 clearframe AS INTEGER
 pendingani AS INTEGER
 redraw AS INTEGER
 fliph AS INTEGER
 scalex AS INTEGER
 ani AS Animator
 jumping AS INTEGER
 attacking AS INTEGER
 duckattacking AS INTEGER
 moving AS INTEGER
 ducking AS INTEGER
 hurting AS INTEGER
 yforce AS INTEGER
 jforce AS INTEGER
 gravity AS INTEGER
 pendingloop AS INTEGER
 tilehit AS INTEGER
 hitsolid AS INTEGER
 coyote AS INTEGER
 hitbox AS Rect
 whipbox AS Rect
 whipframe AS INTEGER
 whiplastframe AS INTEGER
 whipx AS INTEGER
 whipy AS INTEGER
 whiplx AS INTEGER
 whiply AS INTEGER
 iframe AS INTEGER
 whipcheck AS INTEGER
 currentsub as integer
 tmrstun AS INTEGER
 hp AS INTEGER
 maxhp AS INTEGER
 chains AS INTEGER
 teleported AS INTEGER
 onstair AS INTEGER
 platimmune AS INTEGER
 stairimmune AS INTEGER
 stairtarget AS INTEGER
 stairdir AS INTEGER
 ontile AS INTEGER
 throwing as integer
 duckthrowing as integer
 backflip as integer
 platformcheck as integer
END TYPE

type SubWeapon
 active as integer
 pendinginactive as integer
 id as integer
 index as integer
 dmg as integer
 x as integer
 y as integer
 dx as integer
 dy as integer
 lastx as integer
 lasty as integer
 hitbox as Rect
 check as integer
 tmr as TTmr
 drawframe as integer
 clearframe as integer
 redraw as integer
 noclear as integer
 ani as Animator
 fliph as integer
 scalex as integer
 ontile as integer
 subx as integer
 suby as integer
 yforce as integer
 tilehit as integer
 speed as integer
 pswapclip as integer
 pcliploop as integer
 ptmrreset as integer
 pplayerhit as integer
 ptileat as integer
 psolidcheck as integer
 imgnum as integer
end type

TYPE GameDataType
 chainruins AS INTEGER
 chainforest AS INTEGER
 chaincave AS INTEGER
 chaingrave AS INTEGER
 gemruins AS INTEGER
 gemgrave AS INTEGER
 gemcave AS INTEGER
 gemforest AS INTEGER
 hearts AS INTEGER
 dagger AS INTEGER
 axe AS INTEGER
 holywater AS INTEGER
 cross AS INTEGER
 doublejump AS INTEGER
 waterwalk AS INTEGER
 brickbreak AS INTEGER
 skullgrave as integer
 skullforest as integer
 skullcave as integer
 savegrave0 AS INTEGER
 savegrave1 as integer
 saveforest0 AS INTEGER
 saveforest1 as integer
 savecave0 AS INTEGER
 savecave1 as integer
 currentsubweapon AS INTEGER
 currentmap as integer
 savemap as integer
 gyduck as integer
 dooropen as integer
 chainduck as integer
END TYPE

TYPE UIType
 pendingsubweapon AS INTEGER
 lastsubweapon AS INTEGER
 pendinghearts AS INTEGER
 pendingplayerhp AS INTEGER
 pendingenemyhp AS INTEGER
 pendingskull as integer
 pendingpower as integer
 pendinggem as integer
 pendingwhip as integer
END TYPE

Type UpPromptType
 active as integer
 pendinginactive as integer
 x as integer
 lastx as integer
 y as integer
 lasty as integer
 tmr as TTmr
end type

Type SaveMenuType
 active as integer
 shifting as integer
 xpos as integer
 tmr as TTmr
end type

Type ItemDescType
 active as integer
 shifting as integer
 id as integer
 tmr as TTmr
end type

Type EnemyDataLoc
 frameoffset as long
 framebytes as integer
 clipoffset as long
 clipbytes as integer
 gfxoffset as long
 gfxroffset as long
 gfxbytes as long
end type

Type PalSwapType
 water AS INTEGER
 candle AS INTEGER
 fallingwater AS INTEGER
 grass AS INTEGER
 pipe AS INTEGER
 hanginggrass AS INTEGER
 angel as integer
 skull as integer
 livinggrass as integer
end type

Type GamePrefs
 drawlayer as integer
 kup as integer
 kdown as integer
 kleft as integer
 kright as integer
 kb0 as integer
 kb1 as integer
 kb2 as integer
 kstart as integer
 kselect as integer
 sfx as integer
 mfx as integer
 loaded as integer
end type

TYPE GlobalState
 pl AS PlayerType
 swep AS SubWeapon
 ui AS UIType
 item as ItemDescType
 emax AS INTEGER
 omax AS INTEGER
 enemyhp AS INTEGER
 enemymaxhp AS INTEGER
 scenechange AS INTEGER
 md AS MapData
 gd AS GameDataType
 ss as integer
 tmrdeath as TTmr
 gp as GamePrefs
 sLeft as integer
 sRight as integer
 sUp as integer
 sDown as integer
 sB0 as integer
 sB1 as integer
 sB2 as integer
 sSelect as integer
 sStart as integer
 cVoice as integer
 tVoices as integer
END TYPE

type TitleMenuType
 y as integer
 ly as integer
 tmr as TTmr
 shifting as integer
 changescene as integer
 pal as integer
end type

'midi related
TYPE Registers
	 AX    AS INTEGER
	 BX    AS INTEGER
	 CX    AS INTEGER
	 DX    AS INTEGER
	 BP    AS INTEGER
	 SI    AS INTEGER
	 DI    AS INTEGER
	 FLAGS AS INTEGER
	 DS    AS INTEGER
	 ES    AS INTEGER
END TYPE

TYPE MIDIDATA
 MIDIPLAYTIME AS SINGLE
 MIDIError AS INTEGER
 PAUSED AS SINGLE
 SBMIDIINTERRUPT AS INTEGER
 SBSIMINTERRUPT AS INTEGER
 MixerChip AS INTEGER
 SBBASEPORT AS INTEGER
 SBIRQ AS INTEGER
 SBLODMA AS INTEGER
 SBHIDMA AS INTEGER
 SBCARDTYPE AS INTEGER
 SBMPU401 AS INTEGER
 SENSITIVE AS INTEGER
 REVERSESTEREO AS INTEGER
 SOUNDDISABLED AS INTEGER
 CURRENTHANDLE AS INTEGER
END TYPE
